import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.urls import reverse

from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated, DjangoModelPermissions
from utils.mixins import PlatformAPICallMixin
from utils.api_handle_errors import handle_errors
from admin_app.serializers import *
from professionals.serializers import *
from professionals.models import *
from reviews.serializers import ReviewGETSerializer
from reviews.models import Review
from utils.decorator import check_permission
from commonAPI.serializers import ContactPersonSerializer
from commonAPI.models import Contact_Person
from advertisers.models import *
from advertisers.serializers import *


# Create Profile Advertiser

class AdminCreateProfileAdvertiserPOSTProfileAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCreateProfileAdvertiserPOSTSerializers
    dailySerializer_class = AdvertiserDailyAvailibilitySerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []
        #user = request.user
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            data = serializers.save()
            responsedata.append("Successfully Inserted")
            response["result"] = 1
            response['data'] = responsedata
            response['ID'] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
