import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.urls import reverse

from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated
from utils.mixins import *
from utils.api_handle_errors import handle_errors
from utils.mixins import *
from utils.api_handle_errors import handle_errors

from admin_app.serializers import *

from venue_owners.models import *
from venue_owners.serializers import *
from venues.models import *
from venues.serializers import *
from players.models import BookMatch
from commonAPI.models import *
from commonAPI.serializers import OnBoardAPIGETSerializer, OnBoardAPIPOSTSerializer
from django.db.models import Q, Avg
from reviews.models import Review, VenueReviewAndRating
from reviews.serializers import ReviewGETSerializer
from commonAPI.models import Contact_Person
from utils.mail import send_emal_onboard_accept, send_mail_registeration, field_approval_email, \
    in_progress_email_verification, onboard_Complete_mail, onboard_delete_or_declined_mail
from commonAPI.serializers import ContactPersonSerializer, BankInfoProfileSerializer
from field_booking.settings import DOMAIN_NAME
from platform_central.models import RegisterPrivateKey
from message.serializers import *
from message.models import *
from advertisers.models import *
from static_data.models import *
from static_data.serializers import *
from message.serializers import *
from campaigns.serializers import *
from campaigns.models import *
from professionals.models import *
from task.models import Task
from decimal import *
import requests


class AdminCampaignPart1GETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    GET Campaign1 value
    '''
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart1SerializerGET

    def post(self, request, format=None):
        '''
        Campaign Part1 Profile GET
        '''
        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data, context={
                                            "venueowner_id": request.data['venueowner_id']})
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                OwnerInfo = CampaignPart1.objects.filter(
                    id=serializers.validated_data['id'], is_deleted=False)
            else:
                OwnerInfo = CampaignPart1.objects.filter(
                    created_by=v_owner.user, is_deleted=False)
        else:
            response['result'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializer = self.serializer_class(OwnerInfo, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart1POSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart1POSTSerializer
    # Get Campaign Part1

    # Add Campaign Part1
    def post(self, request, format=None):
        '''
        Campaign Part1 Profile Update/Create
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        request.data._mutable = True
        request.data['created_by'] = v_owner.user.id
        if 'id' in request.data:
            if CampaignPart1.objects.filter(id=request.data['id'], created_by=v_owner.user, is_deleted=False).exists():
                serializers = self.serializer_class(instance=CampaignPart1.objects.filter(
                    id=request.data['id'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
                message = "Successfully Updated"
            else:
                responsedata.append("No Such Record to update")
                response['result'] = 0
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'

        if serializers.is_valid():
            if 'id' in request.data:
                # Calculate number of days between Start date and end date
                campaign_part1_obj = CampaignPart1.objects.filter(
                    id=request.data['id'], is_deleted=False).first()
                difference_days = campaign_part1_obj.end_date - campaign_part1_obj.start_date

                serializers.validated_data['completed'] = True
                # Get New End Date
                serializers.validated_data['end_date'] = serializers.validated_data['start_date'] + \
                    datetime.timedelta(days=difference_days.days)

            # check for date
            # if serializers.validated_data['start_date'] > serializers.validated_data['end_date']:
            #     responsedata.append("Incorrect Dates")
            #     response['result'] = 0
            #     response['errors'] = responsedata
            #     self.add_api_call(request, response)
            #     return Response(response, status=status.HTTP_200_OK)

            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminCampaignPart2GETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart2SerializerGET
    # Get Campaign Part1

    def post(self, request, format=None):
        '''
        Campaign Part2 Profile GET
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data, context={
                                            "venueowner_id": request.data['venueowner_id']})
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                data = CampaignPart2.objects.filter(
                    id=serializers.validated_data['id'], is_deleted=False)
            elif 'campaign1' in serializers.validated_data:
                data = CampaignPart2.objects.filter(
                    campaign1=serializers.validated_data['campaign1'], created_by=v_owner.user, is_deleted=False)

            else:
                data = CampaignPart2.objects.filter(
                    created_by=v_owner.user, is_deleted=False)
        else:
            response['result'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart2POSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart2POSTSerializer

    # Add Campaign Part2
    def post(self, request, format=None):
        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        request.data._mutable = True
        request.data['created_by'] = v_owner.user.id
        if 'id' in request.data:
            if CampaignPart2.objects.filter(id=request.data['id'], created_by=v_owner.user, is_deleted=False).exists():
                serializers = self.serializer_class(instance=CampaignPart2.objects.filter(
                    id=request.data['id'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
                message = "Successfully Updated"
            else:
                response["result"] = 0
                responsedata.append("No Such Record to update")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'
        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminGetPlayerListAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminGetPlayerListSerializer

    def post(self, request, format=None):
        response = {}
        vobj = VenueOwner.objects.get(id=request.data['venueowner_id'])

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            # Get players list
            serializers.validated_data.pop('venueowner_id')
            serializers.validated_data['user'] = vobj.user.id

            player_object = Player.objects.filter(
                **serializers.validated_data, is_deleted=False)
            player_class = self.serializer_class(player_object, many=True)
            response["result"] = 1
            response['data'] = player_class.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart3GETEmailAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart3GETEmailSerializer
    # Get Campaign Part33

    def post(self, request, format=None):
        '''
        Campaign Part3 Email GET
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data, context={
                                            "venueowner_id": request.data['venueowner_id']})
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                data = CampaignPart3.objects.filter(
                    id=serializers.validated_data['id'], is_deleted=False)
            elif 'campaign1' in serializers.validated_data:
                data = CampaignPart3.objects.filter(
                    campaign1=serializers.validated_data['campaign1'], created_by=v_owner.user, is_deleted=False)
            else:
                data = CampaignPart3.objects.filter(
                    created_by=v_owner.user, is_deleted=False)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart3POSTEmailAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart3POSTEmailSerializer

    # Add Campaign Part3
    def post(self, request, format=None):

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        request.data._mutable = True
        request.data['created_by'] = v_owner.user.id
        if 'id' in request.data:

            if CampaignPart3.objects.filter(id=request.data['id'], created_by=v_owner.user, is_deleted=False).exists():
                serializers = self.serializer_class(instance=CampaignPart3.objects.filter(
                    id=request.data['id'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
                message = "Successfully Updated"
            else:
                response["result"] = 0
                responsedata.append("No Such Record to update")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

        elif CampaignPart3.objects.filter(campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).exists():
            serializers = self.serializer_class(instance=CampaignPart3.objects.filter(
                campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'
        if serializers.is_valid():
            save_data = serializers.save()
            # set task
            campaign1 = save_data.campaign1
            Task.objects.create(name=campaign1.name, command="campaign_mail", argument_list=campaign1.id,
                                task_type="Campaign Mail", scheduled_time=campaign1.start_date)
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart3GETSMSAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart3GETSmsSerializer
    # Get Campaign Part33

    def post(self, request, format=None):
        '''
        Campaign Part3 SMS GET
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data, context={
                                            "venueowner_id": request.data['venueowner_id']})
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                data = CampaignPart3.objects.filter(
                    id=serializers.validated_data['id'], is_deleted=False)
            elif 'campaign1' in serializers.validated_data:
                data = CampaignPart3.objects.filter(
                    campaign1=serializers.validated_data['campaign1'], created_by=v_owner.user, is_deleted=False)
            else:
                data = CampaignPart3.objects.filter(
                    created_by=v_owner.user, is_deleted=False)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart3POSTSMSAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart3POSTSmsSerializer
    # ADD / update SMS

    def post(self, request, format=None):
        '''
        Campaign Part3 ADD / update SMS
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        request.data._mutable = True
        request.data['created_by'] = v_owner.user.id
        if 'id' in request.data:
            if CampaignPart3.objects.filter(id=request.data['id'], created_by=v_owner.user, is_deleted=False).exists():
                serializers = self.serializer_class(instance=CampaignPart3.objects.filter(
                    id=request.data['id'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
                message = "Successfully Updated"
            else:
                response["result"] = 0
                responsedata.append("No Such Record to update")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

        elif CampaignPart3.objects.filter(campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).exists():
            serializers = self.serializer_class(instance=CampaignPart3.objects.filter(
                campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'
        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart3GETBannerAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart3BannerGETSerializer
    # Get Campaign Part33

    def post(self, request, format=None):
        '''
        Campaign Part3 Banner GET
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data, context={
                                            "venueowner_id": request.data['venueowner_id']})
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                data = CampaignPart3.objects.filter(
                    id=serializers.validated_data['id'], is_deleted=False)
            elif 'campaign1' in serializers.validated_data:
                data = CampaignPart3.objects.filter(
                    campaign1=serializers.validated_data['campaign1'], created_by=v_owner.user, is_deleted=False)
            else:
                data = CampaignPart3.objects.filter(
                    created_by=v_owner.user, is_deleted=False)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart3POSTBannerAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart3BannerPOSTSerializer
    # Get Campaign Part3

    def post(self, request, format=None):
        '''
        Banner Add/Edit
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        request.data._mutable = True
        request.data['created_by'] = v_owner.user.id
        if 'id' in request.data:
            if CampaignPart3.objects.filter(id=request.data['id'], created_by=v_owner.user, is_deleted=False).exists():
                serializers = self.serializer_class(instance=CampaignPart3.objects.filter(
                    id=request.data['id'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
                message = "Successfully Updated"
            else:
                response["result"] = 0
                responsedata.append("No Such Record to update")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

        elif CampaignPart3.objects.filter(campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).exists():
            serializers = self.serializer_class(instance=CampaignPart3.objects.filter(
                campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'
        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart4GETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart4GETSerializer
    # Get Campaign Part 4

    def post(self, request, format=None):
        '''
        Campaign Part4 GET
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                data = CampaignPart4.objects.filter(
                    id=serializers.validated_data['id'], created_by=v_owner.user, is_deleted=False)
            elif 'campaign1' in serializers.validated_data:
                data = CampaignPart4.objects.filter(
                    campaign1=serializers.validated_data['campaign1'], created_by=v_owner.user, is_deleted=False)
            else:
                data = CampaignPart4.objects.filter(
                    created_by=v_owner.user, is_deleted=False)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminCampaignPart4POSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignPart4POSTSerializer

    # Add Campaign Part4
    def post(self, request, format=None):
        '''
        Add Update Campaign Part4
        '''

        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        request.data._mutable = True
        request.data['created_by'] = v_owner.user.id
        if 'id' in request.data:
            if CampaignPart4.objects.filter(id=request.data['id'], created_by=v_owner.user, is_deleted=False).exists():
                serializers = self.serializer_class(instance=CampaignPart4.objects.filter(
                    id=request.data['id'], created_by=v_owner.user, is_deleted=False).first(), data=request.data)
                message = "Successfully Updated"
            else:
                response["result"] = 0
                responsedata.append("No Such Record to update")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

        elif CampaignPart4.objects.filter(campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False).exists():
            # serializers = self.serializer_class(instance=CampaignPart4.objects.filter(
            #     campaign1=request.data['part1ID'], is_deleted=False).first(), data=request.data)
            campaign_obj = CampaignPart4.objects.get(
                campaign1=request.data['part1ID'], created_by=v_owner.user, is_deleted=False)
            campaign_obj.delete()
            campaign_Notification_obj = CampaignNotificationTime.objects.filter(
                campaign1=request.data['part1ID'])
            campaign_Notification_obj.delete()
            # campaign_obj.save()
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'
        if serializers.is_valid():
            save_data = serializers.save()
            campaign1 = save_data.campaign1
            print(campaign1)
            if campaign1.banner == True:
                campaign1.completed = True
                campaign1.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminCampaignSummaryAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignSummarySerializer

    notification_serializer_class = CampaignNotificationSummarySerializer
    sms_email_serializer_class = CampaignPart3SmsANDEmailSerializer
    discount_serializer_class = AdminCampaignPart4DiscountSerializer
    recipient_serializer_class = AdminCampaignPart2RecipientSerializer
    #date_serializer_class = CampaignDateSummarySerializer
    #time_serializer_class = CampaignTimeSummarySerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            # Check if campign exists
            if CampaignPart1.objects.filter(id=serializers.validated_data['id'].id, created_by=v_owner.user).exists():
                campaign1_obj = serializers.validated_data['id']
                #campaign_class = CampaignSummarySerializer(campaign1_obj)
                campaign2_obj = CampaignPart2.objects.filter(
                    campaign1=campaign1_obj, is_deleted=False)
                campaign3_sms_email_obj = CampaignPart3.objects.filter(
                    campaign1=campaign1_obj, is_deleted=False)
                campaign4_obj = CampaignPart4.objects.filter(
                    campaign1=campaign1_obj, is_deleted=False)
                campaign_notification_obj = CampaignNotificationTime.objects.filter(
                    campaign1=campaign1_obj)

            else:
                response["result"] = 0
                responsedata.append("No Such Record to found")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            # Campaign Type
            campaign_type = ""

            if campaign1_obj.email == True:
                campaign_type = campaign_type + "Email "
            if campaign1_obj.sms == True:
                campaign_type = campaign_type + "SMS "
            if campaign1_obj.banner == True:
                campaign_type = campaign_type + "Banner "
            if campaign1_obj.paid_ads == True:
                campaign_type = campaign_type + "Paid_ads "

            campaign_type = campaign_type.strip()
            campaign_type = campaign_type.replace(" ", '-')

            # Get Duration
            if campaign1_obj.end_date == None or campaign1_obj.start_date == None:
                duration = 0
            else:
                duration = campaign1_obj.end_date - campaign1_obj.start_date
                duration = duration.days

            # Data Consolidation
            # sports_data = ""
            # if campaign1_obj.sport is not None:
            #     sports_data = campaign1_obj.sport.name

            field_data = ""
            if campaign1_obj.field is not None:
                field_data = campaign1_obj.field.name

            # Comment
            comment = ""
            if campaign1_obj.comment is not None:
                comment = campaign1_obj.comment

            # Fee Calculation
            email_setup_fee = 0
            email_pack_fee = 0
            sms_setup_fee = 0
            sms_pack_fee = 0
            views_setup_fee = 0
            views_pack_fee = 0

            setup_fee = 0
            pack_fee = 0
            total_cost = 0
            if campaign1_obj.email:
                EmailSetupFee_obj = EmailSetupFee.objects.all().first()
                price = int(EmailSetupFee_obj.price)
                vat = int(EmailSetupFee_obj.vat.vat_code)

                setup_fee = setup_fee + price + (price * (vat)/100)
                #setup_fee_decimal = '{:.2f}'.format(setup_fee)

                # PART2 Object
                print(campaign2_obj)
                for i in campaign2_obj:
                    print('count', (i.user_notification).count())
                    email_recipient_count = (i.user_notification).count()

                # Package
                EmailPackages_obj = EmailPackages.objects.all()

                for i in EmailPackages_obj:
                    edata = []
                    qty_from = i.email_qty_from
                    qty_to = i.email_qty_to
                    if email_recipient_count >= qty_from and email_recipient_count <= qty_to:
                        edata.append(i)

                        eprice = int(edata[0].price)
                        evat = int(edata[0].vat.vat_code)
                        pack_fee = pack_fee + eprice + (eprice * (evat)/100)
                        # print('e-packfee', pack_fee)
                        # print('e-setupfee', setup_fee)

                        total_cost = total_cost + setup_fee + pack_fee
                        # print('e-', total_cost)

                email_setup_fee = email_setup_fee + setup_fee
                email_pack_fee = email_pack_fee + pack_fee

            if campaign1_obj.sms:
                setup_fee = 0
                pack_fee = 0

                SmsSetupFee_obj = SmsSetupFee.objects.all().first()
                price = int(SmsSetupFee_obj.price)
                vat = int(SmsSetupFee_obj.vat.vat_code)

                setup_fee = setup_fee + price + (price * (vat)/100)

                # PART2 Object
                print(campaign2_obj)
                for i in campaign2_obj:
                    # print(i.user_notification)
                    recipient_count = (i.user_notification).count()

                # Package
                SmsPackages_obj = SmsPackages.objects.all()

                for i in SmsPackages_obj:
                    edata = []
                    qty_from = i.sms_qty_from
                    qty_to = i.sms_qty_to
                    if recipient_count >= qty_from and recipient_count <= qty_to:
                        edata.append(i)

                        sprice = int(edata[0].price)
                        svat = int(edata[0].vat.vat_code)
                        pack_fee = pack_fee + sprice + (sprice * (svat)/100)

                        total_cost = total_cost + setup_fee + pack_fee
                        print('s', total_cost)
                sms_setup_fee = sms_setup_fee + setup_fee
                sms_pack_fee = sms_pack_fee + pack_fee

            # Paid Ads

            paid_ads_setup_fee = 0
            paid_ads_pack_fee = 0
            if campaign1_obj.paid_ads:
                PaidAdsSetupFee_obj = PaidAdsSetupFee.objects.all().first()
                price = int(PaidAdsSetupFee_obj.price)
                vat = int(PaidAdsSetupFee_obj.vat.vat_code)

                paid_ads_setup_fee = paid_ads_setup_fee + \
                    price + (price * (vat)/100)
                print('paid ads', paid_ads_setup_fee)
                #setup_fee_decimal = '{:.2f}'.format(setup_fee)

                # PART4 Object
                print('part-4', campaign4_obj)
                #print('part-4', campaign4_obj.views)

                for i in campaign4_obj:
                    print('views price', (i.views.price))
                    print('views vat code', (i.views.vat.vat_code))

                    pprice = int(i.views.price)
                    pvat = int(i.views.vat.vat_code)

                    paid_ads_pack_fee = paid_ads_pack_fee + \
                        pprice + (pprice * (pvat)/100)

                    total_cost = total_cost + \
                        paid_ads_setup_fee + paid_ads_pack_fee

                    print('paid ads pack fee', paid_ads_pack_fee)

                    print('ptotal', total_cost)
                views_setup_fee = views_setup_fee + paid_ads_setup_fee
                views_pack_fee = views_pack_fee + paid_ads_pack_fee

            campaign1_obj.cost = total_cost
            campaign1_obj.save()

            if campaign1_obj.paid_ads == True:
                campaign1_obj.completed = True
                campaign1_obj.save()

            data = {"campaign_name": campaign1_obj.name, "campaign_type": campaign_type,  "campaign_status": campaign1_obj.status, "start_date": campaign1_obj.start_date, "end_date": campaign1_obj.end_date,
                    "duration": duration, "campaign_comment": comment, "field": field_data, "sms_setup_fee": sms_setup_fee, "sms_package_fee": sms_pack_fee, "email_setup_fee": email_setup_fee, "email_package_fee": email_pack_fee, "views_setup_fee": views_setup_fee, "views_pack_fee": views_pack_fee, "total_fee": total_cost}

            # campaign 2
            count = 0
            for i in campaign2_obj:
                if i.user_notification is not None:
                    count = (i.user_notification).count()

            recipient_serializer_data = self.recipient_serializer_class(
                campaign2_obj, many=True)

            # campaign 3
            sms_email_serializer_data = self.sms_email_serializer_class(
                campaign3_sms_email_obj, many=True)

            # campaign 4
            discount_serializer_data = self.discount_serializer_class(
                campaign4_obj, many=True)

            # Campaign_notification_time
            serializer_data = self.notification_serializer_class(
                campaign_notification_obj, many=True)

            data['part_2_recipients_count'] = count

            data['part_3_sms_email_design'] = sms_email_serializer_data.data

            data['part_4_discount_percentage'] = discount_serializer_data.data

            data['campaign_notification'] = serializer_data.data

            response["result"] = 1
            responsedata.append(data)
            response['data'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class AdminCampaignListLISTGET(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignLISTSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []
        vobj = VenueOwner.objects.get(id=request.data['venueowner_id'])

        request.data._mutable = True
        request.data['created_by'] = vobj.user.id
        # print(request.data['created_by'])

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            pagination = serializer.validated_data['page']
            serializer.validated_data.pop("page")
            serializer.validated_data.pop('venueowner_id')

            serializer.validated_data['completed'] = True

            # if "start_date" in serializer.validated_data:
            #     serializer.validated_data['start_date__gte'] = serializer.validated_data["start_date"]
            #     serializer.validated_data.pop("start_date")

            # if "end_date" in serializer.validated_data:
            #     serializer.validated_data['end_date__lte'] = serializer.validated_data["end_date"]
            #     serializer.validated_data.pop("end_date")

            if "campaign_kind" in serializer.validated_data:
                if serializer.validated_data['campaign_kind'] == "email":
                    serializer.validated_data['email'] = True
                elif serializer.validated_data['campaign_kind'] == "sms":
                    serializer.validated_data['sms'] = True
                elif serializer.validated_data['campaign_kind'] == "banner":
                    serializer.validated_data['banner'] = True
                elif serializer.validated_data['campaign_kind'] == "paid_ads":
                    serializer.validated_data['paid_ads'] = True
                serializer.validated_data.pop("campaign_kind")

            if "status" in serializer.validated_data:
                if serializer.validated_data["status"] == "UNDER APPROVAL":
                    serializer.validated_data['status'] = "O"
                elif serializer.validated_data["status"] == "ON GOING":
                    serializer.validated_data["start_date__lte"] = timezone.now(
                    )
                    serializer.validated_data['status'] = "A"
                elif serializer.validated_data["status"] == "WAITING":
                    serializer.validated_data["start_date__gte"] = timezone.now(
                    )
                    serializer.validated_data['status'] = "A"
                elif serializer.validated_data["status"] == "REJECTED":
                    serializer.validated_data['status'] = "R"

            if "keyword" in serializer.validated_data:
                serializer.validated_data['name__icontains'] = serializer.validated_data['keyword']
                serializer.validated_data.pop("keyword")

            start_data = (pagination - 1) * 10
            end_data = start_data + 10

            if "assortment" in serializer.validated_data:
                assortment = serializer.validated_data['assortment']
                serializer.validated_data.pop("assortment")
                campaign_data = CampaignPart1.objects.filter(
                    **serializer.validated_data).order_by('-'+assortment)

            else:
                campaign_data = CampaignPart1.objects.filter(
                    **serializer.validated_data).order_by("-created_at")
            campaign_count = campaign_data.count()
            campaign_data = campaign_data[start_data:end_data]

            serializer = self.serializer_class(campaign_data, many=True)

            response["result"] = 1
            response['data'] = serializer.data
            response['total_page'] = campaign_count
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminCampaignListLISTDELETE(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminCampaignDELETESerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []
        v_owner_id = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner_id.user)
        serializer = self.serializer_class(data=request.data, context={
            "venueowner_id": request.data['venueowner_id']})
        if serializer.is_valid():
            # Check whether it is started or not
            print(serializer.validated_data['id'].start_date)
            # print(timezone.now())
            # if serializer.validated_data['id'].start_date < timezone.now():
            #     response["result"] = 0
            #     responsedata.append("This Campaign Cannot be deleted")
            #     response['errors'] = responsedata
            #     self.add_api_call(request, response)
            #     return Response(response, status=status.HTTP_200_OK)

            serializer.validated_data['id'].is_deleted = True
            serializer.validated_data['id'].save()

            response["result"] = 1
            responsedata.append("Sucessfully deleted")
            response['data'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminGlobalCampaignAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminglobalSerializer
    Campaign1serializer_class = CampaignPart1SerializerGET
    Campaign2serializer_class = CampaignPart2SerializerGET
    Campaign3serializer_class = Campaign3Get
    Campaign4serializer_class = CampaignPart4GETSerializer

    def post(self, request, format=None):
        '''
        Campaign Global GET
        '''

        response = {}
        responsedata = []
        v_owner_id = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner_id.user)
        serializers = self.serializer_class(data=request.data, context={
            "venueowner_id": request.data['venueowner_id']})
        if serializers.is_valid():
            if 'id' in serializers.validated_data:
                Campaign1 = CampaignPart1.objects.filter(
                    id=serializers.validated_data['id'], is_deleted=False)
                Campaign2 = CampaignPart2.objects.filter(
                    campaign1=serializers.validated_data['id'], is_deleted=False)
                Campaign3 = CampaignPart3.objects.filter(
                    campaign1=serializers.validated_data['id'], is_deleted=False)
                Campaign4 = CampaignPart4.objects.filter(
                    campaign1=serializers.validated_data['id'], is_deleted=False)
            else:
                Campaign1 = CampaignPart1.objects.filter(
                    created_by=v_owner_id.user, is_deleted=False)
                Campaign2 = CampaignPart2.objects.filter(
                    created_by=v_owner_id.user, is_deleted=False)
                Campaign3 = CampaignPart3.objects.filter(
                    created_by=v_owner_id.user, is_deleted=False)
                Campaign4 = CampaignPart4.objects.filter(
                    created_by=v_owner_id.user, is_deleted=False)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
        serializers1 = self.Campaign1serializer_class(Campaign1, many=True)
        serializers2 = self.Campaign2serializer_class(Campaign2, many=True)
        serializers3 = self.Campaign3serializer_class(Campaign3, many=True)
        serializers4 = self.Campaign4serializer_class(Campaign4, many=True)
        response['result'] = 1
        responsedata.append({"Campaign1": serializers1.data})
        responsedata.append({"Campaign2": serializers2.data})
        responsedata.append({"Campaign3": serializers3.data})
        responsedata.append({"Campaign4": serializers4.data})
        response['data'] = responsedata
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class AdminGeoFilterApi(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminPlayerAreaSerializer

    def post(self, request, format=None):
        '''
        Area serializer
        '''
        response = {}
        responsedata = []
        v_owner = VenueOwner.objects.get(
            id=request.data['venueowner_id'])
        print(v_owner.user)
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            ar = []
            area_ids = []
            sports = []
            pids = []
            if 'area_list' in serializers.validated_data:
                ar = serializers.validated_data['area_list']

            if 'sports_list' in serializers.validated_data:
                sports = serializers.validated_data['sports_list']
                ppobj = PlayerSkills.objects.filter(sport__id__in=sports)
                for j in range(0, ppobj.count()):
                    pids.append(ppobj[j].player.id)
                pids = list(set(pids))

            aobj = Area.objects.filter(name__in=ar)
            for i in range(0, aobj.count()):
                area_ids.append(aobj[i].id)

            player_data = []
            if len(pids) > 0 and len(area_ids) > 0:
                pobj = Player.objects.filter(
                    area__id__in=area_ids, id__in=pids)
                for a in range(0, pobj.count()):
                    if BookMatch.objects.filter(created_by=pobj[a].id, venue_field__created_by=v_owner.user).exists():
                        dt = {}
                        dt['id'] = pobj[a].id
                        dt['firstname'] = pobj[a].first_name
                        dt['lastname'] = pobj[a].last_name
                        dt['nickname'] = pobj[a].nick_name
                        player_data.append(dt)
            elif len(pids) == 0 and len(area_ids) > 0:
                pobj = Player.objects.filter(area__id__in=area_ids)
                for a in range(0, pobj.count()):
                    if BookMatch.objects.filter(created_by=pobj[a].id, venue_field__created_by=v_owner.user).exists():
                        dt = {}
                        dt['id'] = pobj[a].id
                        dt['firstname'] = pobj[a].first_name
                        dt['lastname'] = pobj[a].last_name
                        dt['nickname'] = pobj[a].nick_name
                        player_data.append(dt)
            elif len(pids) > 0 and len(area_ids) == 0:
                pobj = Player.objects.filter(id__in=pids)
                for a in range(0, pobj.count()):
                    if BookMatch.objects.filter(created_by=pobj[a].id, venue_field__created_by=v_owner.user).exists():
                        dt = {}
                        dt['id'] = pobj[a].id
                        dt['firstname'] = pobj[a].first_name
                        dt['lastname'] = pobj[a].last_name
                        dt['nickname'] = pobj[a].nick_name
                        player_data.append(dt)
            else:
                print("no data")

            response['result'] = 1
            response['data'] = player_data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class SmsSetupFeeGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    SMS Setup Fee
    """
    serializer_class = SmsSetupFeeSerializer

    def get(self, request, format=None):
        response = {}
        responsedata = []
        data = SmsSetupFee.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class SmsSetupFeePostAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SmsSetupFeePostSerializer

    # Add SMS Setup Fee
    def post(self, request, format=None):
        response = {}
        responsedata = []

        # if SmsSetupFee.objects.filter(code=request.data['code']).exists():
        #     response['results'] = 0
        #     response['error'] = "Code already exists"
        #     self.add_api_call(request, response)
        #     return Response(response, status=status.HTTP_200_OK)

        if SmsSetupFee.objects.filter().exists():
            sms_object = SmsSetupFee.objects.filter()
            print(sms_object)
            sms_object.delete()

            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'

        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class SmsPackagesGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    SMS Packages
    """
    serializer_class = SmsPackagesSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []
        # get page number
        if 'page' in request.data:
            start_count = int(request.data['page']) - 1
        else:
            start_count = 0
        start_count = start_count * 10
        end_count = start_count + 10
        data = SmsPackages.objects.all()[start_count:end_count]
        total_count = SmsPackages.objects.all().count()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        response['total_count'] = total_count
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class SmsPackagesPOSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SmsPackagesPOSTSerializer

    def post(self, request, format=None):
        '''
        Add SmsPackages
        '''
        responsedata = []
        response = {}

        serializer = self.serializer_class(data=request.data)
        message = "Created Successfully"

        if serializer.is_valid():
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class SmsPackagesEDITAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SmsPackagesEDITSerializer

    def post(self, request, format=None):
        '''
        Update SmsPackages
        '''
        responsedata = []
        response = {}

        if SmsPackages.objects.filter(id=request.data['id']).exists():
            serializer = self.serializer_class(instance=SmsPackages.objects.get(
                id=request.data['id']), data=request.data)
            message = "Updated Successfully"
        else:
            response["result"] = 0
            response['data'] = "Invalid SMS Package id"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class SmsPackagesDeleteAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = DeleteSmsPackagesSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []

        if not SmsPackages.objects.filter(id=request.data['id']).exists():
            response['results'] = 0
            response['error'] = "Not a valid ID"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            Sms_obj = SmsPackages.objects.get(
                id=serializers.validated_data['id'])
            Sms_obj.delete()

            response['results'] = 1
            response['data'] = "Successfully Deleted"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetSingleSmsPackagesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SingleSmsPackagesSerializer

    def post(self, request, format=None):
        '''
        Get SMS Packages by Id
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if SmsPackages.objects.filter(id=serializer.validated_data["id"]).exists():
                smsPacakage_obj = SmsPackages.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid SMS Package id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            serializer = self.serializer_class(smsPacakage_obj)

            response["result"] = 1
            response['data'] = serializer.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class EmailSetupFeeGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    EMAIL Setup Fee
    """
    serializer_class = EmailSetupFeeSerializer

    def get(self, request, format=None):
        response = {}
        responsedata = []
        data = EmailSetupFee.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class EmailSetupFeePostAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = EmailSetupFeePostSerializer

    # Add Email Setup Fee
    def post(self, request, format=None):
        response = {}
        responsedata = []

        if EmailSetupFee.objects.filter().exists():
            email_object = EmailSetupFee.objects.filter()
            print(email_object)
            email_object.delete()

            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'

        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class EmailPackagesGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    EMAIL Packages
    """
    serializer_class = EmailPackagesSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []
        # get page number
        if 'page' in request.data:
            start_count = int(request.data['page']) - 1
        else:
            start_count = 0
        start_count = start_count * 10
        end_count = start_count + 10
        data = EmailPackages.objects.all()[start_count:end_count]
        total_count = EmailPackages.objects.all().count()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        response['total_count'] = total_count
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class EmailPackagesPOSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = EmailPackagesPOSTSerializer

    def post(self, request, format=None):
        '''
        Add EmailPackages
        '''
        responsedata = []
        response = {}

        serializer = self.serializer_class(data=request.data)
        message = "Created Successfully"

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class EmailPackagesEDITAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = EmailPackagesEDITSerializer

    def post(self, request, format=None):
        '''
        Update EmailPackages
        '''
        responsedata = []
        response = {}

        if EmailPackages.objects.filter(id=request.data['id']).exists():
            serializer = self.serializer_class(instance=EmailPackages.objects.get(
                id=request.data['id']), data=request.data)
            message = "Updated Successfully"
        else:
            response["result"] = 0
            response['error'] = "Invalid EMAIL Package id"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class EmailPackagesDeleteAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = DeleteEmailPackagesSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []

        if not EmailPackages.objects.filter(id=request.data['id']).exists():
            response['results'] = 0
            response['error'] = "Not a valid ID"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            Email_obj = EmailPackages.objects.get(
                id=serializers.validated_data['id'])
            Email_obj.delete()

            response['results'] = 1
            response['data'] = "Successfully Deleted"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetSingleEmailPackagesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SingleEmailPackagesSerializer

    def post(self, request, format=None):
        '''
        Get EMAIL Packages by Id
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if EmailPackages.objects.filter(id=serializer.validated_data["id"]).exists():
                emailPackage_obj = EmailPackages.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid EMAIL Package id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            serializer = self.serializer_class(emailPackage_obj)

            response["result"] = 1
            response['data'] = serializer.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class BannerSetupFeeGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    BANNER Setup Fee
    """
    serializer_class = BannerSetupFeeSerializer

    def get(self, request, format=None):
        response = {}
        responsedata = []
        data = BannerSetupFee.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class BannerSetupFeePostAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = BannerSetupFeePostSerializer

    # Add Banner Setup Fee
    def post(self, request, format=None):
        response = {}
        responsedata = []

        if BannerSetupFee.objects.filter().exists():
            banner_object = BannerSetupFee.objects.filter()
            print(banner_object)
            banner_object.delete()

            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'

        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class PaidAdsSetupFeeGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    PAIDADS Setup Fee
    """
    serializer_class = PaidAdsSetupFeeSerializer

    def get(self, request, format=None):
        response = {}
        responsedata = []
        data = PaidAdsSetupFee.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class PaidAdsSetupFeePostAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = PaidAdsSetupFeePostSerializer

    # Add PaidAds Setup Fee
    def post(self, request, format=None):
        response = {}
        responsedata = []

        if PaidAdsSetupFee.objects.filter().exists():
            paidads_object = PaidAdsSetupFee.objects.filter()
            print(paidads_object)
            paidads_object.delete()

            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Updated'
        else:
            serializers = self.serializer_class(data=request.data)
            message = 'Successfully Inserted'

        if serializers.is_valid():
            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class PaidAdsViewsPackagesGetAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    PaidAds Views Packages
    """
    serializer_class = PaidAdsViewsPackagesSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []
        # get page number
        if 'page' in request.data:
            start_count = int(request.data['page']) - 1
        else:
            start_count = 0
        start_count = start_count * 10
        end_count = start_count + 10
        data = PaidAdsViewsPackages.objects.all()[start_count:end_count]
        total_count = PaidAdsViewsPackages.objects.all().count()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        response['total_count'] = total_count
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class PaidAdsViewsPackagesPOSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = PaidAdsViewsPackagesPOSTSerializer

    def post(self, request, format=None):
        '''
        Add PaidAds Views Packages
        '''
        responsedata = []
        response = {}

        if PaidAdsViewsPackages.objects.filter(code=request.data['code']).exists():
            response['results'] = 0
            response['error'] = "Code already exists"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        serializer = self.serializer_class(data=request.data)
        message = "Created Successfully"

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class PaidAdsViewsPackagesEDITAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = PaidAdsViewsPackagesEDITSerializer

    def post(self, request, format=None):
        '''
        Update PaidAds Views Packages
        '''
        responsedata = []
        response = {}

        if PaidAdsViewsPackages.objects.filter(id=request.data['id']).exists():
            serializer = self.serializer_class(instance=PaidAdsViewsPackages.objects.get(
                id=request.data['id']), data=request.data)
            message = "Updated Successfully"
        else:
            response["result"] = 0
            response['error'] = "Invalid PaidAds Views Package id"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class PaidAdsViewsPackagesDeleteAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = DeletePaidAdsViewsPackagesSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []

        if not PaidAdsViewsPackages.objects.filter(id=request.data['id']).exists():
            response['results'] = 0
            response['error'] = "Not a valid ID"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            views_obj = PaidAdsViewsPackages.objects.get(
                id=serializers.validated_data['id'])
            views_obj.delete()

            response['results'] = 1
            response['data'] = "Successfully Deleted"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetSinglePaidAdsViewsPackagesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SinglePaidAdsViewsPackagesSerializer

    def post(self, request, format=None):
        '''
        Get PaidAds Views Package by Id
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if PaidAdsViewsPackages.objects.filter(id=serializer.validated_data["id"]).exists():
                viewsPackage_obj = PaidAdsViewsPackages.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid View Package id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            serializer = self.serializer_class(viewsPackage_obj)

            response["result"] = 1
            response['data'] = serializer.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class CreateOrderPaymentApiView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = CreateOrderSerializer

    def post(self, request, format=None):
        '''
        Payment Gateway  POST
        '''
        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            camp_id = serializers.validated_data['camp_id']
            url_of_viva = "https://demo.vivapayments.com/api/orders"
            if CampaignPart1.objects.filter(id=camp_id, is_deleted=False).exists():
                camp_obj = CampaignPart1.objects.get(
                    id=camp_id, is_deleted=False)
                # print(Decimal(camp_obj.cost))
                value = Decimal(camp_obj.cost)
                # print(value*100)

                amount = 0
                if camp_obj.email:
                    amount = amount+(int(value*100))
                elif camp_obj.sms:
                    amount = amount+(int(value*100))
                elif camp_obj.sms and camp_obj.email:
                    amount = amount+(int(value*100))
                print(amount)

                user_details = None
                if VenueOwner.objects.filter(user=camp_obj.created_by).exists():
                    user_details = VenueOwner.objects.get(
                        user=camp_obj.created_by)
                else:
                    user_details = Advertiser.objects.filter(
                        user=camp_obj.created_by)
                payload = {
                    "amount": amount,
                    "email": camp_obj.created_by.username,
                    "fullName": user_details.first_name+" "+user_details.last_name,
                    "customerTrns": "PAYMENT FOR CAMPAIGN",
                    "phone": user_details.mobile,
                    "requestLang": "en-US",
                    "sourceCode": "6785",
                    "disableCash": "false",
                    "disableExactAmount": "false",
                    "allowRecurring": "false",
                    "isPreAuth": "false",
                    "maxInstallments": 1,
                    "paymentTimeOut": 86400,
                    "merchantTrns": "PAYMENT FOR CAMPAIGN",
                }
                access_token = "NWZlZTg4YjAtYzUyNy00MGJmLTkzOTAtYjkzMjM4NzMyNTI4OnxacDIuXw=="
                result_of_order = requests.post(url_of_viva,
                                                headers={'Content-Type': 'application/x-www-form-urlencoded',
                                                         'Authorization': 'Basic {}'.format(access_token), 'Accept': 'application/json'}, data=payload)
                print(result_of_order.json()['OrderCode'])

                camp_obj.order_code = result_of_order.json()['OrderCode']
                camp_obj.save()

                t = Transaction.objects.create(order_code=result_of_order.json(
                )['OrderCode'], payment_done_for="C", created_by=camp_obj.created_by)
                t.save()
                response['result'] = 1
                responsedata.append(result_of_order.json()['OrderCode'])
                response['data'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response['result'] = 0
                responsedata.append("NO SUCH CAMPAIGN FOUND")
                response['data'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class TransactionCheck(PlatformAPICallMixin, generics.GenericAPIView):
    serializer_class = TransactionSerializer

    def post(self, request, format=None):
        '''
        Transaction success  POST
        '''
        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            order_code = serializers.validated_data['orderCode']
            t_id = serializers.validated_data['transactionId']
            access_token = "NWZlZTg4YjAtYzUyNy00MGJmLTkzOTAtYjkzMjM4NzMyNTI4OnxacDIuXw=="
            url_of_viva = "https://demo.vivapayments.com/api/transactions/"+t_id
            result_of_order = requests.get(url_of_viva,
                                           headers={'Content-Type': 'application/x-www-form-urlencoded',
                                                    'Authorization': 'Basic {}'.format(access_token), 'Accept': 'application/json'})
            print(result_of_order.json())
            message = ""
            u = ""
            if result_of_order.json()['Success']:
                t = Transaction.objects.get(order_code=order_code)
                t.transaction_id = t_id
                t.payment_status = "S"
                t.save()
                camp_obj = CampaignPart1.objects.get(order_code=order_code)
                camp_obj.payment_status = "S"
                camp_obj.completed = True
                camp_obj.save()
                if VenueOwner.objects.filter(user=camp_obj.created_by).exists():
                    u = "V"
                    response['user_id'] = VenueOwner.objects.get(
                        user=camp_obj.created_by).id
                else:
                    u = "A"
                    response['user_id'] = Advertiser.objects.get(
                        user=camp_obj.created_by).id
                message = "Your Payment Has Been Successful! Your Campaign is in process"
            else:
                t = Transaction.objects.get(order_code=order_code)
                t.transaction_id = t_id
                t.payment_status = "F"
                t.save()
                camp_obj = CampaignPart1.objects.get(order_code=order_code)
                camp_obj.payment_status = "F"
                camp_obj.save()
                if VenueOwner.objects.filter(user=camp_obj.created_by).exists():
                    u = "V"
                    response['user_id'] = VenueOwner.objects.get(
                        user=camp_obj.created_by).id
                else:
                    u = "A"
                    response['user_id'] = Advertiser.objects.get(
                        user=camp_obj.created_by).id
                message = "Sorry your payment has failed,campaign is not created."
            response['result'] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['user'] = [u]
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
