import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.contrib.contenttypes.models import ContentType
from django.urls import reverse
from django.contrib.auth.models import Group
from django.contrib.auth import login as django_login
import datetime
from django.utils import timezone
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated
from utils.mixins import *
from utils.api_handle_errors import handle_errors

from admin_app.serializers import *

from venue_owners.models import *
from venue_owners.serializers import *
from venues.models import *
from venues.serializers import *
from players.models import BookMatch
from commonAPI.models import *
from commonAPI.serializers import OnBoardAPIGETSerializer, OnBoardAPIPOSTSerializer
from django.db.models import Q, Avg
from reviews.models import Review, VenueReviewAndRating
from reviews.serializers import ReviewGETSerializer
from commonAPI.models import Contact_Person
from utils.mail import send_emal_onboard_accept, send_mail_registeration, field_approval_email, \
    in_progress_email_verification, onboard_Complete_mail, onboard_delete_or_declined_mail
from commonAPI.serializers import ContactPersonSerializer, BankInfoProfileSerializer
from field_booking.settings import DOMAIN_NAME
from platform_central.models import RegisterPrivateKey
from message.serializers import MessagesInboxSerializer
from message.models import MessagesInbox, Notification
from advertisers.models import Advertiser
from static_data.models import *
from static_data.serializers import *
from message.serializers import NotificationsSerializer
from campaigns.serializers import CampaignPart4GETSerializer, Campaign3Get, CampaignPart2SerializerGET
from campaigns.models import CampaignPart1, CampaignPart2, CampaignPart3, CampaignPart4
from professionals.models import Professional


class AdminTemplateListLISTGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminScheduleTemplateGETLISTSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():

                vobj = VenueOwner.objects.get(
                    id=serializer.validated_data['venueowner_id'])
                print(vobj.user.id)
                print(vobj.user)

                print(serializer.validated_data)

                serializer.validated_data['created_by'] = vobj.user.id

                # Get page number
                start_count = (serializer.validated_data['page'] - 1) * 10
                end_count = start_count + 10
                serializer.validated_data.pop('page')

                in_use_filter = ""
                if "filter_in_use" in serializer.validated_data:
                    in_use_filter = serializer.validated_data['filter_in_use']
                    serializer.validated_data.pop('filter_in_use')

                # Keyword
                keyword = ""
                if "keyword" in serializer.validated_data:
                    serializer.validated_data['template_name__icontains'] = serializer.validated_data['keyword']
                    keyword = serializer.validated_data['keyword']
                    serializer.validated_data.pop("keyword")

                assortment = ""
                if "assortment" in serializer.validated_data:
                    assortment = serializer.validated_data['assortment']
                    serializer.validated_data.pop('assortment')

                serializer.validated_data.pop('venueowner_id')

                list_of_ids_to_include = []
                if in_use_filter != "":
                    if in_use_filter == "yes":
                        schedules_of_that_user = Schedule.objects.filter(
                            created_by=vobj.user.id, is_deleted=False)
                        # print(schedules_of_that_user)
                        upper_list_count = Schedule.objects.filter(
                            created_by=vobj.user.id, is_deleted=False).count()
                        # print(upper_list_count)
                        for x in range(0, upper_list_count):
                            list_of_ids_to_include.append(
                                schedules_of_that_user[x].template.id)
                        # print(list_of_ids_to_include)

                        if len(list_of_ids_to_include) > 0:
                            if assortment != "":
                                if keyword != "":
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at").order_by(assortment)
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)
                                else:
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, is_deleted=False, created_by=vobj.user.id).order_by("created_at").order_by(assortment)
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)

                            else:
                                if keyword != "":
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at")
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)
                                else:
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, is_deleted=False, created_by=vobj.user.id).order_by("created_at")
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        id__in=list_of_ids_to_include, is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)

                        else:
                            response["result"] = 1
                            response['data'] = []
                            response['total_count'] = 0
                            self.add_api_call(request, response)
                            return Response(response, status=status.HTTP_200_OK)
                    else:
                        print("noo")
                        schedules_of_that_user = Schedule.objects.filter(
                            created_by=vobj.user.id, is_deleted=False)
                        upper_list_count = Schedule.objects.filter(
                            created_by=vobj.user.id, is_deleted=False).count()
                        for x in range(0, upper_list_count):
                            list_of_ids_to_include.append(
                                schedules_of_that_user[x].template.id)

                        if len(list_of_ids_to_include) > 0:
                            if assortment != "":
                                if keyword != "":
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at").order_by(assortment)
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)
                                else:
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), is_deleted=False, created_by=vobj.user.id).order_by("created_at").order_by(assortment)
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)

                            else:
                                if keyword != "":
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at")
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), template_name__icontains=keyword, is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)
                                else:
                                    schedule_templates_in_use = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), is_deleted=False, created_by=vobj.user.id).order_by("created_at")
                                    count_for_upper_var = ScheduleTemplateStep1.objects.filter(
                                        ~Q(id__in=list_of_ids_to_include), is_deleted=False, created_by=vobj.user.id).order_by("created_at").count()
                                    serializer = self.serializer_class(
                                        schedule_templates_in_use, many=True)
                                    response["result"] = 1
                                    response['data'] = serializer.data
                                    response['total_count'] = count_for_upper_var
                                    self.add_api_call(request, response)
                                    return Response(response, status=status.HTTP_200_OK)

                        else:
                            if assortment != "":
                                print("assortment")
                                data_without_inuse = ScheduleTemplateStep1.objects.filter(
                                    **serializer.validated_data).order_by("created_at").order_by(assortment)
                                data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                                    **serializer.validated_data).order_by("created_at").count()
                                serializer = self.serializer_class(
                                    data_without_inuse, many=True)
                                response["result"] = 1
                                response['data'] = serializer.data
                                response['total_count'] = data_without_inuse_count
                                self.add_api_call(request, response)
                                return Response(response, status=status.HTTP_200_OK)
                            else:
                                data_without_inuse = ScheduleTemplateStep1.objects.filter(
                                    **serializer.validated_data).order_by("created_at")
                                data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                                    **serializer.validated_data).order_by("created_at").count()
                                serializer = self.serializer_class(
                                    data_without_inuse, many=True)
                                response["result"] = 1
                                response['data'] = serializer.data
                                response['total_count'] = data_without_inuse_count
                                self.add_api_call(request, response)
                                return Response(response, status=status.HTTP_200_OK)

                else:
                    print("no in use")
                    if assortment != "":
                        print("assortment")
                        data_without_inuse = ScheduleTemplateStep1.objects.filter(
                            **serializer.validated_data).order_by("created_at").order_by(assortment)
                        data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                            **serializer.validated_data).order_by("created_at").count()
                        serializer = self.serializer_class(
                            data_without_inuse, many=True)
                        response["result"] = 1
                        response['data'] = serializer.data
                        response['total_count'] = data_without_inuse_count
                        self.add_api_call(request, response)
                        return Response(response, status=status.HTTP_200_OK)
                    else:
                        data_without_inuse = ScheduleTemplateStep1.objects.filter(
                            **serializer.validated_data).order_by("created_at")
                        data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                            **serializer.validated_data).order_by("created_at").count()
                        serializer = self.serializer_class(
                            data_without_inuse, many=True)
                        response["result"] = 1
                        response['data'] = serializer.data
                        response['total_count'] = data_without_inuse_count
                        self.add_api_call(request, response)
                        return Response(response, status=status.HTTP_200_OK)

            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminTemplateListLISTDELETEAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminScheduleTemplateLISTDELETESerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            v_owner_id = VenueOwner.objects.get(
                id=request.data['id'])

            serializer = self.serializer_class(instance=ScheduleTemplateStep1.objects.get(
                id=request.data['template_id']), data=request.data, context={"id": request.data['id']})
            if serializer.is_valid():

                # Check if schedule template is assigned
                if Schedule.objects.filter(template=serializer.validated_data["template_id"], is_deleted=False).exists():
                    response["result"] = 0
                    responsedata.append("Schedule Template is in use")
                    response['data'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                serializer.save()
                response["result"] = 1
                responsedata.append("Successfulle Deleted")
                response['data'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminScheduleTemplate1APIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminScheduleTemplateStep1POSTSerializer

    def post(self, request, format=None):
        '''
        Add Schedule Template
        '''
        try:
            response = {}
            responsedata = []
            serializers = self.serializer_class(
                data=request.data, context={"id": request.data['id']})
            if serializers.is_valid():
                serializers.save()
                response["result"] = 1
                responsedata.append("Successfully Inserted")
                response['data'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializers.errors)
                response["result"] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminScheduleTemplate1GETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminScheduleTemplate1GETSerializer
    slots_serializer = AdminScheduleTemplateSlotsSerialzier

    def post(self, request, format=None):
        '''
        Get Schedule Template
        '''
        try:
            response = {}
            responsedata = []
            venue_owner = VenueOwner.objects.get(
                id=request.data['venueowner_id'])

            serializers = self.serializer_class(
                data=request.data, context={"venueowner_id": request.data['venueowner_id']})
            if serializers.is_valid():
                serializers.validated_data.pop('venueowner_id')
                template_data = ScheduleTemplateStep1.objects.get(
                    **serializers.validated_data, created_by=venue_owner.user)

                days = 1 if template_data.plan_range == 'D' else 7 if template_data.plan_range == "W" else 31
                serializers = self.serializer_class(template_data, many=False)
                slots_start_times = ScheduleTemplateSlot.objects.filter(
                    template=template_data).values_list('start_hour').distinct()

                template_slots = []

                if len(serializers.data) == 0:
                    template_slots = []
                else:
                    if template_data.plan_range == "W":
                        print("w")
                        slots = ScheduleTemplateSlot.objects.filter(
                            template=template_data)
                        slotSerializer = self.slots_serializer(
                            slots, many=True)
                        sdata = slotSerializer.data
                        print(sdata)
                        template_slots = sdata
                    else:
                        print(slots_start_times)
                        for k in slots_start_times:
                            temp_data = {}
                            break_down = 0
                            print(days)
                            for i in range(days):
                                slots = ScheduleTemplateSlot.objects.get(
                                    template=template_data, day=i, start_hour=k[0].strftime('%H:%M:%S'))
                                slotSerializer = self.slots_serializer(
                                    slots, many=False)
                                temp_data[i] = slotSerializer.data
                                template_slots.append(temp_data)

                                if break_down > 500:
                                    break
                                else:
                                    break_down = break_down + 1

                response["result"] = 1
                responsedata.append({"ScheduleTemplate1": serializers.data})
                responsedata.append({"ScheduleTemplateSlot": template_slots})
                response['data'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializers.errors)
                response["result"] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminScheduleTemplate1UPDATEAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminScheduleTemplateStep1UPDATESerializer

    @transaction.atomic
    def post(self, request, format=None):
        '''
        For update send entire record again
        '''
        try:
            response = {}
            responsedata = []
            v_owner_id = VenueOwner.objects.get(id=request.data['id'])

            request.data._mutable = True
            request.data['created_by'] = v_owner_id.user.id
            # print(request.data['created_by'])

            serializers = self.serializer_class(instance=ScheduleTemplateStep1.objects.get(
                id=request.data['template_id']), data=request.data, context={"id": request.data['id']})
            if serializers.is_valid():

                # Check if schedule template is assigned
                if Schedule.objects.filter(template=serializers.validated_data["template_id"], is_deleted=False).exists():
                    response["result"] = 0
                    responsedata.append("Schedule Template is in use")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                # Append Slots
                slots = serializers.validated_data['slots']
                serializers.validated_data.pop("slots")
                serializers.validated_data.pop("id")
                template_obj = serializers.save()

                # Slots
                ScheduleTemplateSlot.objects.filter(
                    template=template_obj).delete()
                data = [ScheduleTemplateSlot(
                    **i,
                    template=template_obj
                ) for i in slots]
                ScheduleTemplateSlot.objects.bulk_create(data)

                response["result"] = 1
                responsedata.append("Successfully Updated")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializers.errors)
                response["result"] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class AdminTemplateListLISTWithoutPaginationGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = AdminScheduleTemplateLISTWithoutPaginationSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():

                vobj = VenueOwner.objects.get(
                    id=serializer.validated_data['venueowner_id'])

                serializer.validated_data['created_by'] = vobj.user.id

                serializer.validated_data.pop('venueowner_id')

                # Keyword
                if "keyword" in serializer.validated_data:
                    serializer.validated_data['template_name__icontains'] = serializer.validated_data['keyword']
                    serializer.validated_data.pop("keyword")

                if "assortment" in request.data:
                    assortment = serializer.validated_data['assortment']
                    serializer.validated_data.pop('assortment')
                    data = ScheduleTemplateStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at").order_by(assortment)
                else:
                    data = ScheduleTemplateStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at")

                serializer = self.serializer_class(data, many=True)
                response["result"] = 1
                response['data'] = serializer.data
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
