from django.urls import path, include
from .views import *

admin_urls = [
    path('venueowner_autofill', VenueOwnerAutoFillAPIView.as_view()),
    path('venueowner_list', VenueOwnerListInfoAPIView.as_view()),

    path('venueowner_crm', VenueOwnerCRMAPIView.as_view()),  # CRM

    # Get Venue owner information
    path('venueowner_info', VenueOwnerInfoAPIView.as_view()),
    # Edit venue owner Information
    path('venueowner_edit', VenueOwnerEditInfoAPIView.as_view()),
    # Get Venue Field Information
    path('field_info_get', VenueOwnerFieldInfoGetAPIView.as_view()),
    path('add_field', AddFieldAPIView.as_view()),  # Add field
    path('update_field', UpdateFieldAPIView.as_view()),  # Update field
    path('add_contact_info', AddContactInfoAPIView.as_view()),  # Add Contact Info
    # Add Contact Info
    path('delete_contact_info', DeleteContactInfoAPIView.as_view()),

    path('approvals', ApprovalsAPIView.as_view()),  # Get Onboard Forms
    path('get_approvals_id', ApprovalsByIDAPIView.as_view()),

    # Approve or reject Onboard API
    path("change_status", ChangeApprovalAPIView.as_view()),

    # Get message of all venue owners.
    path("get_messages", GetMessageAPIView.as_view()),
    # Get Specific Message
    path("message_details", GetMessageDetailsAPIView.as_view()),
    # Send message of all venue owners.
    path("compose_messages", AdminComposeMessageAPIView.as_view()),
    # Send message of all venue owners.
    path("delete_message", DeleteMessageAPIView.as_view()),

    # Get All venue fields.
    path("get_venues", VenueApprovalsAPIView.as_view()),
    # Change status of the fields
    path("approve_venues", VenueChangeStatusAPIView.as_view()),
    # Change status of the fields
    path("status_venues", VenueStatusApprovalAPIView.as_view()),
    path('get_venue_id', VenueFieldByIDAPIView.as_view()),  # Get Field By ID

    # Get All venue fields.
    path("get_campaign", CampaignApprovalsAPIView.as_view()),
    # Change status of the fields
    path("status_campaign", CampaignStatusApprovalAPIView.as_view()),
    # Change status of the fields
    path("approve_campaign", CampaignChangeStatusAPIView.as_view()),
    path('get_campaign_id', CampaignByIDAPIView.as_view()),

    # Get  Professional Service
    path("status_professional", GetProfessionalServicesAPIView.as_view()),
    # Change status of the Professional Service
    path("approve_professional", ProfessionalChangeStatusAPIView.as_view()),
    path('get_professional_id', ProfessionalByIDAPIView.as_view()),

    path('packages_admin/get', AdminPackagesGETAPIView.as_view()),
    path("status_packages", PackageChangeStatusAPIView.as_view()),
    path("delete_package", DeletePackageAPIView.as_view()),

    path('delete_field_image', DeleteFieldImage.as_view()),

    path('venueowner_statistics', VenueOwnerStatisticsAPIView.as_view()),

    path('update/contact_person', VenueOwnerContactPersonEditInfoAPIView.as_view()),

    path('venueowner_venue_fields', VenueOwnerVenueFieldAPIView.as_view()),
    path('venueowner_filter_list', VenueOwnerListAPIView.as_view()),
    path('venueowner_id', VenueOwnerIdAPIView.as_view()),
    path('admin_venueowner_createprofile',
         AdminVenueOwnerPOSTAPIView.as_view()),

    path('venue_photo_all_services/post',
         VenuePhotoAndAllServicesAPIView.as_view()),

    path('venue_photo_all_services/get',
         VenueGetPhotoAndAllServicesAPIView.as_view()),

    path('delete_venue_image', DeleteVenueImage.as_view()),

    path('packages_all/post', AdminPackagesPostAPIView.as_view()),

    path('packages_get_filter/get', AdminPackagesGETAPIView.as_view()),

    path('all_services/post', AdminProfileServiceSerializerAPIView.as_view()),
    path('paid_services/post', AdminPaidServicesPOSTAPIView.as_view()),
    path('delete_venue_field_id', DeleteVenueFieldIdAPIView.as_view()),

    path('admin_packages_filter/get',
         AdminNewPackagesGetAndFiltersAPIView.as_view()),


    path('admin_venuefield_service/post',
         AdminVenueFieldPOSTServicesSerializerAPIView.as_view()),

    path('admin_venue_paid_service/get',
         AdminVenueOwnerPaidServiceGETAPIView.as_view()),

    path('admin_venue_service_venue/post',
         AdminVenuePOSTServicesSerializerAPIView.as_view()),

    path('admin_venue_field_paid_service/get',
         AdminVenueFieldPaidServiceGETAPIView.as_view()),

    path('admin_field_info/get',
         AdminVenueFieldGETInfoAPIView.as_view()),

    path('document/list', DocumentListAPIView.as_view()),
    path('document/add', DocumentAddAPIView.as_view()),
    path('delete_document', DocumentDeleteAPIView.as_view()),
    path('prof_filter', ProfessionalsListAPIView.as_view()),
    path('adv_filter', AdvertiserListAPIView.as_view()),

    # Schedule Template
    path('admin_schedule_template/get',
         AdminTemplateListLISTGETAPIView.as_view()),

    path('admin_schedule_template/delete',
         AdminTemplateListLISTDELETEAPIView.as_view()),

    path('admin_schedule_template1/post',
         AdminScheduleTemplate1APIView.as_view()),

    path('admin_schedule_template1/get',
         AdminScheduleTemplate1GETAPIView.as_view()),

    path('admin_schedule_template1/update',
         AdminScheduleTemplate1UPDATEAPIView.as_view()),

    path('admin_schedule_template/without_pagination',
         AdminTemplateListLISTWithoutPaginationGETAPIView.as_view()),

    # Schedule
    path('admin_schedule/get', AdminScheduleListGETAPIView.as_view()),

    path('admin_schedule/delete', AdminScheduleListDELETEAPIView.as_view()),

    path('admin_schedule_data/get', AdminScheduleGETTableAPIView.as_view()),

    path('admin_schedule_data/post', AdminSchedulePOSTTableAPIView.as_view()),

    path('admin_schedule_data/edit1', AdminGetSchedule1.as_view()),

    path('admin_schedule_data/editOnlyHour',
         AdminEditScheduleOnlyHours.as_view()),

    path('admin_schedule_data/editAll', AdminEditScheduleAll.as_view()),

    path('admin_static_fields/get', AdminGetFieldsAPIView.as_view()),

    # Campaign
    path('admin_part1/get', AdminCampaignPart1GETAPIView.as_view()),

    path('admin_part1/post', AdminCampaignPart1POSTAPIView.as_view()),

    path('admin_part2/get', AdminCampaignPart2GETAPIView.as_view()),

    path('admin_part2/post', AdminCampaignPart2POSTAPIView.as_view()),

    path('admin_get_player_list', AdminGetPlayerListAPIView.as_view()),

    path('admin_part3_email/get', AdminCampaignPart3GETEmailAPIView.as_view()),

    path('admin_part3_email/post', AdminCampaignPart3POSTEmailAPIView.as_view()),

    path('admin_part3_sms/get', AdminCampaignPart3GETSMSAPIView.as_view()),

    path('admin_part3_sms/post', AdminCampaignPart3POSTSMSAPIView.as_view()),

    path('admin_part3_banner/get', AdminCampaignPart3GETBannerAPIView.as_view()),

    path('admin_part3_banner/post', AdminCampaignPart3POSTBannerAPIView.as_view()),

    path('admin_part4/get', AdminCampaignPart4GETAPIView.as_view()),

    path('admin_part4/post', AdminCampaignPart4POSTAPIView.as_view()),

    path('admin_part5/post', AdminCampaignSummaryAPIView.as_view()),

    path('admin_campaign_list/get', AdminCampaignListLISTGET.as_view()),

    path('admin_campaign_list/delete', AdminCampaignListLISTDELETE.as_view()),

    path('admin_global_campaign/get', AdminGlobalCampaignAPIView.as_view()),

    path('admin_geofilter', AdminGeoFilterApi.as_view()),
    path('all_venue/get', AdminGetAllVenueAPIView.as_view()),

    # booking cancellation
    path('booking_cancel_approval_filter/get',
         BookingCancellationApprovalFilterAPIView.as_view()),
    path('booking_cancel_id/get', BookingCancelGetAPIView.as_view()),
    path('booking_cancel_change_status',
         BookingCancelChangeApproveStatusAPIView.as_view()),
    path('booking_cancel_reason/delete',
         DeleteCancellationReasonAPIView.as_view()),
    path('booking_cancel_reason/get',
         GetSingleCancellationReasonAPIView.as_view()),
    path('booking_cancel_reason_save_edit',
         CancellationReasonSaveEditInfoAPIView.as_view()),
    path('cancellation_policy/edit', CancellationPolicyEditInfoAPIView.as_view()),
    path('cancellation_policy/post', CancellationPolicySaveInfoAPIView.as_view()),
    path('cancellation_policy/delete', DeleteCancellationPolicyAPIView.as_view()),
    path('cancellation_policy_getAll', CancellationPolicyGetAllAPIView.as_view()),
    path('cancellation_policy/get', GetSingleCancellationPolicyAPIView.as_view()),
    path('cancellation_policy_no_pagination/getAll',
         CancellationPolicyWithoutPaginationGetAllAPIView.as_view()),
    path('collaboration_types_getAll', CollaborationTypesGetAllAPIView.as_view()),
    path('collaboration_types/delete', DeleteCollaborationTypesAPIView.as_view()),
    path('collaboration_types_save_edit',
         CollaborationTypesSaveEditInfoAPIView.as_view()),
    path('collaboration_types/get', GetSingleCollaborationTypesAPIView.as_view()),

    path('adminbookingCancelRequest/post',
         AdminBookingCancellationRequestPOSTAPIView.as_view()),
    path('adminbookingCancelFilter/get',
         AdminBookingCancellationFilterAPIView.as_view()),
    path('adminbookingCanceledit/post',
         AdminBookingCancellationRequestEditAPIView.as_view()),


    # Covid19Measures
    path('Covid19Measures_save_edit',
         Covid19MeasuresSaveEditInfoAPIView.as_view()),
    path('Covid19Measures/getAll', Covid19MeasuresGetAllAPIView.as_view()),
    path('Covid19Measures/delete', DeleteCovid19MeasuresAPIView.as_view()),
    path('Covid19Measures_withoutpage/getAll',
         Covid19MeasuresGetAllWithoutPageAPIView.as_view()),

    # Professional profile info
    path('admin_profile', AdminGetProfessionalAPIView.as_view()),
    path('admin_profile/add', AdminPOSTProfessionalAPIView.as_view()),

    path('admin_service_info_data', AdminServiceInfoDataAPIView.as_view()),
    path('admin_certificate', AdminCertificateAPIView.as_view()),
    path('admin_certificate/post', AdminPostCertificateAPIView.as_view()),
    path('admin_delete_certificate', AdminCertificateDeleteAPIView.as_view()),
    path('admin_add_skills', AdminRequestSkillAPIView.as_view()),
    path('admin_skills_select', AdminSkillsSelectAPIView.as_view()),

    # Create profile
    path('admin_prof_create_profile/add',
         AdminCreatePOSTProfessionalAPIView.as_view()),
    path('admin_adver_create_profile/post',
         AdminCreateProfileAdvertiserPOSTProfileAPIView.as_view()),


    path('sms_setup_fee/get',
         SmsSetupFeeGetAPIView.as_view()),
    path('sms_setup_fee/post',
         SmsSetupFeePostAPIView.as_view()),
    path('sms_packages/get',
         SmsPackagesGetAPIView.as_view()),
    path('sms_packages/post',
         SmsPackagesPOSTAPIView.as_view()),
    path('sms_packages/edit',
         SmsPackagesEDITAPIView.as_view()),
    path('sms_packages/delete',
         SmsPackagesDeleteAPIView.as_view()),
    path('sms_packages_id/get',
         GetSingleSmsPackagesAPIView.as_view()),


    path('email_setup_fee/get',
         EmailSetupFeeGetAPIView.as_view()),
    path('email_setup_fee/post',
         EmailSetupFeePostAPIView.as_view()),
    path('email_packages/get',
         EmailPackagesGetAPIView.as_view()),
    path('email_packages/post',
         EmailPackagesPOSTAPIView.as_view()),
    path('email_packages/edit',
         EmailPackagesEDITAPIView.as_view()),
    path('email_packages/delete',
         EmailPackagesDeleteAPIView.as_view()),
    path('email_packages_id/get',
         GetSingleEmailPackagesAPIView.as_view()),


    path('banner_setup_fee/get',
         BannerSetupFeeGetAPIView.as_view()),
    path('banner_setup_fee/post',
         BannerSetupFeePostAPIView.as_view()),


    path('paid_ads_setup_fee/get',
         PaidAdsSetupFeeGetAPIView.as_view()),
    path('paid_ads_setup_fee/post',
         PaidAdsSetupFeePostAPIView.as_view()),
    path('paid_ads_views_packages/get',
         PaidAdsViewsPackagesGetAPIView.as_view()),
    path('paid_ads_views_packages/post',
         PaidAdsViewsPackagesPOSTAPIView.as_view()),
    path('paid_ads_views_packages/edit',
         PaidAdsViewsPackagesEDITAPIView.as_view()),
    path('paid_ads_views_packages/delete',
         PaidAdsViewsPackagesDeleteAPIView.as_view()),
    path('paid_ads_views_packages_id/get',
         GetSinglePaidAdsViewsPackagesAPIView.as_view()),


    path('create_order/post', CreateOrderPaymentApiView.as_view()),
    path('transaction/post', TransactionCheck.as_view()),

    # Reqeust Service
    path('request-services', ProfessionalRequestServiceAPIView.as_view()),
    path('request-skills', ProfessionalRequestSkillsAPIView.as_view()),

    # Package Types
    path('package_types/post_edit', PackageTypesPostAndEditAPIView.as_view()),
    path('package_types/get', PackageTypesGetAPIView.as_view()),
    path('package_types/delete', PackageTypesDeleteAPIView.as_view()),
    path('package_types_id/get', GetSinglePackageTypesAPIView.as_view()),

    # Levels
    path('player_level', PlayerLevelAPIView.as_view()),
    path('team_level', TeamLevelAPIView.as_view()),

    # Package Durations
    path('package_durations/post_edit',
         PackageDurationsPostAndEditAPIView.as_view()),
    path('package_durations/get', PackageDurationsGetAPIView.as_view()),
    path('package_durations/delete', PackageDurationsDeleteAPIView.as_view()),
    path('package_durations_id/get', GetSinglePackageDurationsAPIView.as_view()),

    # Sports
    path('sports/post', SportsPostAPIView.as_view()),
    path('sports/get', AdminSportsGetAPIView.as_view()),
    path('sports/edit', SportsEditAPIView.as_view()),
    path('sports/delete', SportDeleteAPIView.as_view()),
    path('sports_id/get', GetSingleSportAPIView.as_view()),

    # Winter Sports
    path('winter_sports/post', WinterSportsPostAPIView.as_view()),
    path('winter_sports/get', WinterSportsGetAPIView.as_view()),

    # Summer Sports
    path('summer_sports/post', SummerSportsPostAPIView.as_view()),
    path('summer_sports/get', SummerSportsGetAPIView.as_view()),

    # All Seasons Sports
    path('allseasons_sports/post', AllSeasonsSportsPostAPIView.as_view()),
    path('allseasons_sports/get', AllSeasonsSportsGetAPIView.as_view()),

    # Field Types
    path('field_types/post', FieldTypesPostAPIView.as_view()),
    path('field_types/get', AllFieldTypesGetAPIView.as_view()),
    path('field_types/edit', FieldTypeEditAPIView.as_view()),
    path('field_types/delete', FieldTypeDeleteAPIView.as_view()),
    path('field_types_id/get', GetSingleFieldTypeAPIView.as_view()),


    # Floor Types
    path('floor_types/post', FloorTypesPostAPIView.as_view()),
    path('floor_types/get', AllFloorTypesGetAPIView.as_view()),
    path('floor_types/edit', FloorTypeEditAPIView.as_view()),
    path('floor_types/delete', FloorTypeDeleteAPIView.as_view()),
    path('floor_types_id/get', GetSingleFloorTypeAPIView.as_view()),

    # Facility Types
    path('facility_types/post', FacilityTypesPostAPIView.as_view()),
    path('facility_types/get', AllFacilityTypesGetAPIView.as_view()),
    path('facility_types/edit', FacilityTypeEditAPIView.as_view()),
    path('facility_types/delete', FacilityTypeDeleteAPIView.as_view()),
    path('facility_types_id/get', GetSingleFacilityTypeAPIView.as_view()),

    # Lights Types
    path('lights/post', LightsPostAPIView.as_view()),
    path('lights/get', AllLightsGetAPIView.as_view()),


    # Availability_in_use
    path('availability_in_use/post', AVAILABILITY_IN_USEPostAPIView.as_view()),
    path('availability_in_use/get', AllAVAILABILITY_IN_USEGetAPIView.as_view()),

     # Professional
    path('professional-document', ProfessionalDegreesAPIView.as_view()),
    path('professional-certificate', ProfessionalCertificateAPIView.as_view()),
    path('professional-profile', ProfessionalProfileAPIView.as_view()),
    path('professional-service-info', ProfessionalServiceInfoProfileAPIView.as_view()),
    path('professional-skills', ProfessionalYourSkillsProfileAPIView.as_view()),
    path('professional-certificate-stepper', ProfessionalYourCertificatesAPIView.as_view()),
    path('professional-contract', ProfessionalConListView.as_view()),
    path('professional-contract/<int:pk>', ProfessionalConDetailView.as_view()),



]

urlpatterns = [
    path('', include(admin_urls)),
]
