# Generated by Django 2.2 on 2021-10-17 05:59

import advertisers.models
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Advertiser',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(help_text='user first name', max_length=100, null=True)),
                ('middle_name', models.CharField(blank=True, help_text='user middle name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='user last name', max_length=100, null=True)),
                ('email', models.CharField(blank=True, help_text='user email', max_length=100, null=True)),
                ('new_email', models.CharField(blank=True, help_text='user new email', max_length=100, null=True)),
                ('business_name', models.CharField(blank=True, help_text='user buisness name', max_length=100, null=True)),
                ('buisness_type', models.CharField(blank=True, help_text='user buisness Type', max_length=100, null=True)),
                ('buisness_vat', models.CharField(blank=True, help_text='user buisness vat', max_length=100, null=True)),
                ('buisness_tax_office', models.CharField(blank=True, help_text='user buisness Tax office', max_length=100, null=True)),
                ('mobile', models.CharField(blank=True, help_text='user mobile number', max_length=15, null=True)),
                ('new_mobile', models.CharField(blank=True, help_text='user new mobile number', max_length=10, null=True)),
                ('telephone', models.CharField(blank=True, max_length=15, null=True)),
                ('telephone2', models.CharField(blank=True, max_length=15, null=True)),
                ('gender', models.CharField(choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('address1', models.CharField(blank=True, help_text='Apartment, Suite, Unit, building, floor,etc.', max_length=150, null=True)),
                ('address2', models.CharField(blank=True, help_text='Street & Number, P.O.box c/o', max_length=150, null=True)),
                ('profile', models.TextField(blank=True, null=True)),
                ('user_code', models.CharField(blank=True, max_length=6, null=True)),
                ('pincode', models.CharField(blank=True, help_text='code', max_length=10, null=True)),
                ('image', models.ImageField(blank=True, help_text='Profile image', null=True, upload_to='advertiser_images', validators=[advertisers.models.validate_image])),
                ('dob', models.DateField(blank=True, help_text='date of birth format YYYY-MM-DD', null=True, verbose_name='date of birth')),
                ('is_deleted', models.BooleanField(default=False, help_text='delete/restore user')),
                ('is_inactive', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.State')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Advertiser Users',
                'db_table': 'advertiser_user',
                'unique_together': {('user', 'email')},
            },
        ),
        migrations.CreateModel(
            name='AdvertiserDailyTiming',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, help_text='Start time', null=True)),
                ('end_time', models.TimeField(blank=True, help_text='Start time', null=True)),
                ('is_active', models.BooleanField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now=True, null=True)),
                ('advertiser', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='advertisers.Advertiser')),
                ('day', models.ForeignKey(blank=True, help_text='Day', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.DayofWeek')),
            ],
        ),
    ]
