from django.contrib import admin
from nested_admin import NestedModelAdmin
from .models import *
# Register your models here.

admin.site.register(CampaignPart2)
admin.site.register(CampaignPart3)
admin.site.register(CampaignPart4)
admin.site.register(CampaignNotificationTime)


@admin.register(CampaignPart1)
class CampaignPart1Admin(NestedModelAdmin):
    model = CampaignPart1
    list_display = ['id', 'name', 'email', 'sms',
                    'banner', 'paid_ads', 'start_date', 'end_date', 'completed', 'created_by']


@admin.register(ViewsPackage)
class ViewsPackageAdmin(NestedModelAdmin):
    model = ViewsPackage
    list_display = ['id', 'start_view', 'end_view', 'cost', 'is_deleted']


@admin.register(ClicksPackage)
class ClicksPackageAdmin(NestedModelAdmin):
    model = ClicksPackage
    list_display = ['id', 'start_click', 'end_click', 'cost', 'is_deleted']


@admin.register(SmsSetupFee)
class SmsSetupFeeAdmin(NestedModelAdmin):
    model = SmsSetupFee
    list_display = ['id', 'code', 'description', 'price',
                    'measurement_units', 'vat', 'is_deleted', 'created_at']



@admin.register(UniqueCode)
class UniqueCodeAdmin(NestedModelAdmin):
    model = UniqueCode
    list_display = ['id','code', 'is_deleted', 'created_at']



@admin.register(SmsPackages)
class SmsPackagesAdmin(NestedModelAdmin):
    model = SmsPackages
    list_display = ['id','code',  'description', 'sms_qty_from', 'sms_qty_to', 'price',
                    'measurement_units', 'vat', 'is_deleted', 'created_at']


@admin.register(EmailSetupFee)
class EmailSetupFeeAdmin(NestedModelAdmin):
    model = EmailSetupFee
    list_display = ['id', 'code', 'description', 'price',
                    'measurement_units', 'vat', 'is_deleted', 'created_at']


@admin.register(EmailPackages)
class EmailPackagesAdmin(NestedModelAdmin):
    model = EmailPackages
    list_display = ['id','code',  'description', 'email_qty_from', 'email_qty_to', 'price',
                    'measurement_units', 'vat', 'is_deleted', 'created_at']


@admin.register(BannerSetupFee)
class BannerSetupFeeAdmin(NestedModelAdmin):
    model = BannerSetupFee
    list_display = ['id', 'code', 'description', 'price',
                    'measurement_units', 'vat', 'is_deleted', 'created_at']


@admin.register(PaidAdsSetupFee)
class PaidAdsSetupFeeAdmin(NestedModelAdmin):
    model = PaidAdsSetupFee
    list_display = ['id', 'code', 'description', 'price',
                    'measurement_units', 'vat', 'is_deleted', 'created_at']


@admin.register(PaidAdsViewsPackages)
class EmailPackagesAdmin(NestedModelAdmin):
    model = EmailPackages
    list_display = ['id', 'code', 'description', 'view_qty_from', 'view_qty_to', 'price',
                    'measurement_units', 'vat', 'low_limit_notification', 'is_deleted', 'created_at']
