# Generated by Django 2.2 on 2021-10-17 05:59

import campaigns.models
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('venues', '0001_initial'),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='CampaignPart1',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('email', models.BooleanField(default=False)),
                ('sms', models.BooleanField(default=False)),
                ('banner', models.BooleanField(default=False)),
                ('paid_ads', models.BooleanField(default=False)),
                ('start_date', models.DateField(blank=True, help_text='Start Date', null=True)),
                ('end_date', models.DateField(blank=True, help_text='End Date', null=True)),
                ('status', models.CharField(blank=True, choices=[('A', 'Accepted'), ('R', 'Rejected'), ('O', 'On Hold')], default='O', help_text='Is document Verified', max_length=10, null=True)),
                ('comment', models.TextField(blank=True, null=True)),
                ('order_code', models.CharField(blank=True, max_length=100, null=True)),
                ('payment_status', models.CharField(blank=True, choices=[('F', 'Failed'), ('S', 'Success')], default='F', help_text='Payment Status', max_length=10, null=True)),
                ('completed', models.BooleanField(default=False)),
                ('cost', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueField')),
            ],
            options={
                'verbose_name_plural': 'Campaign Part1',
                'db_table': 'campaign_part1',
            },
        ),
        migrations.CreateModel(
            name='ClicksPackage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('cost', models.IntegerField(blank=True, help_text='cost', null=True)),
                ('start_click', models.IntegerField(blank=True, null=True)),
                ('end_click', models.IntegerField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
            ],
            options={
                'verbose_name_plural': 'Clicks Package',
                'db_table': 'clicks_package',
            },
        ),
        migrations.CreateModel(
            name='UniqueCode',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=6, null=True, unique=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Unique Codes',
                'db_table': 'unique_code',
            },
        ),
        migrations.CreateModel(
            name='ViewsPackage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('cost', models.IntegerField(blank=True, help_text='cost', null=True)),
                ('start_view', models.IntegerField(blank=True, null=True)),
                ('end_view', models.IntegerField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
            ],
            options={
                'verbose_name_plural': 'Views Package',
                'db_table': 'views_package',
            },
        ),
        migrations.CreateModel(
            name='SmsSetupFee',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('measurement_units', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'SMS Setup Fee',
                'db_table': 'sms_setup_fee',
            },
        ),
        migrations.CreateModel(
            name='SmsPackages',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('sms_qty_from', models.IntegerField(blank=True, null=True)),
                ('sms_qty_to', models.IntegerField(blank=True, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('code', models.ForeignKey(blank=True, help_text='Code', null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.UniqueCode')),
                ('measurement_units', models.ForeignKey(blank=True, help_text='measurement units id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, help_text='vat id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'SMS Packages',
                'db_table': 'sms_package',
            },
        ),
        migrations.CreateModel(
            name='PaidAdsViewsPackages',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('view_qty_from', models.IntegerField(blank=True, null=True)),
                ('view_qty_to', models.IntegerField(blank=True, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('low_limit_notification', models.IntegerField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('measurement_units', models.ForeignKey(blank=True, help_text='measurement units id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, help_text='vat id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'PAIDADS Views Packages',
                'db_table': 'paid_ads_views_package',
            },
        ),
        migrations.CreateModel(
            name='PaidAdsSetupFee',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('code', models.ForeignKey(blank=True, help_text='Code', null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.UniqueCode')),
                ('measurement_units', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'PAIDADS Setup Fee',
                'db_table': 'paid_ads_setup_fee',
            },
        ),
        migrations.CreateModel(
            name='EmailSetupFee',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('measurement_units', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'EMAIL Setup Fee',
                'db_table': 'email_setup_fee',
            },
        ),
        migrations.CreateModel(
            name='EmailPackages',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('email_qty_from', models.IntegerField(blank=True, null=True)),
                ('email_qty_to', models.IntegerField(blank=True, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('code', models.ForeignKey(blank=True, help_text='Code', null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.UniqueCode')),
                ('measurement_units', models.ForeignKey(blank=True, help_text='measurement units id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, help_text='vat id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'EMAIL Packages',
                'db_table': 'email_package',
            },
        ),
        migrations.CreateModel(
            name='CampaignPart4',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('campaign_purpose', models.CharField(blank=True, choices=[('INFORMATIVE', 'INFORMATIVE'), ('DISCOUNT', 'DISCOUNT')], help_text='Campaign Purpose', max_length=100, null=True)),
                ('discount', models.IntegerField(help_text='discount percentage', null=True)),
                ('discount_code', models.CharField(blank=True, help_text='Discount coupon code', max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('campaign1', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignPart1')),
                ('clicks', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.ClicksPackage')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('discount_applied_field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='venues.VenueField')),
                ('views', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.PaidAdsViewsPackages')),
            ],
            options={
                'verbose_name_plural': 'Campaign Part4',
                'db_table': 'campaign_part4',
            },
        ),
        migrations.CreateModel(
            name='CampaignPart3',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('emailBody', models.TextField(blank=True, max_length=600)),
                ('email_logo', models.ImageField(blank=True, null=True, upload_to='Campaign', validators=[campaigns.models.validate_logo])),
                ('email_background', models.ImageField(blank=True, null=True, upload_to='Campaign', validators=[campaigns.models.validate_email_background])),
                ('email_url', models.TextField(blank=True, help_text='3rd party link', max_length=800, null=True)),
                ('sms_text', models.TextField(blank=True, max_length=80)),
                ('sms_url', models.TextField(blank=True, help_text='3rd party link', max_length=800, null=True)),
                ('banner_text', models.TextField(blank=True, max_length=30)),
                ('banner_background', models.ImageField(blank=True, null=True, upload_to='Campaign', validators=[campaigns.models.validate_banner_background])),
                ('banner_logo', models.ImageField(blank=True, null=True, upload_to='Campaign', validators=[campaigns.models.validate_logo])),
                ('banner_url', models.TextField(blank=True, help_text='3rd party link', max_length=800, null=True)),
                ('subject_line', models.TextField(blank=True, max_length=600)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('campaign1', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignPart1')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Campaign Part3',
                'db_table': 'campaign_part3',
            },
        ),
        migrations.CreateModel(
            name='CampaignPart2',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('notification', models.CharField(help_text='A - All, V - venue owners, P - Players, F -Professional', max_length=4, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('Areas', models.ManyToManyField(blank=True, to='static_data.Area')),
                ('campaign1', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignPart1')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='Created_by', to=settings.AUTH_USER_MODEL)),
                ('professional_service', models.ManyToManyField(blank=True, to='static_data.Profession')),
                ('sports', models.ManyToManyField(blank=True, to='static_data.Sport')),
                ('user_notification', models.ManyToManyField(blank=True, related_name='Personalized_message', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Campaign Part2',
                'db_table': 'campaign_part2',
            },
        ),
        migrations.CreateModel(
            name='CampaignNotificationTime',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(blank=True, help_text='Date YYYY-MM-DD', null=True)),
                ('time', models.TimeField(blank=True, help_text='Time HH:MM', null=True)),
                ('campaign1', models.ForeignKey(help_text='Campaign 1 ID', on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignPart1')),
            ],
            options={
                'verbose_name_plural': 'Campaign Notifications',
                'db_table': 'campaign_notification',
            },
        ),
        migrations.CreateModel(
            name='CampaignBannerQuoteRequest',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_date', models.DateField(blank=True, help_text='Start Date', null=True)),
                ('end_date', models.DateField(blank=True, help_text='End Date', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('campaign1', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignPart1')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Campaign Banner Requests',
                'db_table': 'campaign_banner_request',
            },
        ),
        migrations.CreateModel(
            name='BannerSetupFee',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('price', models.DecimalField(blank=True, decimal_places=2, default=0.0, max_digits=19, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('code', models.ForeignKey(blank=True, help_text='Code', null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.UniqueCode')),
                ('measurement_units', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeasurementUnits')),
                ('vat', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'BANNER Setup Fee',
                'db_table': 'banner_setup_fee',
            },
        ),
    ]
