from django.urls import path, include
from .views import *

campaign_urls = [
    path('part1/get', CampaignPart1GETAPIView.as_view()),
    path('part1/post', CampaignPart1POSTAPIView.as_view()),

    path('part2/get', CampaignPart2GETAPIView.as_view()),
    path('part2/post', CampaignPart2POSTAPIView.as_view()),
    path('part2/adv/post', CampaignPart2POSTAPIViewAdvertiser.as_view()),

    path('campaign-banner-request-quote', CampaignBannerQuoteRequestAPIView.as_view()),

    path('part3_email/get', CampaignPart3GETEmailAPIView.as_view()),
    path('part3_email/post', CampaignPart3POSTEmailAPIView.as_view()),

    path('part3_sms/get', CampaignPart3GETSMSAPIView.as_view()),
    path('part3_sms/post', CampaignPart3POSTSMSAPIView.as_view()),

    path('part3_banner/get', CampaignPart3GETBannerAPIView.as_view()),
    path('part3_banner/post', CampaignPart3POSTBannerAPIView.as_view()),

    path('part4/get', CampaignPart4GETAPIView.as_view()),
    path('part4/post', CampaignPart4POSTAPIView.as_view()),

    path('part5/post', CampaignSummaryAPIView.as_view()),

    path('global_campaign/get', GlobalCampaignAPIView.as_view()),

    path('payment_gateway/post', PaymentGatewayApiView.as_view()),
    path('charge_gateway/post', ChargePaymentGatewayApiView.as_view()),

    path('campaign_list/get', CampaignListLISTGET.as_view()),
    path('campaign_list/delete', CampaignListLISTDELETE.as_view()),

    path('get_player_list', GetPlayerListAPIView.as_view()),

    path('player_city_country', GetPlayerByCityCountryAPIView.as_view()),

    path('all_user_city_country', AllUsersCityCountryAPIView.as_view()),

    path('views_package', ViewsPackageAPIView.as_view()),

    path('clicks_package', ClicksPackageAPIView.as_view()),
    path('geofilter', GeoFilterApi.as_view()),

    path('create_order/post', CreateOrderPaymentApiView.as_view()),

    path('transaction/post', TransactionCheck.as_view()),

    path('paid_ads_views_package/get',
         CampaignPart4PaidAdsViewsPackagesGetAPIView.as_view()),



]
urlpatterns = [
    path('', include(campaign_urls)),
]
