from django.contrib import admin
from nested_admin import NestedModelAdmin
from .models import *


# Register your models here.
@admin.register(Document)
class DocumentAdmin(NestedModelAdmin):
    model = Document
    list_display = ['id', 'document_name', 'is_deleted', 'created_by']


@admin.register(ContactInfo)
class ContactInfoAdmin(NestedModelAdmin):
    model = ContactInfo
    list_display = ['id', 'first_name', 'last_name',
                    'email', 'gender', 'is_deleted']


@admin.register(BankInfo)
class BankInfoAdmin(NestedModelAdmin):
    model = BankInfo
    list_display = ['id', 'iban', 'bank', 'acc_holder_first_name',
                    'acc_holder_last_name', 'is_deleted']


@admin.register(OnBoardAPI)
class OnBoardAPIAdmin(NestedModelAdmin):
    model = OnBoardAPI
    search_fields = ['first_name', 'created_by']
    list_display = ['id', 'first_name', 'last_name', 'email',
                    'business_name', 'buisness_vat', 'created_by', "status"]


@admin.register(ProfileSetting)
class ProfileSettingAdmin(NestedModelAdmin):
    model = ProfileSetting
    search_fields = ['notification_name']
    list_display = ['id', 'notification_name',
                    'is_active', 'from_time', 'to_time']


@admin.register(TelephoneNumbers)
class TelephoneNumbersAdmin(NestedModelAdmin):
    model = TelephoneNumbers
    list_display = ['id', 'contact_id', 'contact_number']


@admin.register(Contact_Person)
class ContactPersonAdmin(NestedModelAdmin):
    model = Contact_Person
    list_display = ['id', 'first_name', 'last_name', 'email', 'telephone']


@admin.register(ContractTerms)
class ContractTermsAdmin(NestedModelAdmin):
    model = ContractTerms
    list_display = ['id', 'commission_fee', 'payments',
                    'collaboration_name', 'contract_terms_document', 'created_for']


# @admin.register(ContractTermsDocument)
# class ContractTermsDocumentAdmin(NestedModelAdmin):
#     model = ContractTermsDocument
#     list_display = ['id', 'document_name', 'document']


@admin.register(Platform_Update)
class Platform_UpdateAdmin(NestedModelAdmin):
    model = Platform_Update
    list_display = ['id', 'email', 'created_at']


@admin.register(Transaction)
class TransactionAdmin(NestedModelAdmin):
    model = Transaction
    list_display = ['id', 'transaction_id', 'order_code',
                    'payment_status', 'payment_done_for', 'created_by', 'created_at']
