# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('salesman', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('contenttypes', '0002_remove_content_type_name'),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='ContactInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(blank=True, max_length=50, null=True)),
                ('last_name', models.CharField(blank=True, max_length=50, null=True)),
                ('mobile', models.CharField(blank=True, max_length=20, null=True)),
                ('email', models.CharField(blank=True, max_length=50, null=True)),
                ('gender', models.CharField(choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('object_id', models.PositiveIntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'verbose_name_plural': 'Contact Info',
                'db_table': 'contactInfo',
            },
        ),
        migrations.CreateModel(
            name='Platform_Update',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('email', models.CharField(blank=True, max_length=50, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Platform Updates',
                'db_table': 'platform_updates',
            },
        ),
        migrations.CreateModel(
            name='Transaction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('transaction_id', models.CharField(blank=True, help_text='id of transaction', max_length=100, null=True)),
                ('order_code', models.CharField(blank=True, max_length=100, null=True)),
                ('payment_status', models.CharField(blank=True, choices=[('F', 'Failed'), ('S', 'Success')], default='F', help_text='Payment Status-F=Failed,S=Success', max_length=10, null=True)),
                ('payment_done_for', models.CharField(blank=True, choices=[('C', 'Campaign'), ('B', 'Booking')], help_text='C= Campaign,B=Booking', max_length=10, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Transactions',
                'db_table': 'transaction',
            },
        ),
        migrations.CreateModel(
            name='TelephoneNumbers',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('contact_number', models.CharField(blank=True, max_length=15, null=True)),
                ('contact_id', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='commonAPI.ContactInfo')),
            ],
            options={
                'verbose_name_plural': 'Telephone Numbers',
                'db_table': 'TelephoneNumber',
            },
        ),
        migrations.CreateModel(
            name='ProfileSetting',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('notification_name', models.CharField(choices=[('M', 'Messages'), ('F', 'Join Requests'), ('S', 'Schedule'), ('P', 'Platform Messages'), ('O', 'Offers')], help_text='M - Message, J - Join Requests, S - Schedule, P - Platform Messages, O - Offers', max_length=1, null=True)),
                ('is_active', models.BooleanField(default=False)),
                ('from_time', models.TimeField(blank=True, null=True)),
                ('to_time', models.TimeField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('object_id', models.PositiveIntegerField()),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'verbose_name_plural': 'Profile Settings',
                'db_table': 'profile_Setting',
            },
        ),
        migrations.CreateModel(
            name='OnBoardAPI',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(blank=True, max_length=50, null=True)),
                ('last_name', models.CharField(blank=True, max_length=50, null=True)),
                ('gender', models.CharField(choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('registeration_type', models.CharField(choices=[('A', 'Advertiser'), ('P', 'Professional'), ('V', 'Venue Owner')], help_text='V - Venue Owner, P - Professional, A - Advertiser', max_length=1, null=True)),
                ('email', models.CharField(blank=True, max_length=50, null=True)),
                ('telephone', models.CharField(blank=True, max_length=50, null=True)),
                ('telephone2', models.CharField(blank=True, max_length=50, null=True)),
                ('mobile', models.CharField(blank=True, max_length=20, null=True)),
                ('business_name', models.CharField(blank=True, max_length=50, null=True)),
                ('address', models.TextField(blank=True, max_length=100, null=True)),
                ('field_type', models.CharField(blank=True, max_length=100, null=True)),
                ('buisness_type', models.CharField(blank=True, max_length=100, null=True)),
                ('total_field', models.CharField(blank=True, max_length=50, null=True)),
                ('buisness_vat', models.CharField(blank=True, max_length=50, null=True)),
                ('comments', models.CharField(blank=True, max_length=5000, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('status', models.CharField(blank=True, choices=[('I', 'In Progress'), ('R', 'Rejected'), ('N', 'New'), ('A', 'Approve'), ('C', 'Complete')], default='N', help_text='Is document Verified', max_length=10, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('service', models.ManyToManyField(blank=True, to='static_data.Profession')),
                ('sports', models.ManyToManyField(blank=True, to='static_data.Sport')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.State')),
            ],
            options={
                'verbose_name_plural': 'Onboard API',
                'db_table': 'onboard',
            },
        ),
        migrations.CreateModel(
            name='Document',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('document_name', models.CharField(max_length=50)),
                ('document', models.FileField(blank=True, null=True, upload_to='professional_Documents')),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Documents',
                'db_table': 'Documents',
            },
        ),
        migrations.CreateModel(
            name='ContractTerms',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('commission_fee', models.TextField(blank=True, null=True)),
                ('payments', models.TextField(blank=True, null=True)),
                ('collaboration_name', models.CharField(blank=True, max_length=50, null=True)),
                ('contract_terms_document', models.FileField(blank=True, null=True, upload_to='Contract_Terms_Documents')),
                ('supervisor', models.CharField(blank=True, max_length=50, null=True)),
                ('cancellation_policy', models.ManyToManyField(blank=True, to='static_data.CancellationPolicy')),
                ('created_for', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('salesman', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='salesman.Salesman')),
            ],
            options={
                'verbose_name_plural': 'Contract Terms',
                'db_table': 'Contract_Terms',
            },
        ),
        migrations.CreateModel(
            name='Contact_Person',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(blank=True, help_text='Contact Person first name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='user last name', max_length=100, null=True)),
                ('email', models.CharField(blank=True, max_length=50, null=True)),
                ('telephone', models.CharField(blank=True, max_length=15, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('object_id', models.PositiveIntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'verbose_name_plural': 'ContactPerson',
                'db_table': 'common_contactPerson',
            },
        ),
        migrations.CreateModel(
            name='BankInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('iban', models.CharField(help_text='Bank Account Number', max_length=100)),
                ('certificate_name', models.CharField(blank=True, help_text='Certificates', max_length=100, null=True)),
                ('bank', models.CharField(help_text='Bank Name', max_length=100)),
                ('acc_holder_first_name', models.CharField(help_text='Bank Account Holder First Name', max_length=100)),
                ('acc_holder_last_name', models.CharField(blank=True, help_text='Bank Account Holder Last Name', max_length=100, null=True)),
                ('acc_type', models.CharField(blank=True, help_text='Account Type', max_length=100, null=True)),
                ('bank_identification_no', models.CharField(blank=True, help_text='Bank BIC/Sift Code', max_length=100, null=True)),
                ('iban_certificate', models.FileField(blank=True, help_text='IBAN CERTIFICATE', null=True, upload_to='pdfs/')),
                ('is_deleted', models.BooleanField(default=False, help_text='Active/Deleted Bank')),
                ('object_id', models.PositiveIntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Bank Info',
                'db_table': 'bank_info',
            },
        ),
    ]
