from django.urls import path, include
from .views import *

auth_urls = [
    path('settings', SettingAPIView.as_view()),
    path('document', DocumentAPIView.as_view()),
    path('delete_document', DocumentDeleteAPIView.as_view()),

    path('bank_info', BankAPIView.as_view()),
    path('bank_add', AddBankAPIView.as_view()),
    path('bank_update', EditBankAPIView.as_view()),
    path('bank_delete', BankDeleteAPIView.as_view()),

    path('contact_info', ContactAddEditAPIView.as_view()),
    path('contact_info/get', ContactGETAPIView.as_view()),
    path('contact_delete', DeleteContactAPIView.as_view()),
    path('contact_person/post', AddContactPersonAPIView.as_view()),

    path('country/get', CountryApiView.as_view()),
    path('city/get', CityApiView.as_view()),

    path('onboard_get', OnboardAPIView.as_view()),
    path('onboard_post', OnboardUpdateAPIView.as_view()),

    path('profile_settings/get', ProfileSettingAPIView.as_view()),
    path('profile_settings/post', ProfileSettingPOSTAPIView.as_view()),


    path('update_profile/', UpdateProfileView.as_view()),
    path("change_password", ChangePasswordAPIView.as_view()),
    path("contract_terms/post", ContractTermsSaveInfoAPIView.as_view()),
    path("contract_terms_doc/delete", DeleteContractTermDocumentAPIView.as_view()),
    path("contract_terms/get", GetSingleContractTermsAPIView.as_view()),
    path("contract_terms/edit", ContractTermsEditInfoAPIView.as_view()),
    path("contract_terms/getAll", GetAllContractTermsVenueOwnerAPIView.as_view()),

    path('platform_updates', PlatformUpdatePostAPIView.as_view()),
]

urlpatterns = [
    path('', include(auth_urls)),
]
