from django.contrib.auth import get_user_model
from django.contrib.auth.backends import ModelBackend

class EmailBackend(ModelBackend):
	""" Log in to Django user with email and password """
	@staticmethod
	def authenticate(username=None, password=None, **kwargs):
		UserModel = get_user_model()
		if username is None:
			email = kwargs.get('email', '')

		try:
			user = UserModel.objects.get(email = email)
		except UserModel.DoesNotExist:
			return None
		else:
			if user.check_password(password):
				return user