import requests
import datetime
import _thread
import tempfile

from django.db import transaction
from django.http import HttpResponse, Http404, HttpResponseNotFound

from django.core.mail import send_mail, EmailMultiAlternatives, EmailMessage

from django.template.loader import get_template 
from django.template.loader import render_to_string

from weasyprint import HTML, CSS
from django.core.files import File

import os

from field_booking.settings import BASE_DIR, PAGE_SIZE


# from field_booking.local_settings import WEBERLEADS_AUTHENTIC_KEY, WEBERLEADS_SENDER_ID
from platform_central.models import SmsCentral

def paginate(items, page):
   count      = len(items)
   page_count = count/PAGE_SIZE + 1

   page_no = int(page) - 1
   offset  = page_no * PAGE_SIZE

   return items[offset:offset+PAGE_SIZE]


def call_template_function(request, context, template, name, category):

    html_template = get_template(template)
    html = html_template.render(context).encode(encoding="utf-8")
    uri = request.build_absolute_uri()
    result = HTML(string=html, base_url=uri, encoding="utf-8").write_pdf(stylesheets=[CSS(string='body { margin: 0px !important }')])

    response = HttpResponse(content_type='application/pdf;')
    response['Content-Disposition'] = 'attachment; filename = '+ name + '_'+ category + '.pdf'
    response['Content-Transfer-Encoding'] = 'binary'
    with tempfile.NamedTemporaryFile(delete=True) as PDF:
        PDF.write(result)
        PDF.flush()
        PDF = open(PDF.name, 'rb')
        response.write(PDF.read())
        PDF.close()

    result = HTML(string=html, base_url=uri, encoding="utf-8").write_pdf(BASE_DIR +'/' + name + '_'+ category + '.pdf', stylesheets=[CSS(string='body { margin: 0px !important }')])

    open(BASE_DIR +'/' + name + '_'+ category + '.pdf', 'r')

    f = open(BASE_DIR +'/' + name + '_'+ category + '.pdf')
    myfile = File(f)

    os.remove(BASE_DIR +'/' + name + '_'+ category + '.pdf')

    return response, myfile




# @transaction.atomic
# def send_sms(mobile, message):
#     url = 'http://www.weberleads.in/http-tokenkeyapi.php?authentic-key={0}&senderid={1}&route=2&number={2}&message={3}'.format(WEBERLEADS_AUTHENTIC_KEY, WEBERLEADS_SENDER_ID, mobile, message)
#     try:
#         r = requests.get(url)
#     except:
#         corresponding_object = SmsCentral(mobile = mobile, message = message, response = r.text, url = url)
#         corresponding_object.save()
#     else:
#         corresponding_object = SmsCentral(mobile = mobile, message = message, response = r.text, url = url)
#         corresponding_object.save()

#     print('status', r.status_code)
#     print('text', r.text)
#     print('r', r)
    