"""afl_backend URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/2.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import path, include, re_path
from django.conf.urls import url

from django.views.generic.base import RedirectView

from rest_framework_swagger.views import get_swagger_view

# from utils.mail import email_verify_token, email_change_verify_token, reset_password

schema_view = get_swagger_view(title='Sports - API')
schema_view.cls.schema = None

# admin.site.site_header = 'Sports'
# admin.site.site_title  = 'Sports'


urlpatterns = [
    url(r'^jet/', include('jet.urls', 'jet')),  # Django JET URLS
    url(r'^jet/dashboard/', include('jet.dashboard.urls',
                                    'jet-dashboard')),  # Django JET dashboard URLS
    path('admin/', admin.site.urls),
    path('summernote/', include('django_summernote.urls')),
    url(r'^$', RedirectView.as_view(url='/admin/')),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
    url(r'^nested_admin/', include('nested_admin.urls')),

    re_path(r'^docs/', schema_view),

    re_path(r'^player/', include('players.urls')),
    re_path(r'^venueowner/', include('venue_owners.urls')),
    re_path(r'^venues/', include('venues.urls')),
    re_path(r'^message/', include('message.urls')),
    re_path(r'^professional/', include('professionals.urls')),
    re_path(r'^common/', include('commonAPI.urls')),
    re_path(r'^constant/', include('static_data.urls')),
    re_path(r'^reviews/', include('reviews.urls')),
    re_path(r'^campaigns/', include('campaigns.urls')),
    re_path(r'^advertisers/', include('advertisers.urls')),
    re_path(r'^auth/', include('platform_auth.urls')),
    re_path(r'^sports_admin/', include('admin_app.urls')),
    re_path(r'^homepage/', include('homepage.urls')),
    re_path(r'^salesman/', include('salesman.urls')),
    re_path(r'^invoicing/', include('invoicing.urls')),


    # url(r'^verify/email_verification_token/(?P<token>\w+)/$', email_verify_token, name="email_verify_token"),

]
