# Generated by Django 2.2 on 2021-10-17 05:59

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Partner_Sponser_Logo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('logo', models.ImageField(blank=True, help_text='Sponser Logo', null=True, upload_to='partner')),
                ('text', models.CharField(blank=True, help_text='Logo Description', max_length=100, null=True)),
                ('link', models.CharField(blank=True, help_text='Link', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Partner Sponser Logo',
                'db_table': 'partner_sponser_logo',
            },
        ),
        migrations.CreateModel(
            name='Visitor_Home',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image', models.ImageField(blank=True, help_text='Image', null=True, upload_to='homepage')),
                ('heading', models.CharField(blank=True, help_text='Heading', max_length=100, null=True)),
                ('description', models.TextField(blank=True, help_text='Description', null=True)),
                ('link', models.CharField(blank=True, help_text='Link', max_length=100, null=True)),
                ('background_colour', models.CharField(blank=True, help_text='background colour', max_length=100, null=True)),
                ('n_icon', models.FileField(blank=True, help_text='n_icons', null=True, upload_to='n_icons/')),
                ('fontColour', models.CharField(blank=True, help_text='font colour', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('user_type', models.ForeignKey(blank=True, help_text='User Type', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.UserType')),
            ],
            options={
                'verbose_name_plural': 'Visitor_Home',
                'db_table': 'visitor_home',
            },
        ),
        migrations.CreateModel(
            name='Carousel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image', models.ImageField(blank=True, help_text='Image', null=True, upload_to='homepage')),
                ('heading', models.CharField(blank=True, help_text='Heading', max_length=100, null=True)),
                ('description', models.TextField(blank=True, help_text='Description', null=True)),
                ('link', models.CharField(blank=True, help_text='Link', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('user_type', models.ForeignKey(blank=True, help_text='User Type', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.UserType')),
            ],
            options={
                'verbose_name_plural': 'Carousel',
                'db_table': 'carousel',
            },
        ),
        migrations.CreateModel(
            name='Block',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('icon', models.ImageField(blank=True, help_text='Ad Image', null=True, upload_to='homepage')),
                ('heading', models.CharField(blank=True, help_text='Heading', max_length=100, null=True)),
                ('description', models.TextField(blank=True, help_text='Description', null=True)),
                ('link', models.CharField(blank=True, help_text='Link', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('user_type', models.ForeignKey(blank=True, help_text='User Type', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.UserType')),
            ],
            options={
                'verbose_name_plural': 'Block 3',
                'db_table': 'homepage_block',
            },
        ),
        migrations.CreateModel(
            name='Advertisement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image', models.ImageField(blank=True, help_text='Ad Image', null=True, upload_to='homepage')),
                ('link', models.CharField(blank=True, help_text='Link', max_length=100, null=True)),
                ('image_type', models.CharField(choices=[('BANNER', 'Banner'), ('ADVERTISEMENT', 'Advertisement')], help_text='Banner / Advertisement', max_length=30)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('user_type', models.ForeignKey(blank=True, help_text='User Type', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.UserType')),
            ],
            options={
                'verbose_name_plural': 'Advertisement',
                'db_table': 'advertisement',
            },
        ),
    ]
