from rest_framework import serializers
from django.contrib.auth.models import User, Group
from rest_framework.authtoken.models import Token

from datetime import date

from .models import *
from static_data.serializers import *
from static_data.models import *


# class VenueProfileSerializer(serializers.ModelSerializer):
# 	id 		= serializers.IntegerField(required=False)
# 	class Meta:
# 		model  = Venue
# 		fields = '__all__'


class HomepageSerializer(serializers.Serializer):
    token = serializers.CharField(
        required=False, help_text="Token if logged in")
    user_type = serializers.CharField(
        required=True, help_text="ADVERTISER / PLAYER / PROFESSIONAL / VENUE OWNER / VISITOR")


class AdvertisementSerializer(serializers.ModelSerializer):
    user_type = serializers.CharField(source="user_type.name")

    class Meta:
        model = Advertisement
        fields = "__all__"


class CarouselSerializer(serializers.ModelSerializer):
    user_type = serializers.CharField(source="user_type.name")

    class Meta:
        model = Carousel
        fields = "__all__"


class BlockSerializer(serializers.ModelSerializer):
    user_type = serializers.CharField(source="user_type.name")

    class Meta:
        model = Block
        fields = "__all__"


class Visitor_HomeSerializer(serializers.ModelSerializer):
    user_type = serializers.CharField(source="user_type.name")

    class Meta:
        model = Visitor_Home
        fields = "__all__"


class Partner_Sponser_LogoSerializer(serializers.ModelSerializer):

    class Meta:
        model = Partner_Sponser_Logo
        fields = '__all__'
