# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='InternalUser',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(help_text='user first name', max_length=100, null=True)),
                ('middle_name', models.CharField(blank=True, help_text='user middle name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='user last name', max_length=100, null=True)),
                ('email', models.CharField(help_text='user email', max_length=100, null=True)),
                ('new_email', models.CharField(blank=True, help_text='user new email', max_length=100, null=True)),
                ('mobile', models.CharField(help_text='user mobile number', max_length=10, null=True, unique=True)),
                ('gender', models.CharField(choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('address1', models.CharField(blank=True, help_text='Apartment, Suite, Unit, building, floor,etc.', max_length=150, null=True)),
                ('address2', models.CharField(blank=True, help_text='Street & Number, P.O.box c/o', max_length=150, null=True)),
                ('profile', models.TextField(blank=True, null=True)),
                ('city', models.CharField(blank=True, help_text='city', max_length=50, null=True)),
                ('pincode', models.CharField(blank=True, help_text='code', max_length=10, null=True)),
                ('image', models.ImageField(blank=True, help_text='Profile image', null=True, upload_to='internal_user_images')),
                ('dob', models.DateField(blank=True, help_text='date of birth format YYYY-MM-DD', null=True, verbose_name='date of birth')),
                ('is_deleted', models.BooleanField(default=False, help_text='delete/restore user')),
                ('is_inactive', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='internal_system.InternalUser')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.State')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('user_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.UserType')),
            ],
            options={
                'verbose_name_plural': 'Internal System Users',
                'db_table': 'internal_system_user',
                'unique_together': {('user', 'email')},
            },
        ),
    ]
