# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='InvoiceCategories',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=50, null=True)),
                ('description', models.CharField(blank=True, help_text='Descripion', max_length=200, null=True)),
                ('price', models.FloatField(blank=True, help_text='Price', null=True)),
                ('mode', models.CharField(blank=True, choices=[('SERVICES', 'SERVICES'), ('PRODUCTS', 'PRODUCTS')], help_text='Mode', max_length=20, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('exclusive_for', models.ForeignKey(blank=True, help_text='User Type', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.UserType')),
                ('measurement_unit', models.ForeignKey(blank=True, help_text='Measurement Unit', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.MeasurementUnits')),
                ('vat_category', models.ForeignKey(blank=True, help_text='Vat Category', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.Vat')),
            ],
            options={
                'verbose_name_plural': 'Invoices Categories',
                'db_table': 'invoice_categories',
            },
        ),
        migrations.CreateModel(
            name='InvoiceDocument',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('total_disc_percent', models.FloatField(blank=True, default=0, help_text='Discount Percent', null=True)),
                ('total_disc_price', models.FloatField(blank=True, help_text='discount price', null=True)),
                ('total_net_value', models.FloatField(blank=True, help_text='Net Value', null=True)),
                ('total_vat_value', models.FloatField(blank=True, help_text='Vat Value', null=True)),
                ('total_value', models.FloatField(blank=True, help_text='Total Value', null=True)),
                ('pdf', models.FileField(blank=True, help_text='Total Value', null=True, upload_to='')),
                ('number', models.IntegerField(blank=True, help_text='Number', null=True)),
                ('date', models.DateField(blank=True, help_text='Date', null=True)),
                ('user_code', models.CharField(blank=True, help_text='User Code', max_length=199, null=True)),
                ('buisness_name', models.CharField(blank=True, help_text='Buisness Name', max_length=199, null=True)),
                ('address', models.CharField(blank=True, help_text='Address', max_length=199, null=True)),
                ('is_active', models.BooleanField(blank=True, default=False, help_text='If the Invoice is active', null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('doc_numbering_series', models.ForeignKey(blank=True, help_text='Document Numbering Series', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.DocNumberingSeries')),
                ('document_type', models.ForeignKey(blank=True, help_text='Document Type', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.DocumentType')),
                ('means_of_transport', models.ForeignKey(blank=True, help_text='Means of transport', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MeansOfTransport')),
                ('payment_method', models.ForeignKey(blank=True, help_text='Payment Method', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.PaymentMethod')),
                ('transfer_method', models.ForeignKey(blank=True, help_text='Transfer Method', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.TransferMethod')),
                ('transfer_purpose', models.ForeignKey(blank=True, help_text='Transfer Purpose', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.TransferPurpose')),
            ],
            options={
                'verbose_name_plural': 'Invoice Documents',
                'db_table': 'invoice_document',
            },
        ),
        migrations.CreateModel(
            name='InvoiceItems',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('quantity', models.IntegerField(blank=True, default=0, help_text='Quantity', null=True)),
                ('price', models.FloatField(blank=True, default=0, help_text='price', null=True)),
                ('disc_percent', models.FloatField(blank=True, default=0, help_text='Discount Percent', null=True)),
                ('disc_price', models.FloatField(blank=True, default=0, help_text='discount price', null=True)),
                ('net_value', models.FloatField(blank=True, default=0, help_text='Net Value', null=True)),
                ('vat_value', models.FloatField(blank=True, default=0, help_text='Vat Value', null=True)),
                ('total_value', models.FloatField(blank=True, default=0, help_text='Total Value', null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('invoice_category', models.ForeignKey(blank=True, help_text='Invoice Category', null=True, on_delete=django.db.models.deletion.CASCADE, to='invoicing.InvoiceCategories')),
                ('invoice_document', models.ForeignKey(blank=True, help_text='Invoice Document', null=True, on_delete=django.db.models.deletion.CASCADE, to='invoicing.InvoiceDocument')),
            ],
            options={
                'verbose_name_plural': 'Invoices Items',
                'db_table': 'invoice_item',
            },
        ),
        migrations.CreateModel(
            name='InvoiceComment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('comment', models.CharField(blank=True, help_text='Comment', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, help_text='Created By', null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('invoice_document', models.ForeignKey(blank=True, help_text='Invoice Document', null=True, on_delete=django.db.models.deletion.CASCADE, to='invoicing.InvoiceDocument')),
            ],
            options={
                'verbose_name_plural': 'Invoices Comments',
                'db_table': 'invoice_comment',
            },
        ),
    ]
