# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('contenttypes', '0002_remove_content_type_name'),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Notification',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('category', models.TextField(help_text='Notification Category', max_length=50, null=True)),
                ('subject', models.TextField(help_text='Notification Header', max_length=100, null=True)),
                ('body', models.TextField(help_text='Notification Body', max_length=100, null=True)),
                ('button_text', models.CharField(blank=True, help_text='Icon', max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_read', models.BooleanField(default=False, help_text='Unread/Read')),
                ('object_id', models.PositiveIntegerField()),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('icon', models.ForeignKey(blank=True, help_text='Icon', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.NotificationIcon')),
                ('recipient', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='NotificationReciver', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Notifications',
                'db_table': 'notifications',
            },
        ),
        migrations.CreateModel(
            name='MessagesInbox',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('message', models.TextField(help_text='Message Body', max_length=10000, null=True)),
                ('sent_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_read', models.BooleanField(default=False, help_text='Unread/Read')),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateField(auto_now=True, null=True)),
                ('recipient', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='receiver', to=settings.AUTH_USER_MODEL)),
                ('sender', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='sender', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Message Inbox',
                'db_table': 'message_storage',
            },
        ),
    ]
