from nested_admin import NestedModelAdmin
from django.contrib import admin    
from .models import *
# Register your models here.



@admin.register(UserToken)
class UserTokenAdmin(NestedModelAdmin):
    model        = UserToken
    search_fields = ['user']
    list_display = ['user', 'purpose', 'key', 'is_active','last_used','created_at','updated_at']



@admin.register(UserOtp)
class UserOtpAdmin(NestedModelAdmin):
    model        = UserOtp
    list_display = ['user', 'otp', 'valid_till', 'created_at','updated_at']




@admin.register(SmsCentral)
class SmsCentralAdmin(NestedModelAdmin):
    model        = SmsCentral
    list_display = ['mobile', 'message', 'created_at']



@admin.register(RegisterPrivateKey)
class RegisterPrivateKeyAdmin(NestedModelAdmin):
    model        = RegisterPrivateKey
    list_display = ['id', 'user', 'key','is_active','activated_at']



@admin.register(PlatformApiCall)
class PlatformApiCallAdmin(NestedModelAdmin):
    model = PlatformApiCall
    list_display = ['id','user','requested_url','requested_data','response_data','created_at']




