# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='UserToken',
            fields=[
                ('purpose', models.CharField(blank=True, choices=[('EMAIL VERIFICATION', 'EMAIL VERIFICATION'), ('EMAIL CHANGE', 'EMAIL CHANGE'), ('RESET PASSWORD', 'RESET PASSWORD')], max_length=50, null=True)),
                ('key', models.CharField(max_length=40, primary_key=True, serialize=False)),
                ('is_active', models.BooleanField(blank=True, default=True, null=True)),
                ('last_used', models.DateTimeField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='custom_token', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Platform User Tokens',
                'db_table': 'platform_user_token',
            },
        ),
        migrations.CreateModel(
            name='UserOtp',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('otp', models.CharField(blank=True, help_text="User's OTP", max_length=100)),
                ('valid_till', models.DateTimeField(blank=True, help_text='Time until when the OTP is valid', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_active', models.BooleanField(blank=True, default=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'User OTPs',
                'db_table': 'user_otp',
            },
        ),
        migrations.CreateModel(
            name='UserFcmObject',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('device_id', models.CharField(blank=True, help_text="user's device id", max_length=400, null=True)),
                ('fcm_id', models.CharField(blank=True, help_text="user's fcm id", max_length=400, null=True)),
                ('device_type', models.CharField(blank=True, help_text="user's device type", max_length=400, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'User FCM Ids',
                'db_table': 'user_fcm',
            },
        ),
        migrations.CreateModel(
            name='SmsCentral',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mobile', models.CharField(blank=True, default='', max_length=10, null=True)),
                ('message', models.CharField(blank=True, max_length=1000, null=True)),
                ('url', models.TextField(blank=True, null=True)),
                ('response', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('user_otp', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='platform_central.UserOtp')),
            ],
            options={
                'verbose_name_plural': 'Platform SMS Central',
                'db_table': 'sms_central',
            },
        ),
        migrations.CreateModel(
            name='RegisterPrivateKey',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('key', models.CharField(blank=True, help_text='Key of the User', max_length=100, null=True)),
                ('is_active', models.BooleanField(default=True, help_text='Status of the key')),
                ('activated_at', models.DateTimeField(blank=True, help_text='Time of activation', null=True)),
                ('user', models.OneToOneField(blank=True, help_text='User for the Key', null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Registeration Key',
                'db_table': 'registeration_key',
            },
        ),
        migrations.CreateModel(
            name='PlatformApiCall',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('requested_url', models.CharField(max_length=250, null=True, verbose_name='requested url')),
                ('requested_data', models.TextField(verbose_name='requested data')),
                ('response_data', models.TextField(verbose_name='response data')),
                ('client_ip_address', models.CharField(blank=True, max_length=200, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Platform API Calls',
                'db_table': 'platform_api_call',
            },
        ),
    ]
