from django.core.management.base import BaseCommand
from django.utils import timezone, tree
from players.models import *
from players.serializers import PlayerNotifyContactAvailabilityDatesSerializer
from utils.mail import player_notify_contact_email


class Command(BaseCommand):
    help = 'Schdule End Notification'

    def handle(self, *args, **kwargs):
        notify_contact_task = PlayerNotifyContactCronScheduler.objects.filter(
            is_deleted=False, status="HOLD")
        images = Template_Images.objects.filter().values('template_image')
        logo = images[0]
        logo2 = images[1]

        if notify_contact_task.count() < 1:
            self.stdout.write(self.style.NOTICE('No Record Found'))
            return 0

        for j in notify_contact_task:
            try:
                j.status = "RUNNING"
                j.save()

                to_player_user_email = j.to_player.email
                to_player_user_name = j.to_player.first_name
                from_player_user_name = j.from_player.first_name

                availability_slots = PlayerNotifyContactAvailabilityDates.objects.filter(
                    player_notify_contact=j)
                if availability_slots.exists():
                    availability_slots = PlayerNotifyContactAvailabilityDatesSerializer(
                        availability_slots, many=True).data
                else:
                    availability_slots = []

                player_notify_contact_email(
                    to_player_user_email, to_player_user_name, from_player_user_name, availability_slots, logo, logo2)

                j.status = "SUCCESS"
                # + ','.join(map(str, all_doc_type))
                j.message = "Successfully Completed. "
                j.save()
                self.stdout.write(self.style.SUCCESS('Successfully Completed'))

            except Exception as e:
                print(e)
                j.status = "FAILED"
                j.message = str(e)
                j.save()
