# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import players.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('static_data', '0001_initial'),
        ('venues', '0001_initial'),
        ('venue_owners', '0001_initial'),
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='BookMatch',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(blank=True, help_text='Date', null=True)),
                ('services_cost', models.IntegerField(blank=True, default=0, null=True)),
                ('total_cost', models.IntegerField(blank=True, default=0, null=True)),
                ('status', models.CharField(blank=True, choices=[('Upcoming', 'Upcoming'), ('Completed', 'Completed'), ('Cancelled', 'Cancelled')], help_text='Status of the match', max_length=20, null=True)),
                ('match_result', models.NullBooleanField(help_text='true for win/false for loose')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Team Book Match',
                'db_table': 'book_match',
            },
        ),
        migrations.CreateModel(
            name='NewsLetter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('email', models.CharField(blank=True, max_length=50, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'News Letter',
                'db_table': 'news_letter',
            },
        ),
        migrations.CreateModel(
            name='Player',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(help_text='user first name', max_length=100, null=True)),
                ('middle_name', models.CharField(blank=True, help_text='user middle name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='user last name', max_length=100, null=True)),
                ('nick_name', models.CharField(blank=True, help_text='user nick name', max_length=100, null=True)),
                ('email', models.CharField(help_text='user email', max_length=100, null=True)),
                ('new_email', models.CharField(blank=True, help_text='user new email', max_length=100, null=True)),
                ('mobile', models.CharField(help_text='user mobile number', max_length=15, null=True, unique=True)),
                ('new_mobile', models.CharField(blank=True, help_text='user new mobile number', max_length=15, null=True)),
                ('gender', models.CharField(choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('street', models.CharField(blank=True, help_text='Street & Number, P.O.box c/o', max_length=150, null=True)),
                ('latitude', models.FloatField(blank=True, help_text='Latitude', null=True)),
                ('longitude', models.FloatField(blank=True, help_text='Longitude', null=True)),
                ('pincode', models.CharField(blank=True, help_text='code', max_length=10, null=True)),
                ('image', models.ImageField(blank=True, null=True, storage=players.models.S3CustomStorage(), upload_to='player_images')),
                ('dob', models.DateField(blank=True, help_text='date of birth format YYYY-MM-DD', null=True, verbose_name='date of birth')),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('is_email_verified', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.State')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Players',
                'db_table': 'player',
                'unique_together': {('user', 'email')},
            },
        ),
        migrations.CreateModel(
            name='TeamDetails',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('team_name', models.TextField(blank=True, max_length=100, null=True)),
                ('perfecture', models.CharField(blank=True, help_text='Perfecture', max_length=10, null=True)),
                ('region', models.CharField(blank=True, max_length=100, null=True)),
                ('date_founded', models.DateField(blank=True, null=True)),
                ('team_image', models.ImageField(blank=True, null=True, upload_to='team_images')),
                ('admin_first_name', models.CharField(blank=True, help_text='Administrator First name', max_length=100, null=True)),
                ('admin_last_name', models.CharField(blank=True, help_text='Administrator First name', max_length=100, null=True)),
                ('player_count', models.IntegerField(blank=True, default=0, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.State')),
                ('team_level', models.ManyToManyField(blank=True, to='static_data.TeamLevel')),
            ],
            options={
                'verbose_name_plural': 'Team Details',
                'db_table': 'team_details',
            },
        ),
        migrations.CreateModel(
            name='VenuePaidServiceQuantity',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('quantity', models.IntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('book_match', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.BookMatch')),
                ('venue_service_cost', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueServiceCost')),
            ],
            options={
                'verbose_name_plural': 'Venue Paid Service Quantity',
                'db_table': 'venue_paid_service_quantity',
            },
        ),
        migrations.CreateModel(
            name='VenueListPlayer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_by', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue_list', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'VenueListPlayers',
                'db_table': 'VenueListPlayer',
            },
        ),
        migrations.CreateModel(
            name='VenueFieldServiceQuantity',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('quantity', models.IntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('book_match', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.BookMatch')),
                ('venue_field_service', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueFieldService')),
            ],
            options={
                'verbose_name_plural': 'Venue Field Service Quantity',
                'db_table': 'venue_field_service_quantity',
            },
        ),
        migrations.CreateModel(
            name='TeamMember',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('email', models.CharField(blank=True, help_text='Email address', max_length=100, null=True)),
                ('first_name', models.CharField(blank=True, help_text='First Name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='last Name', max_length=100, null=True)),
                ('status', models.CharField(blank=True, choices=[('Pending', 'Pending'), ('Approved', 'Approved'), ('Declined', 'Declined')], default='Pending', help_text='Status of the player', max_length=20, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='Deleted Status', null=True)),
                ('is_owner', models.BooleanField(blank=True, default=False, help_text='Owner of the team', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
                ('position', models.ForeignKey(blank=True, help_text='Player Position', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Position')),
                ('team_details', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.TeamDetails')),
            ],
            options={
                'verbose_name_plural': 'Team Members',
                'db_table': 'team_member',
            },
        ),
        migrations.CreateModel(
            name='TeamContacts',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.TextField(blank=True, max_length=100, null=True)),
                ('last_name', models.TextField(blank=True, max_length=100, null=True)),
                ('mobile', models.TextField(blank=True, max_length=14, null=True)),
                ('email', models.TextField(blank=True, max_length=50, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('team_details', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.TeamDetails')),
            ],
            options={
                'verbose_name_plural': 'Team Contacts',
                'db_table': 'team_contact',
            },
        ),
        migrations.CreateModel(
            name='TeamCalendar',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='Deleted Status', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('day', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.DayofWeek')),
                ('team_details', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.TeamDetails')),
            ],
            options={
                'verbose_name_plural': 'Team Calendar',
                'db_table': 'team_calendar',
            },
        ),
        migrations.CreateModel(
            name='PlayerSkills',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('level', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.PlayerLevel')),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
                ('position', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Position')),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Player Skills',
                'db_table': 'player_skills',
            },
        ),
        migrations.CreateModel(
            name='PlayerRating',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rating', models.IntegerField(default=0)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Player Rating',
                'db_table': 'player_rating',
            },
        ),
        migrations.CreateModel(
            name='PlayerOpponentSearchInterest',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('interested_for_opponent', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
            ],
            options={
                'verbose_name_plural': 'Player Opponent Interest',
                'db_table': 'player_opponent_interest',
            },
        ),
        migrations.CreateModel(
            name='PlayerNotifyContactCronScheduler',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sent_date', models.DateField(blank=True, help_text='Mail Sent date', null=True)),
                ('status', models.CharField(choices=[('HOLD', 'HOLD'), ('RUNNING', 'RUNNING'), ('SUCCESS', 'SUCCESS'), ('FAILED', 'FAILED')], default='HOLD', help_text='Status', max_length=100)),
                ('message', models.CharField(blank=True, help_text='message', max_length=200, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Schedule Slot')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('from_player', models.ForeignKey(blank=True, help_text='Player', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='from_player', to='players.Player')),
                ('to_player', models.ForeignKey(blank=True, help_text='Player', null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
            ],
            options={
                'verbose_name_plural': 'Player Notify Contacts',
                'db_table': 'player_notify_contacts',
            },
        ),
        migrations.CreateModel(
            name='PlayerNotifyContactAvailabilityDates',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(blank=True, null=True)),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('day', models.CharField(blank=True, max_length=100, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('sport', models.CharField(blank=True, max_length=100, null=True)),
                ('player_notify_contact', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.PlayerNotifyContactCronScheduler')),
            ],
            options={
                'verbose_name_plural': 'Player Notify Availability Dates',
                'db_table': 'player_notify_availability_dates',
            },
        ),
        migrations.CreateModel(
            name='PlayerMyContactsPlatform',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('email', models.CharField(help_text='user email', max_length=100, null=True)),
                ('status', models.CharField(blank=True, choices=[('Pending', 'Pending'), ('Approved', 'Approved'), ('Declined', 'Declined')], default='Pending', help_text='Status', max_length=20, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Player MyContacts Platform',
                'db_table': 'player_my_contacts_platform',
            },
        ),
        migrations.CreateModel(
            name='PlayerInvitation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('recipient', models.CharField(blank=True, help_text='Recipient Email', max_length=100, null=True)),
                ('category', models.CharField(blank=True, choices=[('Play Match', 'Play Match'), ('Join Team', 'Join Team'), ('Find Opponent', 'Find Opponent'), ('Team Request', 'Team Request'), ('Team Match', 'Team Match')], help_text='Invitation category', max_length=20, null=True)),
                ('status', models.CharField(blank=True, choices=[('Pending', 'Pending'), ('Approved', 'Approved'), ('Declined', 'Declined')], default='Pending', help_text='Status of the player', max_length=20, null=True)),
                ('sender', models.CharField(blank=True, help_text='Recipient Email', max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('object_id', models.PositiveIntegerField(blank=True, null=True)),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
            ],
            options={
                'verbose_name_plural': 'Players Invitation',
                'db_table': 'player_invitation',
            },
        ),
        migrations.CreateModel(
            name='PlayerInterest',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('interest_sports', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
            ],
            options={
                'verbose_name_plural': 'Player Interests',
                'db_table': 'player_interest',
            },
        ),
        migrations.CreateModel(
            name='PlayerAvailability',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(blank=True, help_text='YYYY-MM-DD', null=True)),
                ('start_time', models.TimeField(blank=True, help_text='HH:MM 24hrs', null=True)),
                ('end_time', models.TimeField(blank=True, help_text='HH:MM 24hrs', null=True)),
                ('public_game', models.BooleanField(blank=True, default=False, help_text='Public Game')),
                ('private_game', models.BooleanField(blank=True, default=False, help_text='Private Game')),
                ('note', models.TextField(blank=True, help_text='Note', null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('player', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player')),
                ('sport', models.ForeignKey(blank=True, help_text='Public Game', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Player Availability',
                'db_table': 'player_availability',
            },
        ),
        migrations.CreateModel(
            name='FriendList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('contacts', models.ManyToManyField(to='players.Player')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='MainUser', to='players.Player')),
            ],
            options={
                'verbose_name_plural': 'Player Contacts',
                'db_table': 'player_contacts',
            },
        ),
        migrations.AddField(
            model_name='bookmatch',
            name='created_by',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='players.Player'),
        ),
        migrations.AddField(
            model_name='bookmatch',
            name='my_team',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='my_team', to='players.TeamDetails'),
        ),
        migrations.AddField(
            model_name='bookmatch',
            name='opponent_team',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='opponent_team', to='players.TeamDetails'),
        ),
        migrations.AddField(
            model_name='bookmatch',
            name='schedule_slot',
            field=models.ManyToManyField(blank=True, to='venue_owners.Schedule_Slot'),
        ),
        migrations.AddField(
            model_name='bookmatch',
            name='sport',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport'),
        ),
        migrations.AddField(
            model_name='bookmatch',
            name='venue_field',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueField'),
        ),
    ]
