from players.models import PlayerInvitation
import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.urls import reverse
from django.db.models import Avg, Count
from django.contrib.contenttypes.models import ContentType
import random
from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated
from django.contrib.auth import login, authenticate, logout
from utils.mixins import *
from utils.api_handle_errors import handle_errors
from static_data.models import *
from message.models import Notification
from players.serializers import *
from django.db.models import Q
from players.models import Player
from venues.models import Venue, VenueImage, VenueFieldImage, VenueField, VenueServiceCost, VenueDailyTiming, \
    VenueFieldService
from venues.serializers import VenuePhotoGETSerializer, VenueFieldSerializer, VenueFieldImageSerializer, \
    VenueSAVESerializer, VenueServicesCostSerializerForPaidServices, VenueFieldPaidServiceSerializer1
from reviews.models import Review, VenueReviewAndRating
from venue_owners.models import VenueOwner, Schedule, Schedule_Slot
from venue_owners.serializers import Schedule_SlotSerializer, Schedule_SlotSummarySerializer
from django.db.models import Min

from venues.serializers import VenueFieldGETSerializer, VenueFieldServiceSerializer, VenueServicesCostSerializer, \
    VenueSerializer, VenueProfileGlobalSerializer
from reviews.serializers import ReviewGETSerializer, ReviewGETPlayerSerializer

from rest_framework import HTTP_HEADER_ENCODING
from static_data.serializers import VenueServiceSerializer
from datetime import datetime, date, timedelta
from utils.mail import invitation_send, invitation_send_to_friend


class GetVenueAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = GetVenueSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            start_count = (serializers.validated_data['page'] - 1) * 10
            end_count = start_count + 10
            serializers.validated_data.pop("page")

            extra_kwargs = {}
            assortment = None
            q = Q()

            # Extra Kwargs
            if "assortment" in serializers.validated_data:
                assortment = serializers.validated_data['assortment']
                serializers.validated_data.pop("assortment")

            if "keyword" in serializers.validated_data:
                q |= Q(name__icontains=serializers.validated_data['keyword'])
                q |= Q(
                    area__name__icontains=serializers.validated_data['keyword'])
                q |= Q(
                    city__name__icontains=serializers.validated_data['keyword'])
                q |= Q(
                    state__name__icontains=serializers.validated_data['keyword'])
                q |= Q(
                    country__name__icontains=serializers.validated_data['keyword'])
                q |= Q(
                    all_sports__name__icontains=serializers.validated_data['keyword'])
                # serializers.validated_data['name__icontains'] = serializers.validated_data['keyword']
                # extra_kwargs['name__icontains'] = serializers.validated_data['keyword']
                serializers.validated_data.pop("keyword")

            if "booking_date" in serializers.validated_data:
                booking_date = serializers.validated_data['booking_date']
                serializers.validated_data.pop("booking_date")

            if "start_time" in serializers.validated_data:
                start_time = serializers.validated_data['start_time']
                serializers.validated_data.pop("start_time")

            if "end_time" in serializers.validated_data:
                end_time = serializers.validated_data['end_time']
                serializers.validated_data.pop("end_time")
            #
            # if "distance" in serializers.validated_data:
            #     distance = serializers.validated_data['distance']
            #     serializers.validated_data.pop("distance")

            star_rating = None
            if "star_ratings" in serializers.validated_data:
                star_rating = serializers.validated_data['star_ratings']
                if (star_rating) == 0:
                    star_rating = None
                serializers.validated_data.pop("star_ratings")

            if "all_sports" in serializers.validated_data:
                if serializers.validated_data['all_sports'] == "any":
                    serializers.validated_data.pop("all_sports")
                else:
                    if Sport.objects.filter(id=serializers.validated_data["all_sports"]).exists():
                        serializers.validated_data['all_sports'] = Sport.objects.get(
                            id=serializers.validated_data['all_sports'])
                    # serializers.validated_data['all_sports__in'] = serializers.validated_data['all_sports']
                    # serializers.validated_data.pop("all_sports")

            availability = serializers.validated_data['availability']
            serializers.validated_data.pop("availability")

            # Check for schedule date & time & Sports

            schedule_obj = Schedule.objects.filter(
                Q(start_date__lte=booking_date, end_date__gte=booking_date, template__start_hour__lte=start_time,
                  template__end_hour__gte=start_time) | Q(
                    start_date__lte=booking_date, end_date__gte=booking_date, template__start_hour__gte=end_time,
                    template__end_hour__lte=end_time))
            print("query for schedule",
                  Q(start_date__lte=booking_date, end_date__gte=booking_date, template__start_hour__lte=start_time,
                    template__end_hour__gte=start_time) | Q(
                      start_date__lte=booking_date, end_date__gte=booking_date, template__start_hour__gte=end_time,
                      template__end_hour__lte=end_time))

            # schedule_obj = schedule_obj.filter(
            #     field__sport=sports, field__field_type=field_type)
            schedule_list = []

            if "price_range" in serializers.validated_data:
                price_range = serializers.validated_data['price_range']
                serializers.validated_data.pop("price_range")
                for i in schedule_obj:
                    for j in price_range:
                        start_price = j.split()[0]
                        end_price = j.split()[1]

                        if Schedule_Slot.objects.filter(schedule_id=i.id, date=booking_date,
                                                        cost__range=(start_price, end_price)).exists():
                            schedule_list.append(i)
                            print("price range list---", schedule_list)
            else:
                schedule_list = schedule_obj

            # Popular filter logincs
            if "popular_filters" in serializers.validated_data:
                popular_filters = serializers.validated_data['popular_filters']
                serializers.validated_data.pop("popular_filters")
                pass

            # Get venue ids
            venue_ids = [i.field.venue.id for i in schedule_list]
            # Get fields ids
            field_ids = [i.field.id for i in schedule_list]

            if "field_type" in serializers.validated_data:
                field_type = serializers.validated_data['field_type']
                serializers.validated_data.pop("field_type")
                venue_field_type_obj = VenueField.objects.filter(
                    field_type=field_type, is_deleted=False)
                print('venue_field_type_obj---', venue_field_type_obj)

                venue_field_type_list = []
                for i in venue_field_type_obj:
                    venue_field_type_list.append(i.venue.id)
                list1_as_set = set(venue_ids)
                intersection = list1_as_set.intersection(venue_field_type_list)
                venue_ids = list(intersection)

            if "attributes" in serializers.validated_data:
                attributes = serializers.validated_data['attributes']
                serializers.validated_data.pop("attributes")

                venue_facility_obj = VenueField.objects.filter(
                    facility_type__name__in=attributes, id__in=field_ids, is_deleted=False)
                print('venue_facility_obj---', venue_facility_obj)

                venue_lights_obj = VenueField.objects.filter(
                    lights__name__in=attributes, id__in=field_ids, is_deleted=False)
                print('venue_lights_obj---', venue_lights_obj)

                venue_list = []
                for i in venue_facility_obj:
                    venue_list.append(i.venue.id)
                for j in venue_lights_obj:
                    venue_list.append(j.venue.id)

                list1_as_set = set(venue_ids)
                intersection = list1_as_set.intersection(venue_list)
                venue_ids = list(intersection)

            if "location" in serializers.validated_data:
                location = serializers.validated_data['location']
                serializers.validated_data.pop("location")

                # Get Venue
                venue_data = Venue.objects.filter(q, id__in=venue_ids, city__in=location,
                                                  is_deleted=False, **serializers.validated_data)[start_count:end_count]
            else:
                venue_data = Venue.objects.filter(q, id__in=venue_ids,
                                                  is_deleted=False, **serializers.validated_data)[start_count:end_count]
            total_count = Venue.objects.filter(q, id__in=venue_ids,
                                               is_deleted=False, **serializers.validated_data).count()

            # venue_data = Venue.objects.filter(
            #     is_deleted=False, **serializers.validated_data, **extra_kwargs)[start_count:end_count]
            # total_count = Venue.objects.filter(
            #     is_deleted=False, **serializers.validated_data).count()
            print('venue data-->>', venue_data)

            serialized_data = VenueProfileGETSerializer(venue_data, many=True)

            map_list = []

            # Get Rating Counts & Unavailable messages
            for i in serialized_data.data:
                i['address'] = str(i['city']) + " " + str(i['street']) + \
                    " " + str(i['country']) + " " + str(i['pincode'])
                i['address'] = i['address'].replace(
                    "None", "").strip().replace(" ", ", ")

                venue_content = ContentType.objects.get_for_model(Venue)
                venue_content_to = Venue.objects.filter(
                    id=i['id'], is_deleted=False)
                venue_ratings = VenueReviewAndRating.objects.filter(venue=i['id'], is_deleted=False).values(
                    'rating').aggregate(rating=Avg('rating'))
                print(venue_ratings)

                if star_rating is not None:
                    # print(star_rating[0])
                    # print(star_rating[-1])
                    if venue_ratings['rating'] >= star_rating[0] and venue_ratings['rating'] <= star_rating[-1]:
                        responsedata.append(i)
                        i['ratings'] = venue_ratings['rating']
                    else:
                        continue
                else:
                    if venue_ratings['rating'] == None:
                        venue_ratings['rating'] = 0

                    responsedata.append(i)
                    i['ratings'] = venue_ratings['rating']

                if availability == False:
                    pass
                else:
                    # Get unavailable slots
                    field_obj = VenueField.objects.filter(
                        venue=i['id'], is_deleted=False)

                    # Check for unavailable slots
                    for j in field_obj:
                        schedule_obj = Schedule.objects.filter(
                            Q(field=j, start_date__lte=booking_date, end_date__gte=booking_date,
                              template__start_hour__lte=start_time, template__end_hour__gte=start_time) | Q(
                                field=j, start_date__lte=booking_date, end_date__gte=booking_date,
                                template__start_hour__gte=end_time, template__end_hour__lte=end_time))
                        if len(schedule_obj) > 0:
                            for k in schedule_obj:

                                # Cheking for unavailable
                                schedule_slot_object = Schedule_Slot.objects.filter(
                                    Q(schedule_id=k.id, date=booking_date, start_hour__lte=start_time,
                                      end_hour__gte=start_time) | Q(
                                        schedule_id=k.id, start_hour__gte=start_time, end_hour__lte=start_time))
                                if schedule_slot_object.exists():
                                    for l in schedule_slot_object:
                                        # Check for alternate slots
                                        if l.is_available == False:
                                            alternate_schedule_slot_object = Schedule_Slot.objects.filter(
                                                schedule_id=k.id, date=booking_date)[0:3]
                                            alternate_schedule_slot_class = GetVenueScheduleSlotSerializer(
                                                alternate_schedule_slot_object, many=True)
                                            i['error_message'] = "There is no Slot Available on " + \
                                                                 str(l.day) + " " + str(l.start_hour) + \
                                                                 "-" + \
                                                                 str(l.end_hour)
                                            i['alternate_slots'] = alternate_schedule_slot_class.data

                                            schedule_start_hour = str(
                                                l.start_hour)
                                            schedule_end_hour = str(l.end_hour)
                                            FMT = '%H:%M:%S'
                                            i['time_difference'] = (datetime.strptime(
                                                schedule_end_hour, FMT) - datetime.strptime(
                                                schedule_start_hour, FMT)) / 3600

                                        else:
                                            # Start Price ( Currently Random )

                                            value = i.get(
                                                'starting_price', None)
                                            i['starting_price'] = schedule_slot_object.aggregate(Min('cost'))[
                                                'cost__min']
                                            i['start_pp'] = schedule_slot_object.aggregate(Min('cost'))[
                                                'cost__min']

                                            schedule_start_hour = str(
                                                l.start_hour)
                                            schedule_end_hour = str(l.end_hour)
                                            FMT = '%H:%M:%S'
                                            i['time_difference'] = (datetime.strptime(
                                                schedule_end_hour, FMT) - datetime.strptime(
                                                schedule_start_hour, FMT)) / 3600

                map_list.append(
                    {"id": i['id'], "lat": i['latitude'], "lng": i['longitude'], "label": i['name'], "title": i['name'],
                     "all_services": i['all_services'], "rating": i.get('ratings', None), "available": True,
                     "starting_price": i.get('starting_price', None)})

            # sorting
            if assortment is not None:
                if assortment == "Star Rating":
                    responsedata = sorted(
                        responsedata, key=lambda x: int(x['ratings']), reverse=True)

                elif assortment == "Price Low":
                    responsedata = sorted(responsedata, key=lambda x: int(
                        x['starting_price']), reverse=False)
                #    pass nnnnn

                elif assortment == "Star and Price":
                    responsedata = sorted(
                        responsedata, key=lambda x: int(x['ratings']), reverse=True)
                    responsedata = sorted(responsedata, key=lambda x: int(
                        x['starting_price']), reverse=False)

                elif assortment == "Distance":
                    responsedata = sorted(
                        responsedata, key=lambda x: int(x['distance']), reverse=True)

                #                    pass nnnn

                else:
                    response['results'] = 0
                    response['errors'] = ['No such Assortment parameters']
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

            response['results'] = 1
            response['data'] = responsedata
            response['map_list'] = map_list
            response['total_count'] = len(responsedata)
            response['keyword'] = serializers.validated_data.get(
                "keyword", None)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetVenueMapView(PlatformAPICallMixin, generics.GenericAPIView):
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = GetVenueInMapSerializer

    def post(self, request, format=None):
        """
        Get Venue in MAP
        """
        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            venue_object = Venue.objects.filter(
                is_deleted=False, **serializers.validated_data)
            venue_class = self.serializer_class(venue_object, many=True)
            response_data = []
            venue_content = ContentType.objects.get_for_model(Venue)

            for i in venue_class.data:
                data = {"lat": i['latitude'], "lng": i['longitude'],
                        "label": i['name'], "title": i['name']}
                # get review
                venue_content_to = Venue.objects.filter(
                    id=i['id'], is_deleted=False)
                venue_ratings = Review.objects.filter(
                    rated_to_id__in=venue_content_to, rated_to_type__pk=venue_content.id, is_deleted=False).values(
                    'rating').aggregate(rating=Avg('rating'))
                data['description'] = {
                    "rating": venue_ratings, "sports": i['all_sports'], "all_services": i['all_services']}
                response_data.append(data)

            response['results'] = 1
            response['data'] = response_data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


'''
Venue Details
'''


class VenueDetailsAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = VenueDetailsSerializer

    venueProfile_class = VenueProfileGETSerializer
    venueReview_class = ReviewGETSerializer
    venueImage_class = VenuePhotoGETSerializer
    venueFields_class = VenueFieldDetailPageSerializer
    venueTiming_class = VenueTimingSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            data = []
            # Raw Data
            venue_details = Venue.objects.get(
                id=serializers.validated_data['id'], is_deleted=False)

            venue_image = VenueImage.objects.filter(
                venue=venue_details, is_deleted=False)

            venue_content = ContentType.objects.get_for_model(Venue)
            venue_content_to = Venue.objects.filter(
                id=serializers.validated_data['id'], is_deleted=False)

            venue_reviews = Review.objects.filter(
                rated_to_id__in=venue_content_to, rated_to_type__pk=venue_content.id, is_deleted=False)

            venue_fields = VenueField.objects.filter(venue=venue_details)

            venue_timing = VenueDailyTiming.objects.filter(
                venue=venue_details, is_deleted=False, is_active=True)

            # Serialized Data
            serializers_venue = self.venueProfile_class(venue_details)
            profile_data = serializers_venue.data
            profile_data['address'] = str(serializers_venue.data['street']) + " " + str(
                serializers_venue.data['city']) + " " + str(
                serializers_venue.data['country']) + " " + str(serializers_venue.data['pincode'])
            profile_data['address'] = profile_data['address'].replace(
                "None", "").strip()
            data.append({"profile": profile_data})

            serializers_timing = self.venueTiming_class(
                venue_timing, many=True)
            data.append({"timing": serializers_timing.data})

            serializers_image = self.venueImage_class(
                venue_image, many=True)
            data.append({"images": serializers_image.data})

            serializers_reviews = self.venueReview_class(
                venue_reviews, many=True)
            data.append({"reviews": serializers_reviews.data})

            # data.append({"rating": venue_reviews.values(
            #   'rating').aggregate(rating=Avg('rating'))})

            # currently static
            data.append({"rating": 3})
            serializers_fields = self.venueFields_class(
                venue_fields, many=True).data

            for i in serializers_fields:
                schedule_obj = Schedule.objects.filter(
                    is_deleted=False, field=i['id'], start_date__lte=serializers.validated_data['booking_date'],
                    end_date__gte=serializers.validated_data['booking_date'])
                if schedule_obj.count() == 0:
                    i['slots'] = ['No Slots Available']

                else:
                    for j in schedule_obj:
                        schedule_slots = Schedule_Slot.objects.filter(
                            schedule_id=j, date=serializers.validated_data['booking_date'], is_deleted=False,
                            is_available=True)[0:2]
                        if schedule_slots.count() == 0:
                            i['slots'] = ['No Slots Available']
                        else:
                            schedule_class = Schedule_SlotSummarySerializer(
                                schedule_slots, many=True)
                            i['slots'] = schedule_class.data
                # Venue Field iMages
                field_images = VenueFieldImage.objects.filter(
                    venue_field=i['id'], is_deleted=False)
                field_image_class = VenueFieldImageSerializer(
                    field_images, many=True).data
                i['images'] = field_image_class

            # for i in serializers_fields.data:
            #     schedule_obj = Schedule.objects.filter(is_deleted=False, field=i).values_list('start_hour','end_hour','')

            data.append({"fields": serializers_fields})

            venue_data = Venue.objects.filter(
                id=serializers.validated_data['id'])
            venue = venue_data.first()
            venue_serializer = VenueSerializer(venue)
            venue_services_cost = VenueServiceCost.objects.filter(
                venue=venue_serializer.data['id'])

            venue_paid_services_serializer = VenueServicesCostSerializerForPaidServices(
                venue_services_cost, many=True)
            data.append({"Paid services": venue_paid_services_serializer.data})

            # Cancellation_policy
            cancel_query_set = ""
            if ContractTerms.objects.filter(created_for=venue_details.created_by.id).exists():
                contract_obj = ContractTerms.objects.get(
                    created_for=venue_details.created_by.id)
                print(contract_obj.cancellation_policy.all())
                cancel_query_set = contract_obj.cancellation_policy.all()

            serializers_CancellationPolicy = CancellationPolicyySerializer(
                cancel_query_set, many=True)

            data.append(
                {"cancellation_policy": serializers_CancellationPolicy.data})

            response['results'] = 1
            response['data'] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


#   Get Field Details


class FieldDetailsAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = VenueFieldDetailsSerializer

    review_class = ReviewGETPlayerSerializer
    venue_field_serializer_class = VenueFieldGETSerializer
    slot_serializer_class = Schedule_SlotSerializer
    venue_service_class = VenueServiceSerializer
    venue_dailytiming_class = VenueDailyTimingSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            venue_field = VenueField.objects.filter(
                id=serializers.validated_data['id'])
            serializer_data = self.venue_field_serializer_class(
                venue_field[0]).data

            # VenueDailyTiming
            if VenueDailyTiming.objects.filter(venue=venue_field.first().venue, is_deleted=False).exists():
                venue_timing_obj = VenueDailyTiming.objects.filter(
                    venue=venue_field.first().venue, is_deleted=False)

            # Address
            venue_obj = venue_field.first().venue
            address = str(venue_obj.street) + " " + str(venue_obj.city) + \
                " " + str(venue_obj.pincode) + " " + str(venue_obj.country)
            address = address.replace("None", "").strip()

            # Venue Services
            venue_services = venue_obj.all_services.all()
            venue_class = VenueServiceSerializer(
                venue_services, many=True).data

            # venue data
            vdata = VenueProfileGlobalSerializer(venue_obj, many=False)

            # Reviews
            reviewTo_contentType = ContentType.objects.get_for_model(Venue)
            field_reviews = Review.objects.filter(
                rated_to_type__pk=reviewTo_contentType.id, rated_to_id__in=venue_field, is_deleted=False)
            review_serializer = self.review_class(field_reviews, many=True)

            # Schedule Slots
            schedule_data = Schedule.objects.filter(
                Q(field=venue_field[0], start_date__lte=serializers.validated_data.get(
                    'booking_date')) | Q(field=venue_field[0],
                                         end_date__gte=serializers.validated_data.get('booking_date')))
            slots = []
            for i in schedule_data:
                if Schedule_Slot.objects.filter(schedule_id=i,
                                                date=serializers.validated_data.get('booking_date')).exists():
                    schedule_slots = Schedule_Slot.objects.filter(
                        schedule_id=i, date=serializers.validated_data.get('booking_date'))
                    slot_serializer = self.slot_serializer_class(
                        schedule_slots, many=True)
                    slots = slots + slot_serializer.data

            # Static Data
            if len(schedule_data) == 0 or len(slots) == 0:
                slots = "No Schedule Available"
                static_data = "No Schedule Available"
            else:
                static_data = schedule_slots.aggregate(
                    slot_start_price=Min('cost'))

            # Put venue services in field services+
            serializer_data['field_service'] = venue_class

            data = {"field_data": serializer_data, "reviews": review_serializer.data,
                    "available_slots": slots, "static_data": static_data, "address": address}

            dailytiming_serializer_data = self.venue_dailytiming_class(
                venue_timing_obj, many=True).data

            data['daily_timing'] = dailytiming_serializer_data

            venue_field_services = VenueFieldService.objects.filter(
                venue_field=serializers.validated_data['id'])
            venue_paid_services_serializer = VenueFieldPaidServiceSerializer1(
                venue_field_services, many=True)
            data['venue field paid services'] = venue_paid_services_serializer.data

            data['venue'] = vdata.data

            response['results'] = 1
            response['data'] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

# Book a match steps


class GetPlayerFavVenuesFilterAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)

    def get(self, request, format=None):
        """ 
        Get Player Fav Venues Filter
        """
        response = {}
        responsedata = []

        # get Player Objects
        player_obj = Player.objects.filter(user=request.user, is_deleted=False)
        if player_obj.exists():
            player_obj = player_obj.last()
        else:
            response["result"] = 0
            response["errors"] = ["Not Authorized to perform this actino"]
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        field_obj = BookMatch.objects.filter(created_by=player_obj).order_by(
            "-created_at").values_list("venue_field__name", "venue_field__id")
        field_obj = list(set(field_obj))
        data = []
        if len(field_obj) > 0:
            for i in field_obj:
                data.append({"name": i[0], "id": i[1]})

        response["result"] = 1
        response["data"] = data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class GetFieldAutoCompleteAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = GetFieldAutoCompleteSerializer

    def post(self, request, format=None):
        """ 
        Get Field Auto Complete
        """
        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            # get Player Objects
            player_obj = Player.objects.filter(
                user=request.user, is_deleted=False)
            if player_obj.exists():
                player_obj = player_obj.last()
            else:
                response["result"] = 0
                response["errors"] = ["Not Authorized to perform this actino"]
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            venue_field_obj = VenueField.objects.filter(
                name__icontains=serializers.validated_data['keyword'], is_deleted=False)
            venue_field_class = self.serializer_class(
                venue_field_obj, many=True).data

            response["result"] = 1
            response["data"] = venue_field_class
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetPlayerFavVenuesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = GetPlayerFavVenuesSerializer
    slot_serializer_class = Schedule_SlotSerializer

    def post(self, request, format=None):
        """ 
        Get Player Fav Venues Book a match step 1
        """
        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            # get Player Objects
            player_obj = Player.objects.filter(
                user=request.user, is_deleted=False)
            if player_obj.exists():
                player_obj = player_obj.last()
            else:
                response["result"] = 0
                response["errors"] = ["Not Authorized to perform this actino"]
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            # Extra data
            page = serializers.validated_data['page']
            serializers.validated_data.pop("page")
            booking_date = serializers.validated_data['booking_date']
            serializers.validated_data.pop("booking_date")

            book_match = BookMatch.objects.filter(
                created_by=player_obj).order_by("-created_at")
            book_match1 = BookMatch.objects.filter(created_by=player_obj).order_by(
                '-created_at').values_list('venue_field__id')
            book_match1 = list(set(book_match1))

            if book_match.count() == 0:
                response["result"] = 1
                response["message"] = ["No Fav Venues Available"]
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            # if book_match.count() > page:
            #     book_match = book_match[page]
            # else:
            #     book_match = book_match[0]
            #     page = 0

            if "id" in serializers.validated_data:
                field_obj = VenueField.objects.filter(
                    id=serializers.validated_data['id'])
                if field_obj.exists():
                    field_obj = field_obj.last()
                else:
                    response["result"] = 0
                    response["errors"] = ["No SUch Field"]
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)
            else:
                # field_obj = book_match.venue_field
                if len(book_match1) > page:
                    field_obj = VenueField.objects.get(id=book_match1[page][0])
                else:
                    field_obj = VenueField.objects.get(id=book_match1[0][0])
                    page = 0

            schedule_obj = Schedule.objects.filter(Q(field=field_obj, start_date__lte=booking_date) | Q(
                field=field_obj, end_date__gte=booking_date))
            slots = []
            for i in schedule_obj:
                if Schedule_Slot.objects.filter(schedule_id=i, date=booking_date).exists():
                    schedule_slots = Schedule_Slot.objects.filter(
                        schedule_id=i, date=booking_date)
                    slot_serializer = self.slot_serializer_class(
                        schedule_slots, many=True)
                    slots = slots + slot_serializer.data

            # Static Data
            if len(schedule_obj) == 0 or len(slots) == 0:
                slots = "No Schedule Available"
                static_data = "No Schedule Available"
            else:
                static_data = schedule_slots.aggregate(
                    slot_start_price=Min('cost'))

            data = {"field_id": field_obj.id, 'field_name': field_obj.name,
                    "slots": slots, "static_data": static_data, 'page': page}

            response["result"] = 1
            response["data"] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class BookMatchStepAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = BookMatchStepSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []
        user = request.user if request.user.is_anonymous != True else None
        print(user)
        print(request.user)

        if user != None:
            player_obj = Player.objects.filter(
                user=request.user, is_deleted=False)
            if player_obj.exists():
                player_obj = player_obj.last()
            else:
                response["result"] = 0
                response["errors"] = ["Please Register As a player"]
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
        else:
            player_obj = None

        if "id" in request.data:
            booking_obj = BookMatch.objects.filter(
                id=request.data['id'], created_by=player_obj)

            if booking_obj.exists():
                booking_obj = booking_obj.last()
            else:
                response["result"] = 0
                response["errors"] = ["No Such Record Found"]
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            serializers = self.serializer_class(
                instance=booking_obj, data=request.data, context={"user": user})
        else:
            serializers = self.serializer_class(
                data=request.data, context={"user": user})

        if serializers.is_valid():

            if "id" in serializers.validated_data:

                book_match_data = booking_obj

                slot = book_match_data.schedule_slot

                if slot.is_available == True:
                    pass
                else:
                    book_match_data.schedule_slot = None
                    book_match_data.save()
                    response['result'] = 0
                    responsedata.append("Slot Already Booked")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_400_BAD_REQUEST)

            else:
                serializers.validated_data['created_by'] = player_obj
                print(serializers.validated_data['created_by'])
                if Schedule_Slot.objects.filter(schedule_id=serializers.validated_data['available_slot']['schedule_id'],
                                                is_available=True,
                                                start_hour=serializers.validated_data[
                                                    'available_slot']['start_hour'],
                                                end_hour=serializers.validated_data['available_slot'][
                                                    'end_hour']).exists():
                    serializers.validated_data['available_slot'] = Schedule_Slot.objects.get(
                        id=serializers.validated_data['available_slot']['id'])
                else:
                    response['result'] = 0
                    responsedata.append("No Available Schedule")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_400_BAD_REQUEST)

            data = serializers.save()
            data.created_by = player_obj
            data.save()

            response['results'] = 1
            response['errors'] = ["Successfully Inserted"]
            response['id'] = data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class BookMatchUserPOSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    serializer_class = BookMatchCreatedBySerializer

    def post(self, request, format=None):
        """ 
        Book a match POst User Step 3 Login
        """
        response = {}
        responsedata = []

        # Check for Book a match instance
        booking_obj = BookMatch.objects.filter(
            id=request.data['id'], created_by=None)
        if booking_obj.exists():
            booking_obj = booking_obj.last()
        else:
            response["result"] = 0
            response["errors"] = ["No Such Object Found"]
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            return_data = {}

            email = serializers.validated_data.get("email", False)
            first_name = serializers.validated_data.get("first_name", False)
            last_name = serializers.validated_data.get("last_name", False)
            mobile = serializers.validated_data.get("mobile", False)
            gender = serializers.validated_data.get("gender", False)
            dob = serializers.validated_data.get("dob", False)
            password = serializers.validated_data.get("password", False)

            # Check if register
            if email and first_name and password and mobile and gender and dob and password:
                if User.objects.filter(email=email).exists() or Player.objects.filter(
                        Q(email=email, is_deleted=False) | Q(mobile=mobile, is_deleted=False)).exists():
                    response["result"] = 0
                    response["errors"] = [
                        "This Email / Mobile is already Registered"]
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                user_obj = User.objects.create(
                    email=email, username=email, is_active=False, first_name=first_name, last_name=last_name)
                user_obj.set_password(password)
                player_obj = Player.objects.create(
                    email=email, user=user_obj, first_name=first_name, last_name=last_name, mobile=mobile,
                    gender=gender, dob=dob)
                booking_obj.created_by = player_obj
                login(request, user_obj)
                token, created = Token.objects.update_or_create(user=user_obj)
                return_data['token'] = token.key
                return_data['first_name'] = player_obj.first_name

            # Check if guest checkout
            elif email and first_name and last_name:
                if User.objects.filter(email=email).exists() or Player.objects.filter(email=email).exists():
                    response["result"] = 0
                    response["errors"] = ["This User is already Registered"]
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                user_obj = User.objects.create(
                    email=email, first_name=first_name, last_name=last_name, username=email)
                player_obj = Player.objects.create(
                    email=email, first_name=first_name, last_name=last_name, user=user_obj)
                booking_obj.created_by = player_obj
                booking_obj.save()

            # Check if logiin
            elif email and password:
                user = authenticate(request, username=email, password=password)
                if user is not None:

                    player_obj = Player.objects.filter(
                        user=user, is_deleted=False)
                    if player_obj.exists():
                        player_obj = player_obj.last()
                    else:
                        response["result"] = 0
                        response["errors"] = [
                            "You are not registered as a player"]
                        self.add_api_call(request, response)
                        return Response(response, status=status.HTTP_200_OK)

                    booking_obj.created_by = player_obj
                    booking_obj.save()
                    login(request, user)
                    token, created = Token.objects.update_or_create(user=user)
                    return_data['token'] = token.key
                    return_data['first_name'] = player_obj.first_name

                else:
                    response['result'] = 0
                    responsedata.append("Incorrect Username or password")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_400_BAD_REQUEST)

            response["result"] = 1
            response["message"] = ["Successfully Updated"]
            response['data'] = return_data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetFieldServicesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = GetServicesSerializers

    venue_field_service_class = VenueFieldServiceSerializer
    venue_service_class = VenueServicesCostSerializer

    def post(self, request, format=None):
        """
        Field Services GET / Book a Match Step 2
        """

        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            booking_details = BookMatch.objects.select_related("venue_field").get(
                id=serializers.validated_data['id'])

            venue_field_obj = booking_details.venue_field

            field_services = VenueFieldService.objects.filter(
                venue_field=venue_field_obj, is_deleted=False)

            venue_service = VenueServiceCost.objects.filter(
                venue=venue_field_obj.venue)

            field_service_serializer = self.venue_field_service_class(
                field_services, many=True)

            venue_service_serializer = self.venue_service_class(
                venue_service, many=True)

            response['results'] = 1
            response['field_service'] = field_service_serializer.data
            response['venue_service'] = venue_service_serializer.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class GetContactsPlayersAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Get Contacts 
    """
    serializer_class = GetContactPlayerSerializer

    def get(self, request, format=None):
        response = {}
        responsedata = []

        players_obj = Player.objects.filter(is_deleted=False)
        player_class = self.serializer_class(players_obj, many=True)

        response['results'] = 1
        response['data'] = player_class.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class SendMatchRequestAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Send Invitation
    """
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SendMatchRequestSerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            # Get player of user
            current_player_obj = Player.objects.filter(
                user=request.user, is_deleted=False).last()
            current_player_email = current_player_obj.email

            # Get book a match
            match_book_obj = BookMatch.objects.filter(
                id=serializers.validated_data['id']).last()

            # Get Player id
            if "player_id" in serializers.validated_data:
                player_obj = Player.objects.filter(
                    id=serializers.validated_data['player_id'], is_deleted=False).last()
                player_email = player_obj.email

            if "player_email" in serializers.validated_data:
                player_email = serializers.validated_data['player_email']

            player_invitation = PlayerInvitation.objects.create(created_by=current_player_obj, recipient=player_email,
                                                                category="Play Match", sender=current_player_email,
                                                                content_object=match_book_obj)

            # Notification.objects.create(recipient=current_player_obj.user, category="Play Match", button_text="view details",
            # subject="Match Request", content_object=player_invitation, body="Thank you for sending request", created_at=datetime.datetime.now())

            response['results'] = 1
            response['data'] = ["Successfully send"]
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GlobalBookMatchAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Get Global Book Match Data
    """
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = GetServicesSerializers

    book_match_class = BookMatchStepSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            booking_details = BookMatch.objects.get(
                id=serializers.validated_data['id'])

            booking_serializer = self.book_match_class(booking_details)

            response['results'] = 1
            response['data'] = booking_serializer.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class BookMatchStep4APIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Get Book a Match Step4 Data
    """
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = Step4Serializers

    def post(self, request, format=None):
        response = {}
        responsedata = []
        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            # Get Bookings
            auth = request.META.get('HTTP_AUTHORIZATION', b'')
            if isinstance(auth, str):
                # Work around django test client oddness
                auth = auth.encode(HTTP_HEADER_ENCODING)
                token = auth.split()[1].decode()
                from rest_framework.authtoken.models import Token
                token_user = Token.objects.select_related(
                    'user').get(key=token)
                # Get Player instance
                player_obj = Player.objects.filter(
                    user=token_user.user, is_deleted=False).last()
                extra_kwargs = {"created_by": player_obj}
            else:
                extra_kwargs = {"created_by__isnull": True}

            if BookMatch.objects.filter(**extra_kwargs, id=serializers.validated_data['id']).exists():
                booking_obj = BookMatch.objects.filter(
                    **extra_kwargs, id=serializers.validated_data['id']).last()
            else:
                response['results'] = 0
                responsedata.append("No Such booking details exists")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            # Serialize
            booking_serializers = self.serializer_class(booking_obj)
            return_data = booking_serializers.data

            print(return_data)

            # Modify
            # Get Slot
            slot_obj = Schedule_Slot.objects.get(
                id=return_data['schedule_slot'])
            slot_obj = str(slot_obj.start_hour) + \
                " : " + str(slot_obj.end_hour)
            return_data['schedule_slot'] = slot_obj

            response['results'] = 1
            response['data'] = return_data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class MyMatchesFilterAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = MyMatchesFilterSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            start_count = (serializers.validated_data['page'] - 1) * 10
            end_count = start_count + 10
            serializers.validated_data.pop("page")

            extra_kwargs = {}
            assortment = None
            q = Q()
            schedule_obj = []
            venue_field_obj = []
            bookmatch_obj = None

            if "status" in serializers.validated_data:
                extra_kwargs['status'] = serializers.validated_data.pop(
                    "status")

            # venue_field_obj=[]
            if "venue" in serializers.validated_data:
                venue = serializers.validated_data['venue']
                serializers.validated_data.pop("venue")
                venue_obj = Venue.objects.get(name__icontains=venue)
                venue_field_obj = VenueField.objects.filter(venue=venue_obj.id)

            if "all_sports" in serializers.validated_data:
                if serializers.validated_data['all_sports'] == "all":
                    serializers.validated_data.pop("all_sports")
                else:
                    if Sport.objects.filter(id=serializers.validated_data["all_sports"]).exists():
                        extra_kwargs['sport'] = Sport.objects.get(
                            id=serializers.validated_data['all_sports'])

            if "start_date" in serializers.validated_data and "start_time" in serializers.validated_data \
                    and "end_date" in serializers.validated_data and "end_time" in serializers.validated_data:
                schedule_obj = Schedule_Slot.objects.filter(
                    Q(date__lte=serializers.validated_data['end_date'],
                      date__gte=serializers.validated_data['start_date'],
                      start_hour__gte=serializers.validated_data['start_time'],
                      end_hour__lte=serializers.validated_data['end_time']))

            elif "start_date" in serializers.validated_data and "end_date" in serializers.validated_data:
                schedule_obj = Schedule_Slot.objects.filter(
                    Q(date__lte=serializers.validated_data['end_date'],
                      date__gte=serializers.validated_data['start_date']
                      ))

            elif "start_time" in serializers.validated_data and "end_time" in serializers.validated_data:
                schedule_obj = Schedule_Slot.objects.filter(
                    Q(start_hour__gte=serializers.validated_data['start_time'],
                      end_hour__lte=serializers.validated_data['end_time']))

            if "ordering" in serializers.validated_data:
                if serializers.validated_data['ordering'] == "Descending":
                    if schedule_obj and venue_field_obj:
                        bookmatch_obj = BookMatch.objects.filter(venue_field__in=venue_field_obj,
                                                                 schedule_slot__in=schedule_obj,
                                                                 **extra_kwargs).order_by("-created_at")[
                            start_count:end_count]
                    elif schedule_obj:
                        bookmatch_obj = BookMatch.objects.filter(
                            schedule_slot__in=schedule_obj,
                            **extra_kwargs).order_by("-created_at")[start_count:end_count]
                    elif venue_field_obj:
                        bookmatch_obj = BookMatch.objects.filter(venue_field__in=venue_field_obj,
                                                                 **extra_kwargs).order_by("-created_at")[
                            start_count:end_count]
                else:
                    if schedule_obj and venue_field_obj:
                        bookmatch_obj = BookMatch.objects.filter(venue_field__in=venue_field_obj,
                                                                 schedule_slot__in=schedule_obj,
                                                                 **extra_kwargs).order_by("created_at")[
                            start_count:end_count]
                    elif schedule_obj:
                        bookmatch_obj = BookMatch.objects.filter(
                            schedule_slot__in=schedule_obj,
                            **extra_kwargs).order_by("created_at")[start_count:end_count]

                    elif venue_field_obj:
                        bookmatch_obj = BookMatch.objects.filter(venue_field__in=venue_field_obj,
                                                                 **extra_kwargs).order_by("created_at")[
                            start_count:end_count]

            if bookmatch_obj is None:
                bookmatch_obj = BookMatch.objects.filter(**extra_kwargs).order_by("created_at")[
                    start_count:end_count]

            bookmatch_obj_serializer = BookMatchMyMatchesSerializer(
                bookmatch_obj, many=True)

            response['results'] = 1
            response['data'] = bookmatch_obj_serializer.data
            response['total_count'] = len(bookmatch_obj_serializer.data)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GamesPlayedByPlayerGraphCountAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    Games played Graph API View
    '''

    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)

    def get(self, request, format=None):
        response = {}

        player_obj = Player.objects.get(
            user=request.user, is_deleted=False)

        ####graph logic start####

        graph1_player_data = {}
        for j in range(1, 13):
            that_month_data = BookMatch.objects.filter(
                status='Completed', schedule_slot__date__month=j, created_by=player_obj.id)
            if that_month_data.count() > 0:
                graph1_player_data[j] = that_month_data.count()

            else:
                graph1_player_data[j] = 0

        # Sending Response
        response["result"] = 1
        response['data'] = graph1_player_data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class GamesStatusByPlayerGraphCountAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    Match win/loose Graph API View
    '''

    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)

    def get(self, request, format=None):
        response = {}

        player_obj = Player.objects.get(
            user=request.user, is_deleted=False)

        ####graph logic start####

        graph1_player_data = {}
        for j in range(1, 13):
            win_month_data = BookMatch.objects.filter(
                status='Completed', match_result=True, schedule_slot__date__month=j, created_by=player_obj.id)
            print('win_month_data----', win_month_data)
            if win_month_data.count() > 0:
                graph1_player_data[j] = win_month_data.count()

            else:
                graph1_player_data[j] = 0

        graph2_player_data = {}
        for k in range(1, 13):
            loose_month_data = BookMatch.objects.filter(
                status='Completed', match_result=False, schedule_slot__date__month=k, created_by=player_obj.id)
            print('loose_month_data---', loose_month_data)
            if loose_month_data.count() > 0:
                graph2_player_data[k] = loose_month_data.count()

            else:
                graph2_player_data[k] = 0

        # Sending Response
        response["result"] = 1
        response['win_data'] = graph1_player_data
        response['loose_data'] = graph2_player_data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class MyMatchesEditInfoAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = MyMatchesEditInfoSerializer

    def post(self, request, format=None):
        '''
        Update MyMatches
        '''
        responsedata = []
        response = {}

        if BookMatch.objects.filter(id=request.data['id']).exists():
            serializer = self.serializer_class(instance=BookMatch.objects.get(
                id=request.data['id']), data=request.data)
            message = "Updated Successfully"

        else:
            response["result"] = 0
            response['data'] = "Invalid BookMatch id"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        if serializer.is_valid():
            print('validated data----', serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = message
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class BookMatchNewPOSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = BookMatchNewPOSTSerializer

    # Add Schedule Slot

    def post(self, request, format=None):
        '''
        Bookmatch Schedule Slot Create
        '''

        response = {}
        responsedata = []
        request.data._mutable = True
        print(request.user)
        player_object = Player.objects.get(
            user=(request.user))
        request.data['created_by'] = player_object.id

        serializers = self.serializer_class(data=request.data)
        message = 'Successfully Inserted'

        if serializers.is_valid():

            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class BookMatchNew2POSTAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = BookMatchNew2POSTSerializer

    # Add Services

    def post(self, request, format=None):
        '''
        Bookmatch Services Create
        '''

        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)
        message = 'Successfully Inserted'

        if serializers.is_valid():

            save_data = serializers.save()
            response["result"] = 1
            responsedata.append(message)
            response['data'] = responsedata
            response['id'] = save_data.id
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response['result'] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class GetAllBookMatchSevicesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = FieldServiecsBookMatchSerializer

    def post(self, request, format=None):
        '''
        Get all services Id
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if BookMatch.objects.filter(id=serializer.validated_data["id"]).exists():
                bookmatch_obj = BookMatch.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid BookMatch id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            serializer = self.serializer_class(bookmatch_obj)

            # Paid Services
            venue_paid_service_obj = VenuePaidServiceQuantity.objects.filter(
                book_match=bookmatch_obj)
            paid_serialized_data = VenuePaidServiceQuantityerializer(
                venue_paid_service_obj, many=True)

            # Free Sevices
            venue_free_services_obj = VenueService.objects.filter(
                service_available='V', type='F')
            free_venue_services = VenueServiceSerializer(
                venue_free_services_obj, many=True)

            data = {'venue_paid_services': paid_serialized_data.data,
                    'venue_field_services': serializer.data, 'venue_free_services': free_venue_services.data}

            response["result"] = 1
            response['data'] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class GetAllFieldAndVenueSevicesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = FieldServiceSerializer

    def post(self, request, format=None):
        '''
        Get all services Id
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if VenueField.objects.filter(id=serializer.validated_data["id"]).exists():
                VenueField_obj = VenueField.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid VenueField id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            venue_field_services_obj = VenueFieldService.objects.filter(
                venue_field=VenueField_obj)

            serializer = self.serializer_class(
                venue_field_services_obj, many=True)

            # Paid Services
            venue_paid_service_obj = VenueServiceCost.objects.filter(
                venue=VenueField_obj.venue.id)
            paid_serialized_data = VenueServicesCost1Serializer(
                venue_paid_service_obj, many=True)

            data = {'venue_paid_services': paid_serialized_data.data,
                    'venue_field_services': serializer.data, }

            response["result"] = 1
            response['data'] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class BookMatchSummeryAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = BookingSummeryIdSerializer

    def post(self, request, format=None):
        '''
        Get Summery by Id
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if BookMatch.objects.filter(id=serializer.validated_data["id"]).exists():
                bookmatch_obj = BookMatch.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid BookMatch id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            print(bookmatch_obj.schedule_slot.filter())
            Schedule_slot_obj = bookmatch_obj.schedule_slot.filter()

            first = Schedule_slot_obj.first()
            last = Schedule_slot_obj.last()
            start_hour = first.start_hour
            end_hour = last.end_hour

            # Contract Terms
            contract_obj = ContractTerms.objects.filter(
                created_for=bookmatch_obj.venue_field.created_by)
            contract_serialized_data = GetSingleContractTermsSerializer1(
                contract_obj, many=True)

            value = 0
            duration = timedelta(minutes=value)
            for i in Schedule_slot_obj:
                end = i.end_hour
                beginning = i.start_hour

                difference = datetime.combine(
                    date.min, end) - datetime.combine(date.min, beginning)
                print('diff', difference)
                duration = duration + difference
                print('dur', duration)

            total_seconds = duration.total_seconds()
            minutes = total_seconds/60
            hr = minutes/60
            print('hr', hr)

            serializer = BookingSummerySerializer(bookmatch_obj)

            # Paid Services
            venue_paid_service_obj = VenuePaidServiceQuantity.objects.filter(
                book_match=bookmatch_obj)
            paid_serialized_data = VenuePaidServiceQuantityerializer(
                venue_paid_service_obj, many=True)

            venue_field_service_obj = VenueFieldServiceQuantity.objects.filter(
                book_match=bookmatch_obj)
            field_serialized_data = VenueFieldServiceQuantitySerializer(
                venue_field_service_obj, many=True)

            # Total Cost Schedule
            totalcost = 0
            value = 0
            cost = value
            for i in Schedule_slot_obj:
                schedule_cost = i.cost
                cost = cost + schedule_cost
            print('cost', cost)

            # Total Cost Paid Service
            val = 0
            p_cost = val
            for i in venue_paid_service_obj:

                paid_service_cost = i.venue_service_cost.price_per_hour
                quantity = i.quantity

                p_cost = p_cost + (paid_service_cost*quantity)*hr

            print('pcost', p_cost)

            # Total Cost Field Service
            fval = 0
            f_cost = fval
            for i in venue_field_service_obj:

                field_service_cost = i.venue_field_service.price_per_hour
                quantity = i.quantity

                f_cost = f_cost + (field_service_cost*quantity)*hr

            print('fcost', f_cost)

            totalcost = totalcost + cost + p_cost + f_cost

            bookmatch_obj.total_cost = totalcost
            bookmatch_obj.save()

            data = {'booking_data': serializer.data,
                    'start_hour': start_hour, 'end_hour': end_hour, 'duration': hr, 'venue_paid_services': paid_serialized_data.data, 'venue_field_services': field_serialized_data.data, 'total_cost': totalcost, 'contact_terms': contract_serialized_data.data}

            response["result"] = 1
            response['data'] = data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class VenuePaidServiceQuantityEDITAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = VenuePaidServiceQuantityEDITSerializer

    def post(self, request, format=None):
        '''
        Update Venue Paid Service Quantity
        '''
        responsedata = []
        response = {}

        if VenuePaidServiceQuantity.objects.filter(id=request.data['id']).exists():
            serializer = self.serializer_class(instance=VenuePaidServiceQuantity.objects.get(
                id=request.data['id']), data=request.data)
            message = "Updated Successfully"
        else:
            response["result"] = 0
            response['error'] = "Invalid Venue Paid Service id"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class VenueFieldServiceQuantityEDITAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = VenueFieldServiceQuantityEDITSerializer

    def post(self, request, format=None):
        '''
        Update VenueField Service Quantity
        '''
        responsedata = []
        response = {}

        if VenueFieldServiceQuantity.objects.filter(id=request.data['id']).exists():
            serializer = self.serializer_class(instance=VenueFieldServiceQuantity.objects.get(
                id=request.data['id']), data=request.data)
            message = "Updated Successfully"
        else:
            response["result"] = 0
            response['error'] = "Invalid VenueField Service id"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        if serializer.is_valid():
            print(serializer.validated_data)
            serializer.save()
            response["result"] = 1
            response['data'] = [message]
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class VenuePaidServiceQuantityDeleteAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = DeleteVenuePaidServiceQuantitySerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []

        if not VenuePaidServiceQuantity.objects.filter(id=request.data['id']).exists():
            response['results'] = 0
            response['error'] = "Not a valid ID"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            paid_obj = VenuePaidServiceQuantity.objects.get(
                id=serializers.validated_data['id'])
            paid_obj.delete()

            response['results'] = 1
            response['data'] = "Successfully Deleted"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class VenueFieldServiceQuantityDeleteAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = DeleteVenueFieldServiceQuantitySerializer

    def post(self, request, format=None):
        response = {}
        responsedata = []

        if not VenueFieldServiceQuantity.objects.filter(id=request.data['id']).exists():
            response['results'] = 0
            response['error'] = "Not a valid ID"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            field_obj = VenueFieldServiceQuantity.objects.get(
                id=serializers.validated_data['id'])
            field_obj.delete()

            response['results'] = 1
            response['data'] = "Successfully Deleted"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)

        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class PlayersListAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Get All data of players except the requested user
    """
    serializer_class = PlayerProfileSerializer

    def get(self, request, format=None):

        response = {}
        responsedata = []
        user_obj = request.user
        data = Player.objects.all()
        data_obj = data.exclude(user=user_obj)
        serializer = self.serializer_class(data_obj, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class SendPlayerInvitationEmailAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SendEmailPlayerSerializer

    def post(self, request, format=None):
        '''
        Send Mail For Invitation
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        mode = request.data['mode']
        booking_id = request.data['booking_id']
        if serializer.is_valid():

            if Player.objects.filter(id=serializer.validated_data["id"]).exists():
                Player_obj = Player.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid  Player id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            email_obj = Player_obj.email
            first_name_obj = Player_obj.first_name

            bookmatch_obj = BookMatch.objects.get(id=booking_id)
            # print(bookmatch_obj.venue_field.venue.name)
            # print(bookmatch_obj.date)
            user_obj = request.user

            images = Template_Images.objects.filter().values('template_image')
            logo = images[0]
            logo2 = images[1]

            if mode == "T":
                msg = f'{user_obj.first_name} {user_obj.last_name} invited you as a teammate for the {bookmatch_obj.venue_field.venue.name} held on {bookmatch_obj.date}.'
                invitation_send(first_name_obj, email_obj, msg, logo, logo2)

                Notification.objects.create(category='message', subject='Invitation',
                                            body=f'{user_obj.first_name} {user_obj.last_name} has invited you as a teammate.', recipient=Player_obj.user, content_object=Player_obj, button_text='-')
            else:
                msg = f'{user_obj.first_name} {user_obj.last_name} invited you as an opponent for the {bookmatch_obj.venue_field.venue.name} held on {bookmatch_obj.date}.'
                invitation_send(first_name_obj, email_obj, msg, logo, logo2)

                Notification.objects.create(category='message', subject='Invitation',
                                            body=f'{user_obj.first_name} {user_obj.last_name} has invited you as an opponent.', recipient=Player_obj.user, content_object=Player_obj, button_text='-')

            response["result"] = 1
            response['data'] = "Success"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class SendFriendInvitationEmailAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SendEmailFriendSerializer

    def post(self, request, format=None):
        '''
        Send Mail For Invitation
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        mode = request.data['mode']
        booking_id = request.data['booking_id']
        if serializer.is_valid():

            email_obj = serializer.validated_data["email"]

            bookmatch_obj = BookMatch.objects.get(id=booking_id)

            user_obj = request.user
            images = Template_Images.objects.filter().values('template_image')
            logo = images[0]
            logo2 = images[1]

            if mode == "T":
                msg = f'{user_obj.first_name} {user_obj.last_name} invited you as a teammate for the {bookmatch_obj.venue_field.venue.name} held on {bookmatch_obj.date}.'
                invitation_send_to_friend(email_obj, msg, logo, logo2)

            else:
                msg = f'{user_obj.first_name} {user_obj.last_name} invited you as an opponent for the {bookmatch_obj.venue_field.venue.name} held on {bookmatch_obj.date}.'
                invitation_send_to_friend(email_obj, msg, logo, logo2)

            response["result"] = 1
            response['data'] = "Success"
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class GetAllVenuesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Get All Venues
    """
    serializer_class = VenueProfileSerializer

    def get(self, request, format=None):

        response = {}
        responsedata = []
        data = Venue.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class GetAllVenueServicesAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    """
    Get All Venue Services
    """
    serializer_class = VenueServiceSerializer

    def get(self, request, format=None):

        response = {}
        responsedata = []
        data = VenueService.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class GetScheduleSlotsAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = GetScheduleSlotSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            extra_kwargs = {}

            extra_kwargs['date'] = serializers.validated_data['date']

            venue_id_list = []

            if "sport" in serializers.validated_data:
                extra_kwargs['schedule_id__field__sport__id'] = serializers.validated_data['sport']
                serializers.validated_data.pop("sport")

            if "field_type" in serializers.validated_data:
                extra_kwargs['schedule_id__field__field_type__id'] = serializers.validated_data['field_type']

            if "start_time" in serializers.validated_data:
                extra_kwargs['start_hour__gte'] = serializers.validated_data['start_time']
                serializers.validated_data.pop("start_time")

            if "venue_list" in serializers.validated_data:
                venue_id_list = venue_id_list + \
                    serializers.validated_data['venue_list']

            if "prices" in serializers.validated_data:
                b = serializers.validated_data['prices'][0]['start']
                e = serializers.validated_data['prices'][len(
                    serializers.validated_data['prices'])-1]['end']
                extra_kwargs['cost__gte'] = b
                extra_kwargs['cost__lte'] = e

            if "categories" in serializers.validated_data:
                print(serializers.validated_data['categories'])
                list_of_categories = serializers.validated_data['categories']
                field_types_queryset = FieldType.objects.filter(
                    name__in=list_of_categories)
                facility_types_queryset = FacilityType.objects.filter(
                    name__in=list_of_categories)
                floor_types_queryset = FloorType.objects.filter(
                    name__in=list_of_categories)
                lights_queryset = Lights.objects.filter(
                    name__in=list_of_categories)

                list_of_field_type_ids = []
                list_of_facility_type_ids = []
                list_of_floor_type_ids = []
                list_of_lights_ids = []

                for ft in field_types_queryset:
                    list_of_field_type_ids.append(ft.id)

                for fct in facility_types_queryset:
                    list_of_facility_type_ids.append(fct.id)

                for frt in floor_types_queryset:
                    list_of_floor_type_ids.append(frt.id)

                for lt in lights_queryset:
                    list_of_lights_ids.append(lt.id)

                if len(list_of_field_type_ids) > 0:
                    extra_kwargs['schedule_id__field__field_type__id__in'] = list_of_field_type_ids

                if len(list_of_facility_type_ids) > 0:
                    extra_kwargs['schedule_id__field__facility_type__id__in'] = list_of_facility_type_ids

                if len(list_of_floor_type_ids) > 0:
                    extra_kwargs['schedule_id__field__floor_type__id__in'] = list_of_floor_type_ids

                if len(list_of_lights_ids) > 0:
                    extra_kwargs['schedule_id__field__lights__id__in'] = list_of_lights_ids

            if "services" in serializers.validated_data:
                print(serializers.validated_data['services'])
                list_of_services = serializers.validated_data['services']
                venue_paid_service = VenueServiceCost.objects.filter(
                    venue_service__id__in=list_of_services)
                field_paid_service = VenueFieldService.objects.filter(
                    venue_service__id__in=list_of_services)

                list_of_venue_ids_from_venuepaidservices = []
                list_of_field_ids_from_fieldpaidservices = []

                for vs in venue_paid_service:
                    list_of_venue_ids_from_venuepaidservices.append(
                        vs.venue.id)

                for fs in field_paid_service:
                    list_of_field_ids_from_fieldpaidservices.append(
                        fs.venue_field.id)

                if len(list_of_field_ids_from_fieldpaidservices) > 0:
                    extra_kwargs['schedule_id__field__id__in'] = list_of_field_ids_from_fieldpaidservices

                merged_list = list_of_venue_ids_from_venuepaidservices
                venue_id_list = venue_id_list+merged_list

            if len(venue_id_list) > 0:
                extra_kwargs['schedule_id__field__venue__id__in'] = venue_id_list

            if "keyword" in serializers.validated_data:
                n = serializers.validated_data['keyword']
                schedule_slot_obj = Schedule_Slot.objects.filter(Q(schedule_id__field__name__icontains=n) | Q(
                    schedule_id__field__venue__name__icontains=n), **extra_kwargs).order_by('start_hour')
            else:
                schedule_slot_obj = Schedule_Slot.objects.filter(
                    **extra_kwargs).order_by('start_hour')

            # print(schedule_slot_obj)

            for i in schedule_slot_obj:
                data = {}

                check_if_already_added_in_response = [
                    d for d in responsedata if d['start_hour'] == i.start_hour and d['end_hour'] == i.end_hour]
                if len(check_if_already_added_in_response) > 0:
                    # slot is already there,so first get that slot details,index
                    index = 0
                    for j in range(0, len(responsedata)):
                        if responsedata[j]['start_hour'] == i.start_hour and responsedata[j]['end_hour'] == i.end_hour:
                            index = j
                            break

                    # now checking if the slots field type is already present in the responsedata obj available field types
                    already_added_field_types = responsedata[index]['available_field_types']
                    current_field_type = i.schedule_id.field.field_type.name
                    check2 = [
                        ft for ft in already_added_field_types if ft['field_type'] == current_field_type]

                    if len(check2) > 0:
                        if check2[0]['availability'] == i.is_available:
                            pass
                        else:
                            # now find index of that field type record from already added field types
                            inner_index = 0
                            for k in range(0, len(already_added_field_types)):
                                if already_added_field_types[k]['field_type'] == i.schedule_id.field.field_type.name:
                                    inner_index = k
                                    break
                            already_added_field_types[inner_index]['availability'] = i.is_available
                            responsedata[index]['available_field_types'] = already_added_field_types
                            if i.is_available:
                                responsedata[index]['slot_status'] = i.is_available

                    else:
                        field_type_availability_obj = {}
                        field_type_availability_obj['field_type'] = i.schedule_id.field.field_type.name
                        field_type_availability_obj['availability'] = i.is_available
                        already_added_field_types.append(
                            field_type_availability_obj)
                        responsedata[index]['available_field_types'] = already_added_field_types
                        if i.is_available:
                            responsedata[index]['slot_status'] = i.is_available

                    already_added_venues = responsedata[index]['venues']
                    already_added_venues.append(i.schedule_id.field.venue.id)
                    unique_venues = set(already_added_venues)
                    responsedata[index]['venues'] = list(unique_venues)

                else:
                    # slot was new so adding it
                    data['start_hour'] = i.start_hour
                    data['end_hour'] = i.end_hour

                    field_type_availability_obj = {}
                    field_type_availability_obj['field_type'] = i.schedule_id.field.field_type.name
                    field_type_availability_obj['availability'] = i.is_available

                    data['available_field_types'] = [
                        field_type_availability_obj]
                    data['slot_status'] = i.is_available
                    data['venues'] = [i.schedule_id.field.venue.id]
                    responsedata.append(data)

            response['results'] = 1
            response['data'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetPopUpFieldTypeAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = GetPopUpFieldTypeSerializer

    def post(self, request, format=None):

        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():

            extra_kwargs = {}

            extra_kwargs['date'] = serializers.validated_data['date']
            extra_kwargs['start_hour'] = serializers.validated_data['start_hour']
            extra_kwargs['end_hour'] = serializers.validated_data['end_hour']

            if "venue_id" in serializers.validated_data:
                extra_kwargs['schedule_id__field__venue__id'] = serializers.validated_data['venue_id']
                serializers.validated_data.pop("venue_id")

            schedule_slot_obj = Schedule_Slot.objects.filter(
                **extra_kwargs)
            print(schedule_slot_obj)

            for i in schedule_slot_obj:
                data = {}
                available_field_types_on_slot = []

                fieldtype_availability_obj = {}

                field_type = i.schedule_id.field.field_type.name
                available = i.is_available
                field_id = i.schedule_id.field.id
                field_name = i.schedule_id.field.name
                schedule_slot_id = i.id

                fieldtype_availability_obj['field_type'] = field_type
                fieldtype_availability_obj['available'] = available
                available_field_types_on_slot.append(
                    fieldtype_availability_obj)

                data['slot_field_types'] = available_field_types_on_slot
                data['field_id'] = field_id
                data['field_name'] = field_name
                data['schedule_slot_id'] = schedule_slot_id

                responsedata.append(data)

            response['results'] = 1
            response['data'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response['results'] = 0
            response = handle_errors(serializers.errors)
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)


class GetFieldAndVenueSevicesBySportsAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = SportsSerializer

    def post(self, request, format=None):
        '''
        Get all services by Sports
        '''
        response = {}
        responsedata = []

        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():

            if Sport.objects.filter(id=serializer.validated_data["id"]).exists():
                sports_obj = Sport.objects.get(
                    id=serializer.validated_data["id"])
            else:
                response["result"] = 0
                response['error'] = "Invalid sports id"
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)

            venue_field_obj = VenueField.objects.filter(
                sport=sports_obj)
            print(venue_field_obj)

            for i in venue_field_obj:
                data = {}
                field_id = i.id

                VenueFieldService_obj = VenueFieldService.objects.filter(
                    venue_field=field_id)

                serializer = FieldServiceSerializer(
                    VenueFieldService_obj, many=True)

                data['venue_field_services'] = serializer.data

                responsedata.append(data)

            # Venue Paid Services
            venue_obj = Venue.objects.filter(
                all_sports=sports_obj)

            for j in venue_obj:
                data = {}
                venue_id = j.id

                VenueServiceCost_obj = VenueServiceCost.objects.filter(
                    venue=venue_id)

                paid_serialized_data = VenueServicesCost1Serializer(
                    VenueServiceCost_obj, many=True)

                data['venue_paid_services'] = paid_serialized_data.data

                responsedata.append(data)

            response["result"] = 1
            response['data'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializer.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class GetSuggestionsForPlayerAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    Get Names Suggestions For Player
    '''
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = GetSuggestionsSerializer

    def post(self, request, format=None):

        serializers = self.serializer_class(data=request.data)
        if serializers.is_valid():
            response = {}
            responsedata = []

            # Area
            area_data = Area.objects.filter(
                name__icontains=serializers.validated_data['key_word'])
            Area_data = SuggestionsAreaGetSerializer(area_data, many=True)

            # City
            city_data = City.objects.filter(
                name__icontains=serializers.validated_data['key_word'])
            City_data = SuggestionsCitySerializer(city_data, many=True)

            # State
            state_data = State.objects.filter(
                name__icontains=serializers.validated_data['key_word'])
            State_data = SuggestionsStateGetSerializer(state_data, many=True)

            # Country
            country_data = Country.objects.filter(
                name__icontains=serializers.validated_data['key_word'])
            Country_data = SuggestionsCountrySerializer(
                country_data, many=True)

            response['result'] = 1
            response['data'] = Country_data.data + \
                State_data.data + City_data.data + Area_data.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
