from django.contrib import admin
from nested_admin import NestedModelAdmin
from .models import *

# Register your models here.


@admin.register(Professional)
class ProfessionalAdmin(NestedModelAdmin):
    model = Professional
    search_fields = ['first_name']
    list_display = ['id', 'first_name',
                    'last_name', 'email', 'user', 'user_code']


@admin.register(ProfessionalServicePhoto)
class ProfessionalServicePhotoAdmin(NestedModelAdmin):
    model = ProfessionalServicePhoto
    search_fields = ['created_by']
    list_display = ['id', 'main_image', 'is_deleted', 'created_by']


@admin.register(ProfessionalStepSkill)
class ProfessionalStepSkillAdmin(NestedModelAdmin):
    model = ProfessionalStepSkill
    search_fields = ['created_by']
    list_display = ['id', 'skil', 'is_deleted', 'created_by']


@admin.register(ProfessionalCertificate)
class ProfessionalCertificateAdmin(NestedModelAdmin):
    model = ProfessionalCertificate
    search_fields = ['created_by']
    list_display = ['id', 'certificate_name',
                    'certificate', 'created_by', 'is_deleted']


@admin.register(ProfessionalFavList)
class FavListAdmin(NestedModelAdmin):
    model = ProfessionalFavList
    search_fields = ['created_by']
    list_display = ['id', 'fav_profile',
                    'created_by', 'created_at', 'is_deleted']


@admin.register(ProfessionalStepServiceData)
class StepServiceDataAdmin(NestedModelAdmin):
    model = ProfessionalStepServiceData
    search_fields = ['user']
    list_display = ['id', 'user', 'created_at']


@admin.register(ProfessionalDailyTiming)
class ProfessionalTimingAdmin(NestedModelAdmin):
    model = ProfessionalDailyTiming
    list_display = ['id', 'professional', 'day',
                    'is_active', 'start_time', 'end_time']


@admin.register(ProfessionalServedArea)
class ProfessionalServedAreaAdmin(NestedModelAdmin):
    model = ProfessionalServedArea
    list_display = ['id', 'professional', 'latitude',
                    'longitude', 'is_deleted', 'created_by', ]


@admin.register(ProfessionServiceAvailability)
class ProfessionServiceAvailabilityAdmin(NestedModelAdmin):
    model = ProfessionServiceAvailability
    list_display = ['id','service', 'start_hour',
                    'end_hour', 'is_active', 'day' ]



@admin.register(ProfessionalService)
class ProfessionalServiceAdmin(NestedModelAdmin):
    model = ProfessionalService
    list_display = ['id', 'profession',
                    'service', 'cost', 'is_deleted' ]



@admin.register(ProfessionalContract)
class ProfessionalContractAdmin(NestedModelAdmin):
    model = ProfessionalContract
    list_display = ['id' ]


@admin.register(ProfessionalDocument)
class ProfessionalDocumentAdmin(NestedModelAdmin):
    model = ProfessionalDocument
    list_display = ['id' ]