# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import professionals.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Professional',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(blank=True, help_text='user first name', max_length=100, null=True)),
                ('middle_name', models.CharField(blank=True, help_text='user middle name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='user last name', max_length=100, null=True)),
                ('email', models.CharField(blank=True, help_text='user email', max_length=100, null=True)),
                ('new_email', models.CharField(blank=True, help_text='user new email', max_length=100, null=True)),
                ('gender', models.CharField(blank=True, choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('mobile', models.CharField(blank=True, help_text='mobile number', max_length=100, null=True)),
                ('new_mobile', models.CharField(blank=True, help_text='new mobile number', max_length=100, null=True)),
                ('telephone', models.CharField(blank=True, max_length=50, null=True)),
                ('telephone2', models.CharField(blank=True, max_length=50, null=True)),
                ('address1', models.CharField(blank=True, help_text='Apartment, Suite, Unit, building, floor,etc.', max_length=150, null=True)),
                ('tagline', models.CharField(blank=True, help_text='TagLine', max_length=50, null=True)),
                ('address2', models.CharField(blank=True, help_text='Street & Number, P.O.box c/o', max_length=150, null=True)),
                ('user_code', models.CharField(blank=True, max_length=6, null=True)),
                ('street', models.CharField(blank=True, help_text='street', max_length=50, null=True)),
                ('number', models.CharField(blank=True, help_text='number', max_length=50, null=True)),
                ('business_name', models.CharField(blank=True, max_length=50, null=True)),
                ('TaxOffices', models.CharField(blank=True, help_text='TaxOffices', max_length=10, null=True)),
                ('buisness_vat', models.CharField(blank=True, help_text='user Buisness Vat', max_length=10, null=True)),
                ('latitude', models.FloatField(blank=True, null=True)),
                ('longitude', models.FloatField(blank=True, null=True)),
                ('google_address', models.CharField(blank=True, max_length=450, null=True)),
                ('place_id', models.CharField(blank=True, max_length=450, null=True)),
                ('status', models.CharField(blank=True, choices=[('I', 'In Progress'), ('R', 'Rejected'), ('N', 'New'), ('A', 'Approve'), ('C', 'Complete')], default='N', help_text='Is document Verified', max_length=10, null=True)),
                ('pincode', models.CharField(blank=True, help_text='code', max_length=10, null=True)),
                ('image', models.ImageField(blank=True, null=True, upload_to='professional_images', validators=[professionals.models.validate_image])),
                ('dob', models.DateField(blank=True, help_text='date of birth format YYYY-MM-DD', null=True, verbose_name='date of birth')),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('is_email_verified', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('payment_method', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.PaymentMethod')),
                ('served_areas', models.ManyToManyField(blank=True, help_text='serverd areas format [1,2]', related_name='professional_served_areas', to='static_data.Area')),
                ('service', models.ManyToManyField(blank=True, to='static_data.Profession')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.State')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Professionals',
                'db_table': 'professional',
                'unique_together': {('user', 'email')},
            },
        ),
        migrations.CreateModel(
            name='ProfessionalService',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate skills')),
                ('cost', models.IntegerField(blank=True, help_text='Costing', null=True)),
                ('profession', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
                ('service', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.StaticProfessionalService')),
            ],
            options={
                'verbose_name_plural': 'Professional Service',
                'db_table': 'professionalservice',
            },
        ),
        migrations.CreateModel(
            name='ProfessionServiceAvailability',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate skills')),
                ('start_hour', models.TimeField(blank=True, null=True)),
                ('end_hour', models.TimeField(blank=True, null=True)),
                ('is_active', models.BooleanField(blank=True, default=False, null=True)),
                ('day', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.DayofWeek')),
                ('professional', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
                ('service', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.ProfessionalService')),
            ],
            options={
                'verbose_name_plural': 'Step Service Availability',
                'db_table': 'step_service_availability',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalStepSkill',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate skills')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('skil', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Skill')),
            ],
            options={
                'verbose_name_plural': 'Step Skills',
                'db_table': 'professional_step_skill',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalStepServiceData',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate skills')),
                ('service_description', models.TextField(blank=True, max_length=500, null=True)),
                ('professions', models.ManyToManyField(blank=True, to='static_data.Profession')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Step Service Data',
                'db_table': 'professional_step_data',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalServicePhoto',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('main_image', models.ImageField(blank=True, help_text='Main Photo', null=True, upload_to='service_photos', validators=[professionals.models.validate_service_image])),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Service Photo')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Service Photo',
                'db_table': 'professional_service_photo',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalServedArea',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('latitude', models.FloatField(blank=True, null=True)),
                ('longitude', models.FloatField(blank=True, null=True)),
                ('google_address', models.CharField(blank=True, max_length=450, null=True)),
                ('place_id', models.CharField(blank=True, max_length=450, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Serve Area')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('professional', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
            ],
            options={
                'verbose_name_plural': 'ServedArea',
                'db_table': 'professional_ServedArea',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalFavList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate skills')),
                ('created_by', models.ForeignKey(blank=True, on_delete=django.db.models.deletion.CASCADE, related_name='User_Name', to=settings.AUTH_USER_MODEL)),
                ('fav_profile', models.ForeignKey(blank=True, on_delete=django.db.models.deletion.CASCADE, related_name='Professional', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Favourite',
                'db_table': 'professional_favourite',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalDocument',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('document_name', models.CharField(blank=True, help_text='Certificates', max_length=100, null=True)),
                ('document', models.FileField(blank=True, help_text='Documents', null=True, upload_to='professional_document')),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Certificate')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Professional Documents',
                'db_table': 'professional_document',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalDailyTiming',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, help_text='Start time', null=True)),
                ('end_time', models.TimeField(blank=True, help_text='Start time', null=True)),
                ('is_active', models.BooleanField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now=True, null=True)),
                ('day', models.ForeignKey(blank=True, help_text='Day', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.DayofWeek')),
                ('professional', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
            ],
        ),
        migrations.CreateModel(
            name='ProfessionalContract',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('contract_file', models.FileField(blank=True, help_text='Contract', null=True, upload_to='professional_contract')),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('professional', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
            ],
            options={
                'verbose_name_plural': 'Professional Contracts',
                'db_table': 'professional_contract',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalCollaborationType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('collaboration_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.CollaborationTypes')),
                ('professional', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
            ],
            options={
                'verbose_name_plural': 'Professional Collaboration Types',
                'db_table': 'professional_collaboration_type',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalCertificate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('certificate_name', models.CharField(blank=True, help_text='Certificates', max_length=100, null=True)),
                ('certificate', models.FileField(blank=True, help_text='Certificates', null=True, upload_to='professional_certificates')),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Certificate')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Certificate',
                'db_table': 'professional_certificate',
            },
        ),
    ]
