from nested_admin import NestedModelAdmin
from django.contrib import admin
from .models import *
# Register your models here.


@admin.register(Review)
class ReviewAdmin(NestedModelAdmin):
    model = Review
    search_fields = ['rated_by', 'rated_to']
    list_display = ['rating', 'review', 'is_deleted']


@admin.register(VenueReviewAndRating)
class VenueReviewAndRatingAdmin(NestedModelAdmin):
    model = VenueReviewAndRating
    list_display = ['id', 'venue', 'rating', 'review',
                    'created_by', 'created_at', 'updated_at']


@admin.register(ProfessionalReviewAndRating)
class ProfessionalReviewAndRating(NestedModelAdmin):
    model = ProfessionalReviewAndRating
    list_display = ['id', 'professional', 'rating', 'review',
                    'created_by', 'created_at', 'updated_at']