# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('venues', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('professionals', '0001_initial'),
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='VenueReviewAndRating',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rating', models.IntegerField(blank=True, null=True)),
                ('review', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Reviews And Rating',
                'db_table': 'venue_review_rating',
            },
        ),
        migrations.CreateModel(
            name='Review',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rating', models.IntegerField(blank=True, null=True)),
                ('review', models.TextField(blank=True, max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('rated_to_id', models.PositiveIntegerField(blank=True, null=True)),
                ('rated_by_id', models.PositiveIntegerField(blank=True, null=True)),
                ('rated_by_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='Rated_By', to='contenttypes.ContentType')),
                ('rated_to_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='Rated_To', to='contenttypes.ContentType')),
            ],
            options={
                'verbose_name_plural': 'Review',
                'db_table': 'review',
            },
        ),
        migrations.CreateModel(
            name='ProfessionalReviewAndRating',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rating', models.IntegerField(blank=True, null=True)),
                ('review', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('professional', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='professionals.Professional')),
            ],
            options={
                'verbose_name_plural': 'Professional Reviews And Rating',
                'db_table': 'professional_review_rating',
            },
        ),
    ]
