from django.db import models

from django.core.validators import MaxValueValidator, MinValueValidator

from django.contrib.auth.models import User
from storages.backends.s3boto import S3BotoStorage
from django.core.exceptions import ValidationError
from static_data.models import *

# Create your models here.


class S3CustomStorage(S3BotoStorage):
    def _normalize_name(self, name):
        """
        S3 Storage function for storing files
        """
        return name


class Salesman(models.Model):
    """ Salesman """

    first_name = models.CharField(
        max_length=100, null=True, help_text="user first name")
    last_name = models.CharField(
        max_length=100, null=True, help_text="user last name")

    vat = models.CharField(
        max_length=100, null=True, blank=True, help_text=" vat")
    mobile = models.CharField(max_length=15, null=True,
                              blank=True, help_text="user mobile number")
    phone_number = models.CharField(max_length=15, null=True, blank=True)
    id_card_number = models.CharField(
        max_length=100, null=True, blank=True, help_text="user id card number")
    user_code = models.CharField(
        max_length=6, null=True, blank=True, help_text="user code")
    street = models.CharField(max_length=50, blank=True,
                              null=True, help_text="street")
    number = models.CharField(max_length=50, blank=True,
                              null=True, help_text="number")
    city = models.ForeignKey(
        City, on_delete=models.CASCADE, blank=True, null=True)
    country = models.ForeignKey(
        Country, on_delete=models.CASCADE, blank=True, null=True)
    area = models.ForeignKey(
        Area, on_delete=models.CASCADE, blank=True, null=True)
    state = models.ForeignKey(
        State, on_delete=models.CASCADE, blank=True, null=True)
    pincode = models.CharField(
        max_length=10, blank=True, null=True, help_text="pincode")
    # venue_owner_number = models.IntegerField(
    #     blank=True, null=True, help_text="venue_owner_number")
    # advertiser_number = models.IntegerField(
    #     blank=True, null=True, help_text="advertiser_number")
    # professional_number = models.IntegerField(
    #     blank=True, null=True, help_text="professional_number")
    is_deleted = models.BooleanField(
        default=False, help_text="delete/restore user")

    created_at = models.DateTimeField(auto_now_add=True, blank=True, null=True)
    updated_at = models.DateTimeField(auto_now=True, blank=True, null=True)

    def __str__(self):
        return "{}-{}".format(self.first_name, self.last_name)

    class Meta:
        verbose_name_plural = "Salesman"
        db_table = 'salesman'
