from rest_framework import serializers
from django.contrib.auth.models import User, Group
from rest_framework.authtoken.models import Token
from django.contrib.contenttypes.models import ContentType
from django.db import transaction
from utils.api_handle_errors import handle_errors
from .models import *
from static_data.models import *
from static_data.serializers import *
from venues.serializers import VenueFieldSerializer
from commonAPI.models import *
from commonAPI.serializers import *
#from commonAPI.serializers import ContactInfoProfileSerializer, BankInfoProfileSerializer, ContactPersonSerializer
from django.db import transaction
from venues.models import *
from venues.serializers import *
from django.utils import timezone
from players.models import *
import datetime


class SalesmanPostSerializer(serializers.ModelSerializer):
    id = serializers.IntegerField(required=False, help_text="Salesman ID")

    class Meta:
        model = Salesman
        fields = '__all__'
        extra_kwargs = {
            'mobile': {'required': True},
            'user_code': {'required': True},
            'city': {'required': True},
            'country': {'required': True},
            'area': {'required': True},
            'state': {'required': True},
            'pincode': {'required': True},
            'id_card_number': {'required': True},
            'phone_number': {'required': True},
            'first_name': {'required': True},
            'last_name': {'required': True},
            'venue_owner_number': {'required': True},
            'advertiser_number': {'required': True},
            'professional_number': {'required': True},

        }


class SalesmanGetSerializer(serializers.Serializer):
    id = serializers.IntegerField(required=False, help_text="Salesman ID")


class SalesmanSerializer(serializers.ModelSerializer):

    class Meta:
        model = Salesman
        fields = '__all__'


class SalesmanGetandFilterSerializer(serializers.ModelSerializer):
    keyword = serializers.CharField(
        required=False, help_text="(first_name, last_name,venue_owner_number, professional_number, advertiser_number)")
    vats = serializers.CharField(
        required=False, help_text="Vat")
    user_code = serializers.CharField(
        required=False, help_text="user_code")
    page = serializers.IntegerField(
        required=False, default=1, help_text="Page number. Default = 1")

    class Meta:
        model = Salesman
        fields = '__all__'
        read_only_fields = ['first_name', 'last_name', 'vat', 'mobile', 'phone_number', 'id_card_number', 'user_code', 'street', 'number',
                            'city', 'country', 'area', 'state', 'pincode', 'is_deleted', 'created_at', 'updated_at', 'venue_owner_number', 'professional_number', 'advertiser_number']
