import tablib
from django.http import HttpResponseRedirect, HttpResponse
from django.forms import CharField
from django.utils.encoding import force_text
from import_export.forms import ConfirmImportForm
from nested_admin import NestedModelAdmin
from django.contrib import admin
from .models import *
from import_export import resources
from import_export.admin import ImportExportModelAdmin
from import_export.admin import ExportActionMixin, ImportMixin
from django.utils.decorators import method_decorator
from django.views.decorators.http import require_POST
from django.utils.translation import ugettext_lazy as _
from django.template.response import TemplateResponse


# Register your models here.


@admin.register(Skill)
class SkillAdmin(NestedModelAdmin):
    model = Skill
    search_fields = ['skill_name']
    list_display = ['id', 'skill_name', 'profession', 'profession']


@admin.register(UserType)
class UserTypeAdmin(NestedModelAdmin):
    model = UserType
    list_display = ['id', 'name']


@admin.register(Profession)
class ProfessionAdmin(NestedModelAdmin):
    model = Profession
    search_fields = ['professionName']
    list_display = ['id', 'professionName', 'created_at']


@admin.register(DayofWeek)
class DayofWeekAdmin(NestedModelAdmin):
    model = DayofWeek
    list_display = ['id', 'dayofweek']


@admin.register(VenueService)
class VenueServiceAdmin(NestedModelAdmin):
    model = VenueService
    list_display = ['id', 'name', 'type', 'service_available']


@admin.register(VenuePermission)
class VenuePermissionAdmin(NestedModelAdmin):
    model = VenuePermission
    list_display = ['id', 'name']


@admin.register(Sport)
class SportAdmin(NestedModelAdmin):
    model = Sport
    list_display = ['id', 'name', 'play_type', 'catagory',
                    'show_on_homepage', 'parent_sport']


@admin.register(Position)
class PositionAdmin(NestedModelAdmin):
    model = Position
    list_display = ['id', 'sport', 'position']


@admin.register(FieldType)
class FieldTypeAdmin(NestedModelAdmin):
    model = FieldType
    list_display = ['id', 'name', ]


@admin.register(FloorType)
class FloorTypeAdmin(NestedModelAdmin):
    model = FloorType
    list_display = ['id', 'name', ]


@admin.register(FieldAttribute)
class FieldAttributeAdmin(NestedModelAdmin):
    model = FieldAttribute
    list_display = ['id', 'name']


@admin.register(NotificationIcon)
class NotificationIconAdmin(NestedModelAdmin):
    model = NotificationIcon
    list_display = ['id', 'name']


@admin.register(AdminIcons)
class AdminIconAdmin(NestedModelAdmin):
    model = AdminIcons
    list_display = ['id']


@admin.register(BankName)
class BankNameAdmin(NestedModelAdmin):
    model = BankName
    list_display = ['id', 'name']


@admin.register(TelephoneCountryCode)
class TelephoneCountryCodeAdmin(NestedModelAdmin):
    model = TelephoneCountryCode
    list_display = ['id', 'country_name', 'country_code']


@admin.register(Region)
class RegionAdmin(NestedModelAdmin):
    model = Region
    list_display = ['id', 'name', 'country']


@admin.register(TeamLevel)
class TeamLevelAdmin(NestedModelAdmin):
    model = TeamLevel
    list_display = ['id', 'name']


@admin.register(FacilityType)
class FacilityTypeAdmin(NestedModelAdmin):
    model = FacilityType
    list_display = ['id', 'name']


@admin.register(Lights)
class LightsAdmin(NestedModelAdmin):
    model = Lights
    list_display = ['id', 'name', 'sport']


@admin.register(PaymentMethod)
class PaymentMethodAdmin(NestedModelAdmin):
    model = PaymentMethod
    list_display = ['id', 'name', 'created_at']


@admin.register(BookingCancellation)
class BookingCancellationMethodAdmin(NestedModelAdmin):
    model = BookingCancellation
    list_display = ['id', 'cancellation_reason']


@admin.register(CancellationPolicy)
class CancellationPolicyMethodAdmin(NestedModelAdmin):
    model = CancellationPolicy
    list_display = ['id', 'charge_rate', 'start_time', 'end_time']


@admin.register(CollaborationTypes)
class CancellationPolicyMethodAdmin(NestedModelAdmin):
    model = CollaborationTypes
    list_display = ['id', 'collaboration_name']


@admin.register(Covid19Measures)
class Covid19MeasuresMethodAdmin(NestedModelAdmin):
    model = Covid19Measures
    list_display = ['id', 'description']


@admin.register(Template_Images)
class Template_ImagesAdmin(NestedModelAdmin):
    model = Template_Images
    list_display = ['id', 'template_image']


@admin.register(MeasurementUnits)
class MeasurementUnitsAdmin(NestedModelAdmin):
    model = MeasurementUnits
    list_display = ['id', 'measurement_code', 'measurement_description']


@admin.register(VatExemptionOrder)
class VatExemptionOrderUnitsAdmin(NestedModelAdmin):
    model = VatExemptionOrder
    list_display = ['id', 'vat_exemption_order_code',
                    'vat_exemption_order_description']


@admin.register(Vat)
class VatAdmin(NestedModelAdmin):
    model = Vat
    list_display = ['id', 'vat_code', 'vat_description',
                    'vat_standard', 'vat_reduced', 'vat_exemption']


@admin.register(BookingPaymentMethod)
class BookingPaymentMethodAdmin(NestedModelAdmin):
    model = BookingPaymentMethod
    list_display = ['id', 'payment_method_code', 'payment_method_description']


@admin.register(MIXED_GENDER)
class MIXED_GENDERAdmin(NestedModelAdmin):
    model = MIXED_GENDER
    list_display = ['id', 'name', 'sport']


@admin.register(AVAILABILITY_IN_USE)
class AVAILABILITY_IN_USEAdmin(NestedModelAdmin):
    model = AVAILABILITY_IN_USE
    list_display = ['id', 'name', 'sport']


@admin.register(DocNumberingSeries)
class DocNumberingSeriesAdmin(NestedModelAdmin):
    model = DocNumberingSeries
    list_display = ['id', 'code', 'is_deleted']


@admin.register(DocumentType)
class DocumentTypeAdmin(NestedModelAdmin):
    model = DocumentType
    list_display = ['id', 'code', 'is_deleted']


@admin.register(TransferPurpose)
class TransferPurposeAdmin(NestedModelAdmin):
    model = TransferPurpose
    list_display = ['id', 'code', 'is_deleted']


@admin.register(TransferMethod)
class TransferMethodAdmin(NestedModelAdmin):
    model = TransferMethod
    list_display = ['id', 'code', 'is_deleted']


@admin.register(MeansOfTransport)
class MeansOfTransportAdmin(NestedModelAdmin):
    model = MeansOfTransport
    list_display = ['id', 'code', 'is_deleted']


@admin.register(DocumentTypeDocNumberingSeries)
class DocumentTypeDocNumberingSeriesAdmin(NestedModelAdmin):
    model = DocumentTypeDocNumberingSeries
    list_display = ['id', 'document_type', 'document_numbering_series']


@admin.register(PlayerLevel)
class PlayerLevelAdmin(NestedModelAdmin):
    model = PlayerLevel
    list_display = ['id', 'name']


@admin.register(StaticProfessionalService)
class StaticProfessionalServiceAdmin(NestedModelAdmin):
    model = StaticProfessionalService
    list_display = ['id', 'profession', 'service']


@admin.register(Country)
class CountryAdmin(NestedModelAdmin):
    model = Country
    list_display = ['id', 'name']


@admin.register(State)
class StateAdmin(NestedModelAdmin):
    model = State
    list_display = ['id', 'name', 'country']


@admin.register(City)
class CityAdmin(NestedModelAdmin):
    model = City
    list_display = ['id', 'name', 'state']


def add_model_data(single_entry, keyword, model, fk_keyword=False, fk_key=False, **kwargs):
    if keyword in single_entry:
        keyword_data = single_entry[keyword]
        data_obj, created = model.objects.get_or_create(name=keyword_data)
        if fk_keyword:
            setattr(data_obj, fk_key, single_entry[fk_keyword])
            data_obj.save()
            # add_sub_record(data_obj, single_entry[fk_keyword], fk_model)
        single_entry[keyword] = data_obj
    else:
        single_entry[keyword] = None
    return single_entry


def add_area_data(dataset):
    city_model = City
    country_model = Country
    state_model = State
    area_model = Area
    new_dataset = tablib.Dataset()

    for single_entry in dataset.dict:
        dict_new = dict()
        if single_entry['name'] == "":
            continue
        single_entry = add_model_data(single_entry, "country", country_model)
        single_entry = add_model_data(
            single_entry, "prefectures", state_model, "country", "country")
        single_entry = add_model_data(
            single_entry, "city", city_model, "prefectures", "state")
        dict_new['pk'] = int(single_entry['id'])
        dict_new['name'] = single_entry['name']
        dict_new['city'] = single_entry['city'].id
        new_dataset.append(list(dict_new.values()))
    new_dataset.headers = ['id', 'name', 'city']
    return new_dataset


def import_action_method(self, request, keyword, change_data_model, *args, **kwargs):
    if not self.has_import_permission(request):
        raise PermissionDenied

    resource = self.get_import_resource_class()(
        **self.get_import_resource_kwargs(request, *args, **kwargs))

    context = self.get_import_context_data()

    import_formats = self.get_import_formats()
    form_type = self.get_import_form()
    form = form_type(import_formats,
                     request.POST or None,
                     request.FILES or None)

    if request.POST and form.is_valid():
        input_format = import_formats[
            int(form.cleaned_data['input_format'])
        ]()
        import_file = form.cleaned_data['import_file']
        # first always write the uploaded file to disk as it may be a
        # memory file or else based on settings upload handlers
        tmp_storage = self.write_to_tmp_storage(import_file, input_format)

        # then read the file, using the proper format-specific mode
        # warning, big files may exceed memory
        try:
            data = tmp_storage.read(input_format.get_read_mode())
            if not input_format.is_binary() and self.from_encoding:
                data = force_text(data, self.from_encoding)
            dataset = input_format.create_dataset(data)

            # dataset = self.add_states(dataset)
            dataset = add_area_data(dataset)
        except UnicodeDecodeError as e:
            return HttpResponse(_(u"<h1>Imported file has a wrong encoding: %s</h1>" % e))
        except Exception as e:
            return HttpResponse(_(u"<h1>%s encountered while trying to read file: %s</h1>" % (type(e).__name__, import_file.name)))
        result = resource.import_data(dataset, dry_run=True,
                                      raise_errors=False,
                                      file_name=import_file.name,
                                      user=request.user)

        context['result'] = result

        if not result.has_errors() and not result.has_validation_errors():
            context['confirm_form'] = ConfirmImportForm(initial={
                'import_file_name': tmp_storage.name,
                'original_file_name': import_file.name,
                'input_format': form.cleaned_data['input_format'],
            })

    context.update(self.admin_site.each_context(request))

    context['title'] = _("Import")
    context['form'] = form
    context['opts'] = self.model._meta
    context['fields'] = [
        f.column_name for f in resource.get_user_visible_fields()
    ]

    request.current_app = self.admin_site.name
    return TemplateResponse(request, [self.import_template_name],
                            context)


def process_import_method(self, request, keyword, change_data_model, *args, **kwargs):
    if not self.has_import_permission(request):
        raise PermissionDenied
    confirm_form = ConfirmImportForm(request.POST)
    if confirm_form.is_valid():
        import_formats = self.get_import_formats()
        input_format = import_formats[
            int(confirm_form.cleaned_data['input_format'])
        ]()
        tmp_storage = self.get_tmp_storage_class()(
            name=confirm_form.cleaned_data['import_file_name'])
        data = tmp_storage.read(input_format.get_read_mode())
        if not input_format.is_binary() and self.from_encoding:
            data = force_text(data, self.from_encoding)
        dataset = input_format.create_dataset(data)
        # dataset = self.add_states(dataset)
        dataset = add_area_data(dataset)

        result = self.process_dataset(
            dataset, confirm_form, request, *args, **kwargs)

        tmp_storage.remove()

        return self.process_result(result, request)


class AreaResource(resources.ModelResource):
    class Meta:
        model = Area
        list_display = ['id', 'name', 'city']
        fields = ('id', 'name', 'city', 'PREFECTURES', 'COUNTRY')


class AreaAdmin(ImportExportModelAdmin):
    resource_class = AreaResource

    def import_action(self, request, *args, **kwargs):
        '''
        Perform a dry_run of the import to make sure the import will not
        result in errors.  If there where no error, save the user
        uploaded file to a local temp file that will be used by
        'process_import' for the actual import.
        '''
        return import_action_method(self, request, "city", City, *args, **kwargs)

    @method_decorator(require_POST)
    def process_import(self, request, *args, **kwargs):
        return process_import_method(self, request, "city", City, *args, **kwargs)


admin.site.register(Area, AreaAdmin)


# @admin.register(Country)
# class CountryAdmin(NestedModelAdmin):
#     model = Country
#     list_display = ['id', 'name']


# @admin.register(State)
# class StateAdmin(NestedModelAdmin):
#     model = State
#     list_display = ['id', 'name', 'country']

# class CityAdmin(NestedModelAdmin):
#     model = City
#     list_display = ['id', 'name', 'state']


# def add_data(dataset, keyword, model):
#     new_dataset = tablib.Dataset()

#     for single_entry in dataset.dict:
#         if keyword in single_entry:
#             keyword_data = single_entry[keyword]
#             data_obj, created = model.objects.get_or_create(name=keyword_data)
#             single_entry[keyword] = data_obj.id
#         else:
#             single_entry[keyword] = None
#         new_dataset.append(list(single_entry.values()))
#     new_dataset.headers = ['id', 'name', keyword]
#     return new_dataset


# class CountryResource(resources.ModelResource):
#     class Meta:
#         model = Country
#         list_display = ['id', 'name']


# class CountryAdmin(ImportExportModelAdmin):
#     resource_class = CountryResource

# admin.site.register(Country, CountryAdmin)


# class StateResource(resources.ModelResource):
#     class Meta:
#         model = State
#         list_display = ['id', 'name', 'country']
#         fields = ('id', 'name', 'country')


# class StateAdmin(ImportExportModelAdmin):
#     resource_class = StateResource

#     def import_action(self, request, *args, **kwargs):
#         '''
#         Perform a dry_run of the import to make sure the import will not
#         result in errors.  If there where no error, save the user
#         uploaded file to a local temp file that will be used by
#         'process_import' for the actual import.
#         '''
#         return import_action_method(self, request, "country", Country, *args, **kwargs)

#     @method_decorator(require_POST)
#     def process_import(self, request, *args, **kwargs):
#         return process_import_method(self, request,"country", Country, *args, **kwargs)


# admin.site.register(State, StateAdmin)


# class CityResource(resources.ModelResource):
#     state = CharField(required=False)

#     class Meta:
#         model = City
#         list_display = ['id', 'name', 'state']
#         fields = ('id', 'name', 'state')


# class CityAdmin(ImportMixin, admin.ModelAdmin):
#     resource_class = CityResource


#     def import_action(self, request, *args, **kwargs):
#         '''
#         Perform a dry_run of the import to make sure the import will not
#         result in errors.  If there where no error, save the user
#         uploaded file to a local temp file that will be used by
#         'process_import' for the actual import.
#         '''
#         return import_action_method(self, request, "state", State, *args, **kwargs)

#     @method_decorator(require_POST)
#     def process_import(self, request, *args, **kwargs):
#         return process_import_method(self, request,"state", State, *args, **kwargs)

# admin.site.register(City, CityAdmin)
