from utils.custom_exceptions import NoIdException, InvalidIdException, IdInUseException
import re
from invoicing.functionalities import CheckIfUsedByInvoice
from static_data.models import *


def delete_record(self, request):
    """
    Delete Static Records
    """
    dict_obj = {DocumentType: "document_type", DocNumberingSeries: "doc_numbering_series",
                TransferPurpose: "transfer_purpose", TransferMethod: "transfer_method", MeansOfTransport: "means_of_transport"}

    id = request.GET.get('id', False)
    if not id:
        raise NoIdException()

    data_obj = self.serializer_class.Meta.model.objects.filter(
        id=id, is_deleted=False)
    if data_obj.exists():
        data_obj = data_obj.last()
    else:
        raise InvalidIdException()

    invoice_check = CheckIfUsedByInvoice({dict_obj[self.serializer_class.Meta.model]:data_obj}, "Static")
    if invoice_check:
        print("checl")
        raise IdInUseException()
    data_obj.is_deleted = True
    data_obj.save()

    return True


def save_edit_invoices(self):
    """
    Save Edit Invoices
    """
    if 'id' in self.validated_data:
        self.validated_data['id'].description = self.validated_data.get(
            "description", self.validated_data['id'].description)
        self.validated_data['id'].save()
        return self.validated_data['id']
    self.validated_data.pop('id', False)
    print(self.validated_data)
    obj_id = self.Meta.model.objects.create(**self.validated_data)
    return obj_id


def validate_id(self, value):
    """
    Validate Invoice IDs
    """
    data_obj = self.Meta.model.objects.filter(id=value, is_deleted=False)
    if data_obj.exists():
        return data_obj.last()
    raise Exception("Invalid ID")


def validate_code(self, value):
    """
    Validate Invoice Codes
    """
    if self.Meta.model.objects.filter(code=value, is_deleted=False).exclude(**self.context).exists():
        raise Exception("Code is already in use")
    regex = "^[a-zA-Z0-9]*$"
    if re.search(regex, value):
        return value
    else:
        raise Exception("Code is not Alpha Numeric")
