from static_data.models import Skill, StaticProfessionalService
from utils.api_handle_errors import handle_errors

def save_skill_service(mode, new_status, pk_obj):
    if new_status != "ACCEPTED":
        return 0
    if mode == "skill":
        Skill.objects.create(profession=pk_obj.profession, skill_name=pk_obj.skill_name)
    else:
        StaticProfessionalService.objects.create(profession=pk_obj.profession, service=pk_obj.service_name)

def get_levels(serializer_class):
    obj_data = serializer_class.Meta.model.objects.all()
    obj_class = serializer_class(obj_data, many=True)
    return obj_class.data


def delete_levels(serializer_class, id):
    obj_data = serializer_class.Meta.model.objects.filter(id=id)
    if obj_data.exists():
        obj_data = obj_data.last()
    else:
        raise ValueError("No Record with Id Found")
    obj_data.delete()


def insert_levels(serializer_class, data):
    serializers = serializer_class(data=data)
    if serializers.is_valid():
        serializers.save()
        return "Successfully Inserted"
    else:
        raise RuntimeError(handle_errors(serializers.errors))


def update_levels(serializer_class, data, id):
    obj_data = serializer_class.Meta.model.objects.filter(id=id)
    serializers = serializer_class(instance=obj_data,data=data)
    if serializers.is_valid():
        serializers.save()
        return "Successfully Updated"
    else:
        raise RuntimeError(handle_errors(serializers.errors))