# Generated by Django 2.2 on 2021-10-17 05:59

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='AdminIcons',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('icon', models.ImageField(blank=True, null=True, upload_to='admin_icons')),
            ],
            options={
                'verbose_name_plural': 'Admin Icons',
                'db_table': 'admin_icon',
            },
        ),
        migrations.CreateModel(
            name='BankName',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Bank Name',
                'db_table': 'bank_name',
            },
        ),
        migrations.CreateModel(
            name='BookingCancellation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('cancellation_reason', models.CharField(blank=True, max_length=600, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Booking Cancellation',
                'db_table': 'Booking_Cancellation',
            },
        ),
        migrations.CreateModel(
            name='BookingPaymentMethod',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('payment_method_code', models.CharField(blank=True, max_length=50, null=True, unique=True)),
                ('payment_method_description', models.CharField(blank=True, max_length=500, null=True)),
            ],
            options={
                'verbose_name_plural': 'booking payment method',
                'db_table': 'booking_payment_method',
            },
        ),
        migrations.CreateModel(
            name='CancellationPolicy',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('charge_rate', models.CharField(blank=True, max_length=100, null=True)),
                ('start_time', models.IntegerField(blank=True, null=True)),
                ('end_time', models.IntegerField(blank=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Cancellation Policy',
                'db_table': 'Cancellation_Policy',
            },
        ),
        migrations.CreateModel(
            name='CollaborationTypes',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('collaboration_name', models.CharField(blank=True, max_length=500, null=True)),
            ],
            options={
                'verbose_name_plural': 'Collaboration Types',
                'db_table': 'Collaboration_Types',
            },
        ),
        migrations.CreateModel(
            name='Country',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Countries',
                'db_table': 'country',
            },
        ),
        migrations.CreateModel(
            name='Covid19Measures',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, max_length=500, null=True)),
            ],
            options={
                'verbose_name_plural': 'Covid19Measures',
                'db_table': 'Covid19Measures',
            },
        ),
        migrations.CreateModel(
            name='DayofWeek',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('dayofweek', models.CharField(blank=True, choices=[('SUNDAY', 'Sunday'), ('MONDAY', 'Monday'), ('TUESDAY', 'Tuesday'), ('WEDNESDAY', 'Wednesday'), ('THURSDAY', 'Thursday'), ('FRIDAY', 'Friday'), ('SATURDAY', 'Saturday')], max_length=50, null=True)),
            ],
            options={
                'verbose_name_plural': 'Day of Week',
                'db_table': 'dayofweek',
            },
        ),
        migrations.CreateModel(
            name='DocNumberingSeries',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Doc Numbering Series',
                'db_table': 'doc_numbering_series',
            },
        ),
        migrations.CreateModel(
            name='DocumentType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Document Types',
                'db_table': 'document_type',
            },
        ),
        migrations.CreateModel(
            name='FieldAttribute',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Field Attributes',
                'db_table': 'field_attribute',
            },
        ),
        migrations.CreateModel(
            name='MeansOfTransport',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Means Of Transports',
                'db_table': 'means_of_transport',
            },
        ),
        migrations.CreateModel(
            name='MeasurementUnits',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('measurement_code', models.CharField(blank=True, max_length=50, null=True, unique=True)),
                ('measurement_description', models.CharField(blank=True, max_length=500, null=True)),
            ],
            options={
                'verbose_name_plural': 'Measurement Unit',
                'db_table': 'measurement_units',
            },
        ),
        migrations.CreateModel(
            name='NotificationIcon',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('icons', models.ImageField(blank=True, null=True, upload_to='notification_icons')),
            ],
            options={
                'verbose_name_plural': 'Notification Icons',
                'db_table': 'notification_icon',
            },
        ),
        migrations.CreateModel(
            name='PaymentMethod',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Payment Method',
                'db_table': 'payment_method',
            },
        ),
        migrations.CreateModel(
            name='PlayerLevel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
            ],
            options={
                'verbose_name_plural': 'Player Level',
                'db_table': 'player_level',
            },
        ),
        migrations.CreateModel(
            name='Profession',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('professionName', models.CharField(max_length=200)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Static Profession',
                'db_table': 'static_profession',
            },
        ),
        migrations.CreateModel(
            name='TeamLevel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
            ],
            options={
                'verbose_name_plural': 'Team Level',
                'db_table': 'team_level',
            },
        ),
        migrations.CreateModel(
            name='TelephoneCountryCode',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('country_name', models.CharField(blank=True, max_length=100, null=True)),
                ('country_code', models.CharField(blank=True, max_length=100, null=True)),
            ],
            options={
                'verbose_name_plural': 'Country Codes',
                'db_table': 'country_code',
            },
        ),
        migrations.CreateModel(
            name='Template_Images',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('template_image', models.FileField(blank=True, help_text='template images', null=True, upload_to='template_images/')),
            ],
            options={
                'verbose_name_plural': 'Template Image',
                'db_table': 'template_images',
            },
        ),
        migrations.CreateModel(
            name='TransferMethod',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Transfer Method',
                'db_table': 'transfer_method',
            },
        ),
        migrations.CreateModel(
            name='TransferPurpose',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(blank=True, help_text='Code', max_length=5, null=True)),
                ('description', models.CharField(blank=True, help_text='Description', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, help_text='If the record is deleted', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Transfer Purposes',
                'db_table': 'transfer_purpose',
            },
        ),
        migrations.CreateModel(
            name='UserType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, choices=[('VENUE OWNER', 'Venue Owner'), ('PROFESSIONAL', 'Professional'), ('PLAYER', 'Player'), ('ADVERTISER', 'Advertiser'), ('VISITOR', 'Visitor')], help_text='user type choice', max_length=50, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'User Types',
                'db_table': 'user_type',
            },
        ),
        migrations.CreateModel(
            name='Vat',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('vat_code', models.CharField(blank=True, max_length=50, null=True, unique=True)),
                ('vat_description', models.CharField(blank=True, max_length=500, null=True)),
                ('vat_standard', models.CharField(blank=True, max_length=500, null=True)),
                ('vat_reduced', models.CharField(blank=True, max_length=500, null=True)),
                ('vat_exemption', models.CharField(blank=True, max_length=500, null=True)),
            ],
            options={
                'verbose_name_plural': 'vat',
                'db_table': 'vat',
            },
        ),
        migrations.CreateModel(
            name='VatExemptionOrder',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('vat_exemption_order_code', models.CharField(blank=True, max_length=50, null=True, unique=True)),
                ('vat_exemption_order_description', models.CharField(blank=True, max_length=500, null=True)),
            ],
            options={
                'verbose_name_plural': 'vat exemption order',
                'db_table': 'vat_exemption_order',
            },
        ),
        migrations.CreateModel(
            name='VenuePermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='venue_permission')),
            ],
            options={
                'verbose_name_plural': 'Venue Entry',
                'db_table': 'venue_permission',
            },
        ),
        migrations.CreateModel(
            name='VenueService',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='service_icons')),
                ('type', models.CharField(blank=True, choices=[('P', 'Paid'), ('F', 'Free')], default='F', max_length=10, null=True)),
                ('service_available', models.CharField(blank=True, choices=[('V', 'Venue'), ('F', 'Field'), ('B', 'Both')], default='V', max_length=10, null=True)),
            ],
            options={
                'verbose_name_plural': 'Venue Services',
                'db_table': 'venue_service',
            },
        ),
        migrations.CreateModel(
            name='StaticProfessionalService',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('service', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('profession', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Profession')),
            ],
            options={
                'verbose_name_plural': 'Professional Services',
                'db_table': 'static_professional_services',
            },
        ),
        migrations.CreateModel(
            name='State',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
            ],
            options={
                'verbose_name_plural': 'State',
                'db_table': 'state',
            },
        ),
        migrations.CreateModel(
            name='Sport',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('play_type', models.CharField(blank=True, choices=[('T', 'Team'), ('I', 'Individual')], default='I', help_text='Type of Play - Team/Individual', max_length=15, null=True)),
                ('catagory', models.CharField(blank=True, choices=[('Sports', 'Sports'), ('Winter Sports', 'Winter Sports'), ('Summer Sports', 'Summer Sports'), ('All Seasons Sports', 'All Seasons Sports')], help_text='Sports=Sports,Winter Sports=Winter Sports,Summer Sports,All Seasons Sports', max_length=20, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('show_on_homepage', models.BooleanField(default=False, help_text="True=show on homepage/False=don't show")),
                ('parent_sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Sports',
                'db_table': 'sport',
            },
        ),
        migrations.CreateModel(
            name='Skill',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('skill_name', models.CharField(blank=True, max_length=100)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('profession', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Profession')),
            ],
            options={
                'verbose_name_plural': 'Step Skills',
                'db_table': 'step_skills',
            },
        ),
        migrations.CreateModel(
            name='Region',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
            ],
            options={
                'verbose_name_plural': 'Region',
                'db_table': 'region',
            },
        ),
        migrations.CreateModel(
            name='Position',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('position', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Sports_Position',
                'db_table': 'sport_position',
            },
        ),
        migrations.CreateModel(
            name='MIXED_GENDER',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Mixed Genders',
                'db_table': 'mixed_gender',
            },
        ),
        migrations.CreateModel(
            name='Lights',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Lights',
                'db_table': 'lights',
            },
        ),
        migrations.CreateModel(
            name='FloorType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ManyToManyField(blank=True, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Floor Type',
                'db_table': 'floor_type',
            },
        ),
        migrations.CreateModel(
            name='FieldType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ManyToManyField(blank=True, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Field Types',
                'db_table': 'field_type',
            },
        ),
        migrations.CreateModel(
            name='FacilityType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ManyToManyField(blank=True, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Facility Type',
                'db_table': 'facility_type',
            },
        ),
        migrations.CreateModel(
            name='DocumentTypeDocNumberingSeries',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('document_numbering_series', models.ForeignKey(help_text='Document Numbering System', on_delete=django.db.models.deletion.CASCADE, to='static_data.DocNumberingSeries')),
                ('document_type', models.ForeignKey(help_text='Document Type', on_delete=django.db.models.deletion.CASCADE, to='static_data.DocumentType')),
            ],
            options={
                'verbose_name_plural': 'Document Type Numbering Series',
                'db_table': 'document_type_numbering_series',
            },
        ),
        migrations.CreateModel(
            name='City',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.State')),
            ],
            options={
                'verbose_name_plural': 'City',
                'db_table': 'city',
            },
        ),
        migrations.CreateModel(
            name='AVAILABILITY_IN_USE',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Availability In Use',
                'db_table': 'availability_in_use',
            },
        ),
        migrations.CreateModel(
            name='Area',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=800, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
            ],
            options={
                'verbose_name_plural': 'Areas',
                'db_table': 'area',
            },
        ),
    ]
