import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.urls import reverse

from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated
from utils.mixins import PlatformAPICallMixin
from utils.api_handle_errors import handle_errors

from static_data.serializers import *
from static_data.models import *


class GetProfessionAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    Get  All Profession
    '''
    #authentication_classes = (TokenAuthentication,)
    #permission_classes = (IsAuthenticated,)
    serializer_class = ProfessionSerializer
    # Get All Skills

    def get(self, request, format=None):
        try:
            response = {}
            responsedata = []
            data = Profession.objects.all()
            response['result'] = 1
            serializer = self.serializer_class(data, many=True)
            response['data'] = serializer.data
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_200_OK)
        except Exception as e:
            response["result"] = 0
            response['errors'] = responsedata.append(str(e))
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
