import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.urls import reverse

from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated
from utils.mixins import PlatformAPICallMixin
from utils.api_handle_errors import handle_errors

from static_data.serializers import *
from static_data.models import *


class SportsGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    Get  All Sports
    '''
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = SportSerializer
    # Get All Sports

    def get(self, request, format=None):
        response = {}
        responsedata = []
        data = Sport.objects.all()
        serializer = self.serializer_class(data, many=True)
        response['result'] = 1
        response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)


class SpportsCategoryAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    '''
    Get all sports according to category
    '''
    serializer_class = SportCategorySerializer
    # get sports by groups

    def get(self, request, format=None):
        count = 1
        response = {}
        responsedata = []
        data_sports = Sport.objects.filter(
            catagory='Sports').values('name', 'id')
        data_winter_sports = Sport.objects.filter(
            catagory='Winter Sports').values('name', 'id')
        data_summer_sports = Sport.objects.filter(
            catagory='Summer Sports').values('name', 'id')
        data_all_season_sports = Sport.objects.filter(
            catagory='All Seasons Sports').values('name', 'id')
        #flat_list_sports = [item for sublist in data_sports for item in sublist]
        #flat_list_winter_sports = [item for sublist in data_sports for item in sublist]
        #flat_list_summer_sports = [item for sublist in data_sports for item in sublist]
        #flat_list_all_season_sports = [item for sublist in data_sports for item in sublist]
        for dict_name in data_sports:
            dict_name['value'] = dict_name['id']

        for dict_name in data_winter_sports:
            dict_name['value'] = dict_name['id']

        for dict_name in data_summer_sports:
            dict_name['value'] = dict_name['id']

        for dict_name in data_all_season_sports:
            dict_name['value'] = dict_name['id']

        #response['result'] = 1
        response['Sports'] = data_sports
        response['Outdoor Activities'] = {}
        response['Outdoor Activities']['Winter Sports'] = data_winter_sports
        response['Outdoor Activities']['Summer Sports'] = data_summer_sports
        response['Outdoor Activities']['All Season Sports'] = data_all_season_sports

        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)
