from django.urls import path, include, re_path
from .views import *


doc_numbering_series = [
    path("", DocNumberingSeriesAPIView.as_view()),
]


auth_urls = [
    path('skills', SkillsSetAPIView.as_view()),
    path('request-skills', RequestSkillAPIView.as_view()),
    path('request-service', RequestServiceAPIView.as_view()),
    path('sport/get', SportsGETAPIView.as_view()),
    path('sportcategory/get', SpportsCategoryAPIView.as_view()),
    path('profession/get', GetProfessionAPIView.as_view()),
    path('field_type/get', FieldTypeGetAPIView.as_view()),
    path('floor_type/get', FloorTypeGetAPIView.as_view()),
    path('field_attribute/get', FieldAttributeGetAPIView.as_view()),
    path('venue_permission/get', VenuePermissionAPIView.as_view()),
    path('sport_position/get', SportsPositionAPIView.as_view()),
    path('days/get', GetDayofWeekAPIView.as_view()),
    path('services/get', ServicesAPIView.as_view()),
    path('user_type/get', UserTypeAPIView.as_view()),
    path('city_country/get', CityCountryGetAPIView.as_view()),

    path('mail/test', MailTestAPIView.as_view()),
    path("bank/get", GetBankAPIView.as_view()),
    path("country_code/get", CountryCodeGetAPIView.as_view()),
    path("country_code/post", CountryCodePOSTAPIView.as_view()),
    path("region/get", RegionGetAPIView.as_view()),
    path("team_level/get", TeamLevelGetAPIView.as_view()),
    path("state_country/get", GetStatesByCountryAPIView.as_view()),
    path("city_state/get", GetCitysByStateAPIView.as_view()),
    path("area_city/get", GetAreasByCityAPIView.as_view()),
    path("country/get", CountryGetAPIView.as_view()),
    path("facility/get", GetfacilitysAPIView.as_view()),
    path("lights/get", GetLightsAPIView.as_view()),
    path("payment_method/get", PaymentMethodAPIView.as_view()),
    path("booking_cancellation/get", BookingCancellationAPIView.as_view()),
    path("booking_cancellation_with_page/get",
         BookingCancellationWithPageAPIView.as_view()),
    path("template_images/get", TemplateImagesGetAPIView.as_view()),
    path("profession_id_service/get", GetServiceByProfessionAPIView.as_view()),
    path("professional_service", ProfessionalStaticServiceListAPIView.as_view()),
    re_path("professional_service/(?P<pk>.+)",
            ProfessionalStaticServiceDetailAPIView.as_view()),
    path("nested_sport_fieldtype/get",
         GetNestedSportsOrFieldtypeBySportsAPIView.as_view()),

    # measurement unit
    path("measurement_unit/post", MeasurementUnitsPOSTAPIView.as_view()),
    path("measurement_unit/get", GetMeasurementUnitsAPIView.as_view()),
    path("measurement_unit/getAll", MeasurementUnitsWithPageAPIView.as_view()),
    path("measurement_unit/edit", MeasurementUnitsEditInfoAPIView.as_view()),
    path("measurement_unit/delete", DeleteMeasurementUnitsAPIView.as_view()),
    path("measurement_unit_without_pagination/getAll",
         MeasurementUnitsWithoutPageAPIView.as_view()),

    # VatExemptionOrder
    path("vat_exemption_order/add/edit",
         VatExemptionOrderPOSTorEDITAPIView.as_view()),
    path("vat_exemption_order/get", GetVatExemptionOrderAPIView.as_view()),
    path("vat_exemption_order/getAll",
         VatExemptionOrderWithPageAPIView.as_view()),
    path("vat_exemption_order/delete", DeleteVatExemptionOrderAPIView.as_view()),
    path("vat_exemption_order_without_pagination/getAll",
         VatExemptionOrderWithoutPageAPIView.as_view()),

    # BookingPaymentMethod
    path("booking_payment_method/add/edit",
         BookingPaymentMethodPOSTorEDITAPIView.as_view()),
    path("booking_payment_method/get", GetBookingPaymentMethodAPIView.as_view()),
    path("booking_payment_method/getAll",
         BookingPaymentMethodWithPageAPIView.as_view()),
    path("booking_payment_method/delete",
         DeleteBookingPaymentMethodAPIView.as_view()),

    # Vat
    path("vat/add/edit", VatPOSTorEDITAPIView.as_view()),
    path("vat/get", GetVatAPIView.as_view()),
    path("vat/getAll", VatWithPageAPIView.as_view()),
    path("vat/delete", DeleteVatAPIView.as_view()),
    path("vat_without_pagination/getAll", VatWithoutPageAPIView.as_view()),

    path("mixed_gender", MixedGenderGetAPIView.as_view()),
    path("availability_in_use", AvailabilityInUseGetAPIView.as_view()),

    # Invoice
    path("get-invoice-static/<str:model_name>/<int:id>",
         GetInvoiceStaticDataAPIView.as_view()),

    path("doc-numbering-series", DocNumberingSeriesAPIView.as_view()),
    path("document-type", DocumentTypeAPIView.as_view()),
    path("document-type-numbering-series",
         DocumentTypeDocNumberingSeriesAPIView.as_view()),
    path("transfer-purpose", TransferPurposeAPIView.as_view()),
    path("transfer-method", TransferMethodAPIView.as_view()),
    path("means-of-transport", MeansOfTransportAPIView.as_view()),


    # Sport by venue
    path('sport_venue/get', GetSportsByVenueAPIView.as_view()),



]

urlpatterns = [
    path('', include(auth_urls)),
]
