from rest_framework.exceptions import APIException

error_status_code = 400

class NoIdException(APIException):
    status_code = error_status_code
    default_detail = 'No ID passed in parameter.'
    default_code = 'id_unavailable'


class InvalidIdException(APIException):
    status_code = error_status_code
    default_detail = 'No Record with given ID.'
    default_code = 'invalid_id'

class IdInUseException(APIException):
    status_code = error_status_code
    default_detail = 'Record with this Id is currently in use.'
    default_code = 'id_unavailable'
