from field_booking.settings import MAILGUN_FROM, MAILGUN_KEY, MAILGUN_URL
from field_booking.settings import AWS_SES_REGION_NAME, AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY, \
    AWS_STORAGE_BUCKET_NAME
from django.core.mail import EmailMultiAlternatives
from django.shortcuts import render, redirect, get_object_or_404
from django.template.loader import get_template
from django.http import HttpResponse

# from afl_backend.settings import FRONTEND_DOMAIN_NAME

from platform_central.models import UserToken, SmsCentral
from utils.mixins import PlatformAPICallMixin
from internal_system.models import InternalUser
import boto3
from botocore.exceptions import ClientError
import requests

# from django.core.mail import send_email

CHARSET = "UTF-8"


# def send_mail_for_reset_password(first_name, link, to):
# 	client = boto3.client('ses',region_name=AWS_SES_REGION_NAME, aws_access_key_id=AWS_ACCESS_KEY_ID,aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
# 	subject   = "No-Reply: Reset Password for SPORTS"
# 	template  = get_template('utils/emailers/forgot_password.html')
# 	# template  = get_template('reset_password_link.html')
# 	email_msg = template.render({
# 		'first_name': first_name,
# 		'link': link
# 	})
# 	try:
# 		response = client.send_email(
# 			Destination={
# 				'ToAddresses': [to]
# 			},
# 			Message={
# 				'Body': {
# 					'Html': {
# 						'Charset': CHARSET,
# 						'Data': email_msg,
# 					},
# 				},
# 				'Subject': {
# 					'Charset': CHARSET,
# 					'Data': subject,
# 				},
# 			},
# 			Source="sports@worldindia.com",
# 		)
# 	except Exception as e:
# 		print(e)
# 		pass


def send_mail_for_reset_password(first_name, link, to, logo, logo2):
    # subject = "No-Reply: Reset Password for SPORTS"
    # template = get_template('utils/emailers/forgot_password.html')
    # # template  = get_template('reset_password_link.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'link': link,
    #     'to': to
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    subject = "No-Reply: Reset Password for SPORTS"
    template = get_template('utils/emailers/forgot_password.html')
    # template  = get_template('reset_password_link.html')
    email_msg = template.render({
        'first_name': first_name,
        'link': link,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })
    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": subject,
                                           "html": email_msg})

    except Exception as e:
        print(e)
        pass


# def email_verification(first_name, link, to):

# 	client = boto3.client('ses',region_name=AWS_SES_REGION_NAME, aws_access_key_id=AWS_ACCESS_KEY_ID,aws_secret_access_key=AWS_SECRET_ACCESS_KEY)

# 	template = get_template('utils/emailers/email_verification.html')
# 	email_msg = template.render({
# 		'first_name': first_name,
# 		'link': link
# 	})

# 	try:
# 		response = client.send_email(
# 			Destination={
# 				'ToAddresses': [to]
# 			},
# 			Message={
# 				'Body': {
# 					'Html': {
# 						'Charset': CHARSET,
# 						'Data': email_msg,
# 					},
# 				},
# 				'Subject': {
# 					'Charset': CHARSET,
# 					'Data': "No-Reply: Email Verification for AFL",
# 				},
# 			},
# 			Source="avadhesh@dixitsir.com",
# 		)
# 	except Exception as e:
# 		print("except")
# 		print(e)
# 		pass


def email_verification(first_name, link, to):
    template = get_template('utils/emailers/email_verification.html')
    email_msg = template.render({
        'first_name': first_name,
        'link': link,
        'to': to
    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Email Verification",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def in_progress_email_verification(first_name, msg, to, logo, logo2):
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/onboard_In_Progress_mail.html')
    email_msg = template.render({
        'first_name': first_name,
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })
    print(str(logo['template_image']))
    print(str(logo2['template_image']))

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Email Verification In Progress",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def send_invitation(first_name, to, link="sportsbookingnew.worldindia.com/"):
    template = get_template('utils/emailers/send_invitation.html')
    email_msg = template.render({
        'first_name': first_name,
        'link': link,
        'to': to
    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Invitation",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def thank_you_email(first_name, to, logo, logo2):
    # template = get_template('utils/emailers/thankyou.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'to': to

    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/thankyou.html')
    email_msg = template.render({
        'first_name': first_name,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Thank You",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def platform_thank_you_email(to):
    template = get_template('utils/emailers/platform_thankyou.html')
    email_msg = template.render({
        'to': to

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Thank You",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def Player_platform_invite_email(to, msg, link, logo, logo2):
    # template = get_template('utils/emailers/player_platform_invite.html')
    # email_msg = template.render({
    #     'to': to,
    #     'msg': msg,
    #     'link': link

    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/player_platform_invite.html')
    email_msg = template.render({
        'to': to,
        'msg': msg,
        'link': link,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Invitation",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def field_approval_email(to):
    template = get_template('utils/emailers/field_approval_mail.html')
    email_msg = template.render({
        'to': to
    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Field Approval",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def schedule_reminder_email(to, schedule_end_date):
    template = get_template('utils/emailers/schedule_reminder_email.html')
    email_msg = template.render({
        'schedule_end_date': schedule_end_date,
        'to': to

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Schedule Reminder",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def player_notify_contact_email(to, name, from_name, availability, logo, logo2):

    # [OrderedDict([('id', 7), ('date', '2021-08-21'), ('start_time', '12:23:00'), ('day', 'Saturday'), ('end_time', '12:25:00'), ('sport', 'Football'), ('player_notify_contact', 5)]), OrderedDict([('id', 8), ('date', '2021-08-22'), ('start_time', '12:23:00'), ('day', 'Sunday'), ('end_time', '12:25:00'), ('sport', 'Football'), ('player_notify_contact', 5)]), OrderedDict([('id', 9), ('date', '2021-08-29'), ('start_time', '12:23:00'), ('day', 'Sunday'), ('end_time', '12:25:00'), ('sport', 'Football'), ('player_notify_contact', 5)]), OrderedDict([('id', 10), ('date', '2021-09-05'), ('start_time', '12:23:00'), ('day', 'Sunday'), ('end_time', '12:25:00'), ('sport', 'Football'), ('player_notify_contact', 5)]), OrderedDict([('id', 11), ('date', '2021-09-12'), ('start_time', '12:23:00'), ('day', 'Sunday'), ('end_time', '12:25:00'), ('sport', 'Football'), ('player_notify_contact', 5)]), OrderedDict([('id', 12), ('date', '2021-09-19'), ('start_time', '12:23:00'), ('day', 'Sunday'), ('end_time', '12:25:00'), ('sport', 'Football'), ('player_notify_contact', 5)])]

    # template = get_template('utils/emailers/availability_notify.html')
    # email_msg = template.render({
    #     'name': name,
    #     'availability': availability,
    #     'from_name': from_name
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/availability_notify.html')
    email_msg = template.render({
        'name': name,
        'availability': availability,
        'from_name': from_name,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Schedule Reminder",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass

    # subject = "No-Reply: Email Verification for AFL"
    # template = get_template('emailers/email_verification.html')
    # email_msg = template.render({
    # 	'first_name': first_name,
    # 	'link': link
    # })
    # try:
    # 	msg = EmailMultiAlternatives(subject, email_msg, "no-reply@beatsfitness.in", [to])

    # 	msg.attach_alternative(email_msg, "text/html")

    # 	r = msg.send() #in bracket try 'fail_silently=False' https://docs.djangoproject.com/en/2.0/topics/email/
    # 	print(r)
    # except:
    # 	pass


def send_sms(mobile, user_otp):
    message = "{} is your OTP for mobile verification".format(user_otp.otp)
    SmsCentral.objects.create(
        mobile=mobile, message=message, user_otp=user_otp)


# def send_mail_registeration(first_name, link, to):
# 	client = boto3.client('ses',region_name=AWS_SES_REGION_NAME, aws_access_key_id=AWS_ACCESS_KEY_ID,aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
# 	template = get_template('utils/emailers/email_verification.html')
# 	email_msg = template.render({
# 		'first_name': first_name,
# 		'link': link
# 	})

# 	try:
# 		response = client.send_email(
# 			Destination={
# 				'ToAddresses': [to]
# 			},
# 			Message={
# 				'Body': {
# 					'Html': {
# 						'Charset': CHARSET,
# 						'Data': email_msg,
# 					},
# 				},
# 				'Subject': {
# 					'Charset': CHARSET,
# 					'Data': "No-Reply: Email Verification for Sports",
# 				},
# 			},
# 			Source="sports@worldindia.com",
# 		)
# 	except Exception as e:
# 		print(e)
# 		print('Something Went Wrong - sending mail')


def send_mail_registeration(first_name, link, to):
    template = get_template('utils/emailers/email_verification.html')
    email_msg = template.render({
        'first_name': first_name,
        'link': link
    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "Hello",
                                           "html": email_msg})

    except Exception as e:
        print(e)


def send_mail_new_join(to, logo, logo2):
    # template = get_template('utils/emailers/new_join.html')
    # email_msg = template.render({
    #     'to': to
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/new_join.html')
    email_msg = template.render({
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "Invitation to Join Sports Booking",
                                           "html": email_msg})

    except Exception as e:
        print(e)


# def send_emal_onboard_accept(first_name, link, to):
# 	client = boto3.client('ses',region_name=AWS_SES_REGION_NAME, aws_access_key_id=AWS_ACCESS_KEY_ID,aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
# 	template = get_template('utils/emailers/onboard_accept.html')
# 	email_msg = template.render({
# 		'first_name': first_name,
# 		'link': link
# 	})

# 	try:
# 		response = client.send_email(
# 			Destination={
# 				'ToAddresses': [to]
# 			},
# 			Message={
# 				'Body': {
# 					'Html': {
# 						'Charset': CHARSET,
# 						'Data': email_msg,
# 					},
# 				},
# 				'Subject': {
# 					'Charset': CHARSET,
# 					'Data': "No-Reply: Onboarding Registeration for Sports",
# 				},
# 			},
# 			Source="sports@worldindia.com",
# 		)
# 	except Exception as e:
# 		print(e)
# 		print('Something Went Wrong - sending mail')


def send_emal_onboard_accept(first_name, link, to, msg, logo, logo2):
    # template = get_template('utils/emailers/onboard_accept.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'link': link,
    #     'msg': msg,
    #     'to': to
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/onboard_accept.html')
    email_msg = template.render({
        'first_name': first_name,
        'link': link,
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })
    print(str(logo['template_image']))
    print(str(logo2['template_image']))

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Onboarding Registeration for Sports",
                                           "html": email_msg})
    except Exception as e:
        print(e)
        print('Something Went Wrong - sending mail')


def onboard_Complete_mail(first_name, link, to, msg, logo, logo2):
    # template = get_template('utils/emailers/onboard_complete_mail.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'link': link,
    #     'msg': msg,
    #     'to': to
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/onboard_complete_mail.html')
    email_msg = template.render({
        'first_name': first_name,
        'link': link,
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Onboarding Registeration Completion for Sports",
                                           "html": email_msg})
    except Exception as e:
        print(e)
        print('Something Went Wrong - sending mail')


def venue_owner_booking_cancel_Complete_mail(first_name, to, msg, logo, logo2):
    # template = get_template('utils/emailers/venue_owner_booking_cancel.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'msg': msg,
    #     'to': to

    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/venue_owner_booking_cancel.html')
    email_msg = template.render({
        'first_name': first_name,
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: venue owner booking cancellation",
                                           "html": email_msg})
    except Exception as e:
        print(e)
        print('Something Went Wrong - sending mail')


def onboard_delete_or_declined_mail(first_name, to, msg, logo, logo2):
    # template = get_template(
    #     'utils/emailers/onboard_delete_or_declined_mail.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'msg': msg,
    #     'to': to
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template(
        'utils/emailers/onboard_delete_or_declined_mail.html')
    email_msg = template.render({
        'first_name': first_name,
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Onboarding Registeration Declined for Sports",
                                           "html": email_msg})
    except Exception as e:
        print(e)
        print('Something Went Wrong - sending mail')


def booking_cancel_request_approve_mail(first_name, to, msg, logo, logo2):
    # template = get_template('utils/emailers/booking_cancel_approve.html')
    # email_msg = template.render({
    #     'first_name': first_name,
    #     'msg': msg,
    #     'to': to
    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/booking_cancel_approve.html')
    email_msg = template.render({
        'first_name': first_name,
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']
    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Booking Cancellation for Field",
                                           "html": email_msg})
    except Exception as e:
        print(e)
        print('Something Went Wrong - sending mail')


def send_email_campaign_task(contact_list, email_layout):
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/campaign.html')
    email_msg = template.render({
        'background': "https://s3.ap-south-1.amazonaws.com/sports-dev/" + str(email_layout['email_background']),
        'logo': "https://s3.ap-south-1.amazonaws.com/sports-dev/" + email_layout['email_logo'],
        'message': email_layout['emailBody']
    })
    print(str(email_layout['email_logo']))

    try:
        response = client.send_email(
            Destination={
                'ToAddresses': contact_list
            },
            Message={
                'Body': {
                    'Html': {
                        'Charset': CHARSET,
                        'Data': email_msg,
                    },
                },
                'Subject': {
                    'Charset': CHARSET,
                    'Data': "No-Reply: Onboarding Registeration for Sports",
                },
            },
            Source="sports@worldindia.com",
        )
    except Exception as e:
        print(e)
        print('Something Went Wrong - sending mail')


def invitation_send(first_name, to, msg, logo, logo2):
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/invitation_send.html')
    email_msg = template.render({
        'first_name': first_name,
        'to': to,
        'msg': msg,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })
    print(str(logo['template_image']))
    print(str(logo2['template_image']))

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Invitation",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass


def invitation_send_to_friend(to, msg, logo, logo2):
    # template = get_template('utils/emailers/invitation_to_send.html')
    # email_msg = template.render({
    #     'msg': msg,
    #     'to': to

    # })
    client = boto3.client('ses', region_name=AWS_SES_REGION_NAME,
                          aws_access_key_id=AWS_ACCESS_KEY_ID, aws_secret_access_key=AWS_SECRET_ACCESS_KEY)
    template = get_template('utils/emailers/invitation_to_send.html')
    email_msg = template.render({
        'msg': msg,
        'to': to,
        'logo':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo['template_image'],
        'logo2':  "https://s3.ap-south-1.amazonaws.com/sports-dev/" + logo2['template_image']

    })

    try:
        url_response = requests.post(MAILGUN_URL,
                                     auth=("api", MAILGUN_KEY),
                                     data={"from": MAILGUN_FROM,
                                           "to": [to],
                                           "subject": "No-Reply: Invitation",
                                           "html": email_msg})
    except Exception as e:
        print("except")
        print(e)
        pass
# def reset_password(request, token):
# 	token = UserEmailToken.objects.filter(key=token, purpose='RESET PASSWORD').last()
# 	if not token:
# 		return HttpResponse("Token Incorrect !", content_type="text/plain")


# 	# internal_user = InternalUser.objects.filter(pk = token.internal_user.pk, is_deleted = False)
# 	# if not internal_user.exists():
# 	if not token.internal_user:
# 		return HttpResponse('Internal User is deleted.. Invalid user', content_type="text/plain")

# 	# https://afl_front.codezen.in/reset-password/token
# 	return redirect('{}/{}/{}'.format(FRONTEND_DOMAIN_NAME, 'reset-password', token.key))


# def email_change_verification(first_name, link, to):
# 	#########################     Email Change     #################################

# 	subject = "No-Reply: Email Verification for AFL"
# 	template = get_template('emailers/email_change_verification.html')
# 	email_msg = template.render({
# 		'first_name': first_name,
# 		'link': link
# 	})

# 	try:
# 		msg = EmailMultiAlternatives(subject, email_msg, "no-reply@beatsfitness.in", [to])
# 		msg.attach_alternative(email_msg, "text/html")

# 		r = msg.send() #in bracket try 'fail_silently=False' https://docs.djangoproject.com/en/2.0/topics/email/
# 		print(r)
# 	except:
# 		pass

# def send_new_user_email_and_password(first_name, email, password):
# 	#########################     Send Email and Password to New Staff     #################################

# 	subject = "No-Reply: Your Email ID and Password for AFL"
# 	template = get_template('emailers/new_trainer_or_dietician.html')
# 	email_msg = template.render({
# 		'first_name': first_name,
# 		'email' : email,
# 		'password' : password,
# 	})

# 	try:
# 		msg = EmailMultiAlternatives(subject, email_msg, "no-reply@beatsfitness.in", [email])
# 		msg.attach_alternative(email_msg, "text/html")

# 		r = msg.send() #in bracket try 'fail_silently=False' https://docs.djangoproject.com/en/2.0/topics/email/
# 		print(r)
# 	except:
# 		pass


# def email_change_verify_token(request, token):
# 	############################   Verifying Email Verification Token    #############################
# 	token,email=token.split("_")
# 	print(token,email)

# 	if not UserToken.objects.filter(key = token).exists():

# 		return HttpResponse("Token Incorrect !", content_type="text/plain")
# 	else:
# 		token = UserToken.objects.get(key = token)

# 	platform_user = PlatformUser.objects.filter(user = token.user, is_deleted = False)
# 	if not platform_user.exists():
# 		return HttpResponse('User is deleted.. Invalid user', content_type="text/plain")
# 	platform_user = platform_user.last()
# 	platform_user.email      = platform_user.new_email
# 	platform_user.user.email = platform_user.new_email
# 	platform_user.user.save()
# 	platform_user.new_email  = None
# 	platform_user.save()

# 	token.delete()

# 	context = {'username': platform_user.first_name,}
# 	template = get_template('welcome_email.html')
# 	html = template.render(context)

# 	return HttpResponse(html)


# def email_verify_token(request, token):
# 	if not UserToken.objects.filter(key = token).exists():
# 		return HttpResponse("Token Incorrect!", content_type="text/plain")
# 	else:
# 		token = UserToken.objects.get(key = token)

# 	platform_user = PlatformUser.objects.filter(user__username = token.user.mobile, is_deleted = False)

# 	if not platform_user.exists():
# 		return HttpResponse('User is deleted.. Invalid user', content_type="text/plain")

# 	platform_user = platform_user.last()
# 	platform_user.is_email_verified = 'Yes'
# 	platform_user.save()

# 	token.delete()

# 	context = {'username': platform_user.user.first_name,}
# 	template = get_template('welcome_email.html')
# 	html = template.render(context)
# 	# return HttpResponse("successfully changed email", content_type="text/plain")
# 	# return render(request, 'welcome_email.html', context=context)
# 	return HttpResponse(html)

# def email_verify_token(request, token):
#     # response = {}
#     platform_user_otp = PlatformUserOtp.objects.filter(code = token, for_mail = True).last()
#     if not platform_user_otp:
#         return HttpResponse("Token Incorrect !", content_type="text/plain")
#     else:
#         token = PlatformUserOtp.objects.get(code = token, for_mail = True)

#     platform_user = PlatformUser.objects.filter(user = platform_user_otp.platform_user.user, is_deleted = False)
#     if not platform_user.exists():
#         return HttpResponse('User is deleted. Invalid user', content_type="text/plain")

#     platform_user = platform_user.first()
#     platform_user.is_email_verified = 'Yes'
#     platform_user.save()
#     platform_user_otp.delete()

#     context = {'username': platform_user.user.first_name,}
#     template = get_template('welcome_email.html')
#     html = template.render(context)
#     return HttpResponse(html)
