from xhtml2pdf import pisa 
import jinja2
import io
from django.core.files import File as DjangoFile


def createInvoice(json_obj):
    """
    Creates and Returnns Invoice
    """
    print(json_obj)
    templateLoader = jinja2.FileSystemLoader(searchpath="./utils/pdf_template/")
    templateEnv = jinja2.Environment(loader=templateLoader)
    TEMPLATE_FILE = "index.html"
    template = templateEnv.get_template(TEMPLATE_FILE)
    sourceHtml = template.render(json_data=json_obj) 

    pdf_buffer = io.BytesIO()
    pisa.CreatePDF(sourceHtml,pdf_buffer,encoding='UTF-8')
    pdf_buffer.seek(0)
    pdf_buffer.seek(0)
    file_obj1 = DjangoFile(pdf_buffer, name="invoice_"+str(json_obj['id'])+".pdf")
    return file_obj1

# Utility function
def convertHtmlToPdf(sourceHtml, outputFilename):
    # open output file for writing (truncated binary)
    resultFile = open(outputFilename, "w+b")

    # convert HTML to PDF
    pisaStatus = pisa.CreatePDF(
            src=sourceHtml,            # the HTML to convert
            dest=resultFile)           # file handle to receive result

    # close output file
    resultFile.close()

    # return True on success and False on errors
    print(pisaStatus.err, type(pisaStatus.err))
    return pisaStatus.err

if __name__ == "__main__":
    pisa.showLogging()
    convertHtmlToPdf(sourceHtml, outputFilename)