from django.contrib import admin
from nested_admin import NestedModelAdmin
from .models import *
# Register your models here.


@admin.register(VenueOwner)
class VenueOwnerAdmin(NestedModelAdmin):
    model = VenueOwner
    search_fields = ['first_name']
    list_display = ['id', 'first_name', 'last_name', 'email', 'mobile', 'user']


@admin.register(PriceListStep1)
class PriceListStep1Admin(NestedModelAdmin):
    model = PriceListStep1
    search_fields = ['list_name']
    list_display = ['id', 'list_name', 'interval',
                    'gap_period', 'start_hour', 'end_hour']


@admin.register(PriceListStep2)
class PriceListStep2Admin(NestedModelAdmin):
    model = PriceListStep2
    search_fields = ['priceList1ID']
    list_display = ['id', 'price_list1',
                    'start_hour', 'end_hour', 'day', 'price']


@admin.register(ScheduleTemplateStep1)
class ScheduleTemplateStep1Admin(NestedModelAdmin):
    model = ScheduleTemplateStep1
    search_fields = ['template_name']
    list_display = ['id', 'template_name', 'start_hour',
                    'end_hour', 'created_by', 'created_at', 'is_deleted']


@admin.register(ScheduleTemplateSlot)
class ScheduleTemplateSlotAdmin(NestedModelAdmin):
    model = ScheduleTemplateSlot
    list_display = ['id', 'template', 'start_hour', 'end_hour', 'is_available']


@admin.register(Schedule)
class ScheduleAdmin(NestedModelAdmin):
    model = Schedule
    list_display = ['id', 'schedule_name', 'field', 'template',
                    'pricelist', 'start_date', 'end_date', 'created_by', 'is_deleted']


@admin.register(Schedule_Slot)
class ScheduleSlotAdmin(NestedModelAdmin):
    model = Schedule_Slot
    list_display = ['id', 'schedule_id', 'start_hour',
                    'end_hour', 'date', 'day', 'is_available', 'cost']


@admin.register(Packages)
class PackagesAdmin(NestedModelAdmin):
    model = Packages
    list_display = ['id', 'name', 'package_description', 'package_quantity', 'sport_relivance', 'package_type', 'package_duration',
                    'status', 'price', 'created_by', 'is_deleted', 'created_at', 'updated_at']


@admin.register(Schedule_Email_Cron)
class Schedule_Email_CronAdmin(NestedModelAdmin):
    model = Schedule_Email_Cron
    list_display = ['id', 'schedule_id', 'schedule_end_date',
                    'run_date', 'status', 'message', 'is_deleted', 'created_at', 'updated_at']


@admin.register(Time_Slot_Price)
class Time_Slot_PriceAdmin(NestedModelAdmin):
    model = Time_Slot_Price
    list_display = ['id', 'schedule_id', 'start_hour', 'end_hour', 'cost']


@admin.register(BookingCancellationRequest)
class BookingCancellationRequestAdmin(NestedModelAdmin):
    model = BookingCancellationRequest
    list_display = ['id', 'cancellation_reason', 'venue_field',
                    'start_time', 'end_time', 'start_date', 'end_date', 'status']


@admin.register(Schedule_Parameter)
class Schedule_ParameterAdmin(NestedModelAdmin):
    model = Schedule_Parameter
    list_display = ['id', 'schedule_edit',
                    'schedule_delete', 'schedule_create']


@admin.register(RequestBookingCancellation)
class RequestBookingCancellationAdmin(NestedModelAdmin):
    model = RequestBookingCancellation
    list_display = ['id', 'cancellation_reason',
                    'start_time', 'end_time', 'start_date', 'end_date', 'status', 'created_by']


@admin.register(PackageTypes)
class PackageTypesAdmin(NestedModelAdmin):
    model = PackageTypes
    list_display = ['id', 'description',
                    'created_at']


@admin.register(PackageDurations)
class PackageDurationsAdmin(NestedModelAdmin):
    model = PackageDurations
    list_display = ['id', 'description',
                    'created_at']
