from django.core.management.base import BaseCommand
from django.utils import timezone, tree
from venue_owners.models import *
from utils.mail import schedule_reminder_email


class Command(BaseCommand):
    help = 'Schdule End Notification'

    def handle(self, *args, **kwargs):
        print("hello")
        time = timezone.now()
        schedule_task = Schedule_Email_Cron.objects.filter(
            is_deleted=False, status="HOLD", run_date=time)

        if schedule_task.count() < 1:
            self.stdout.write(self.style.NOTICE('No Record Found'))
            return 0

        try:
            for j in schedule_task:
                j.status = "RUNNING"
                j.save()

                schedule_id_obj = j.schedule_id
                # print(schedule_id_obj)

                schedule_user_obj = schedule_id_obj.created_by.email
                # print(schedule_user_obj)
                schedule_end_date = j.schedule_end_date

                schedule_reminder_email(schedule_user_obj, schedule_end_date)

                j.status = "SUCCESS"
                # + ','.join(map(str, all_doc_type))
                j.message = "Successfully Completed. "
                j.save()
                self.stdout.write(self.style.SUCCESS('Successfully Completed'))

        except Exception as e:
            j.status = "FAILED"
            j.message = str(e)
            j.save()
