# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('venues', '0001_initial'),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='PackageDurations',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Package Durations',
                'db_table': 'package_durations',
            },
        ),
        migrations.CreateModel(
            name='PackageTypes',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Package Types',
                'db_table': 'package_types',
            },
        ),
        migrations.CreateModel(
            name='PriceListStep1',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('list_name', models.CharField(help_text='Price List Name', max_length=100, null=True)),
                ('interval', models.IntegerField(help_text='Interval in Minutes', null=True)),
                ('gap_period', models.IntegerField(help_text='Gap Period in Minutes', null=True)),
                ('start_hour', models.TimeField(blank=True, null=True)),
                ('end_hour', models.TimeField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate PriceList')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('fields', models.ManyToManyField(blank=True, to='venues.VenueField')),
            ],
            options={
                'verbose_name_plural': 'Price List 1',
                'db_table': 'price_list1',
            },
        ),
        migrations.CreateModel(
            name='Schedule',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('schedule_name', models.CharField(blank=True, help_text='Schedule Name', max_length=100, null=True)),
                ('start_date', models.DateField(blank=True, help_text='Start Date', null=True)),
                ('end_date', models.DateField(blank=True, help_text='End Date', null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Schedule')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('field', models.ForeignKey(blank=True, help_text='Venue Field', null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueField')),
                ('pricelist', models.ForeignKey(blank=True, help_text='Price List Model', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.PriceListStep1')),
            ],
            options={
                'verbose_name_plural': 'Schedule',
                'db_table': 'schedule',
            },
        ),
        migrations.CreateModel(
            name='Schedule_Parameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('schedule_edit', models.IntegerField(blank=True, null=True)),
                ('schedule_delete', models.IntegerField(blank=True, null=True)),
                ('schedule_create', models.IntegerField(blank=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Schedule Parameter',
                'db_table': 'schedule_parameter',
            },
        ),
        migrations.CreateModel(
            name='Testing_data',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
            ],
            options={
                'verbose_name_plural': 'Testing Data',
                'db_table': 'testing_data',
            },
        ),
        migrations.CreateModel(
            name='Time_Slot_Price',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_hour', models.TimeField(blank=True, help_text='Starting Time', null=True)),
                ('end_hour', models.TimeField(blank=True, help_text='End Time', null=True)),
                ('cost', models.FloatField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Schedule Slot')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('schedule_id', models.ForeignKey(blank=True, help_text='Schedule ID', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.Schedule')),
            ],
            options={
                'verbose_name_plural': 'Time Slots Price',
                'db_table': 'time_slot_price',
            },
        ),
        migrations.CreateModel(
            name='ScheduleTemplateStep1',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('template_name', models.CharField(blank=True, max_length=100, null=True)),
                ('start_hour', models.TimeField(blank=True, help_text='Template Start Hour', null=True)),
                ('end_hour', models.TimeField(blank=True, help_text='Template End Hour', null=True)),
                ('interval', models.IntegerField(help_text='Interval in Minutes', null=True)),
                ('gap_period', models.IntegerField(help_text='Gap Period in Minutes', null=True)),
                ('plan_range', models.CharField(blank=True, choices=[('D', 'Daily'), ('W', 'Weekly'), ('M', 'Monthly')], max_length=1, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate PriceList')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Schedule Template 1',
                'db_table': 'schedule_template1',
            },
        ),
        migrations.CreateModel(
            name='ScheduleTemplateSlot',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_hour', models.TimeField(blank=True, help_text='Template Start Hour', null=True)),
                ('end_hour', models.TimeField(blank=True, help_text='Template End Hour', null=True)),
                ('is_available', models.BooleanField(blank=True, default=True, null=True)),
                ('day', models.IntegerField(blank=True, null=True)),
                ('template', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='venue_owners.ScheduleTemplateStep1')),
            ],
            options={
                'verbose_name_plural': 'Schedule Template Slots',
                'db_table': 'template_slots',
            },
        ),
        migrations.CreateModel(
            name='Schedule_Slot',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_hour', models.TimeField(blank=True, help_text='Starting Time', null=True)),
                ('end_hour', models.TimeField(blank=True, help_text='End Time', null=True)),
                ('date', models.DateField(blank=True, help_text='Date', null=True)),
                ('is_available', models.BooleanField(blank=True, default=True, null=True)),
                ('cost', models.FloatField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Schedule Slot')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('day', models.ForeignKey(blank=True, help_text='Day of week', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.DayofWeek')),
                ('schedule_id', models.ForeignKey(blank=True, help_text='Schedule ID', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.Schedule')),
            ],
            options={
                'verbose_name_plural': 'Schedule Slots',
                'db_table': 'schedule_slot',
            },
        ),
        migrations.CreateModel(
            name='Schedule_Email_Cron',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('schedule_end_date', models.DateField(blank=True, help_text='end date', null=True)),
                ('run_date', models.DateField(blank=True, help_text='run date', null=True)),
                ('status', models.CharField(choices=[('HOLD', 'HOLD'), ('RUNNING', 'RUNNING'), ('SUCCESS', 'SUCCESS'), ('FAILED', 'FAILED')], default='HOLD', help_text='Status', max_length=100)),
                ('message', models.CharField(blank=True, help_text='message', max_length=200, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate Schedule Slot')),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('schedule_id', models.ForeignKey(blank=True, help_text='Schedule ID', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.Schedule')),
            ],
            options={
                'verbose_name_plural': 'Schedule Email Crons',
                'db_table': 'schedule_email_crons',
            },
        ),
        migrations.AddField(
            model_name='schedule',
            name='template',
            field=models.ForeignKey(blank=True, help_text='Schedule Template Model', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.ScheduleTemplateStep1'),
        ),
        migrations.CreateModel(
            name='RequestBookingCancellation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('start_date', models.DateField(blank=True, help_text='Start Date', null=True)),
                ('end_date', models.DateField(blank=True, help_text='End Date', null=True)),
                ('status', models.CharField(blank=True, choices=[('A', 'Approve'), ('R', 'Rejected'), ('N', 'New')], default='N', help_text='Is Verified', max_length=10, null=True)),
                ('comments', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('cancellation_reason', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.BookingCancellation')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue_field', models.ManyToManyField(blank=True, to='venues.VenueField')),
            ],
            options={
                'verbose_name_plural': 'Request Booking Cancellation',
                'db_table': 'request_booking_cancellation',
            },
        ),
        migrations.CreateModel(
            name='PriceListStep2',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_hour', models.TimeField(blank=True, null=True)),
                ('end_hour', models.TimeField(blank=True, null=True)),
                ('price', models.IntegerField(blank=True, default=0, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate PriceList')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('day', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='static_data.DayofWeek')),
                ('price_list1', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='venue_owners.PriceListStep1')),
            ],
            options={
                'verbose_name_plural': 'Price List 2',
                'db_table': 'price_list2',
            },
        ),
        migrations.CreateModel(
            name='Packages',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('package_image', models.ImageField(blank=True, null=True, upload_to='Package')),
                ('name', models.CharField(blank=True, help_text='Package Name', max_length=100, null=True)),
                ('package_description', models.CharField(blank=True, help_text='Package Description', max_length=600, null=True)),
                ('status', models.CharField(blank=True, choices=[('A', 'Accepted'), ('R', 'Rejected'), ('O', 'On Hold')], default='O', help_text='Is Verified', max_length=10, null=True)),
                ('number_sessions', models.IntegerField(blank=True, help_text='Number of sessions', null=True)),
                ('session_duration', models.IntegerField(blank=True, help_text='Session duration in Minutes', null=True)),
                ('price', models.CharField(blank=True, max_length=100, null=True)),
                ('package_quantity', models.IntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('level', models.ManyToManyField(blank=True, to='static_data.TeamLevel')),
                ('package_duration', models.ForeignKey(blank=True, help_text='Duration Id', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.PackageDurations')),
                ('package_type', models.ForeignKey(blank=True, help_text='Package type Id', null=True, on_delete=django.db.models.deletion.CASCADE, to='venue_owners.PackageTypes')),
                ('sport_relivance', models.ForeignKey(blank=True, help_text='Sports ID', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
            ],
            options={
                'verbose_name_plural': 'Packages',
                'db_table': 'packages',
            },
        ),
        migrations.CreateModel(
            name='BookingCancellationRequest',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('start_date', models.DateField(blank=True, help_text='Start Date', null=True)),
                ('end_date', models.DateField(blank=True, help_text='End Date', null=True)),
                ('status', models.CharField(blank=True, choices=[('A', 'Approve'), ('R', 'Rejected'), ('N', 'New')], default='N', help_text='Is Verified', max_length=10, null=True)),
                ('comments', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('cancellation_reason', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.BookingCancellation')),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
                ('venue_field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueField')),
            ],
            options={
                'verbose_name_plural': 'Booking Cancellation Request',
                'db_table': 'Booking_Cancellation_Request',
            },
        ),
        migrations.CreateModel(
            name='VenueOwner',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(help_text='user first name', max_length=100, null=True)),
                ('middle_name', models.CharField(blank=True, help_text='user middle name', max_length=100, null=True)),
                ('last_name', models.CharField(blank=True, help_text='user last name', max_length=100, null=True)),
                ('email', models.CharField(help_text='user email', max_length=100, null=True)),
                ('new_email', models.CharField(blank=True, help_text='user new email', max_length=100, null=True)),
                ('mobile', models.CharField(blank=True, help_text='user mobile number', max_length=15, null=True)),
                ('profession', models.CharField(blank=True, help_text='profession', max_length=50, null=True)),
                ('street', models.CharField(blank=True, help_text='street', max_length=50, null=True)),
                ('venue_number', models.CharField(blank=True, help_text='venue_number', max_length=50, null=True)),
                ('pincode', models.CharField(blank=True, help_text='pincode', max_length=50, null=True)),
                ('new_mobile', models.CharField(blank=True, help_text='user new mobile number', max_length=15, null=True)),
                ('gender', models.CharField(choices=[('M', 'Male'), ('F', 'Female'), ('O', 'Other')], help_text='M - Male, F - Female, O - Other', max_length=1, null=True)),
                ('telephone', models.CharField(blank=True, max_length=15, null=True)),
                ('telephone2', models.CharField(blank=True, max_length=15, null=True)),
                ('user_code', models.CharField(blank=True, max_length=6, null=True)),
                ('is_deleted', models.BooleanField(default=False, help_text='activate/deactivate user')),
                ('is_email_verified', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('payment_method', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.PaymentMethod')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.State')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('vat', models.ForeignKey(blank=True, help_text='vat id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Vat')),
                ('vat_exemption_order', models.ForeignKey(blank=True, help_text='vat exemption order id', null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.VatExemptionOrder')),
            ],
            options={
                'verbose_name_plural': 'Venue Owners',
                'db_table': 'venue_owner',
                'unique_together': {('user', 'email')},
            },
        ),
    ]
