import pytz
import json
from django.http import HttpResponse
from django.template import Template, Context
from django.template.loader import get_template
from django.db import transaction
from django.urls import reverse
from django.db.models import Q
from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics
from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from django.utils import timezone
from rest_framework.permissions import IsAuthenticated
from utils.mixins import *
from utils.api_handle_errors import handle_errors
from venue_owners.serializers import *


class PriceListLISTGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = PricelistLISTSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
 #           request.data._mutable = True
 #            for i in list(request.data):
 #                if i=="start_hour":
 #                    request.data[i] = request.data[i]
 #                    del request.data[i]
 #                elif i =="end_hour":
 #                    request.data[i] = request.data[i]
 #                    del request.data[i]

            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():
                # Get page number
                start_count = (serializer.validated_data['page'] - 1) * 10
                end_count = start_count + 10
                serializer.validated_data.pop('page')

                serializer.validated_data['created_by'] = request.user.id

                if "keyword" in serializer.validated_data:
                    serializer.validated_data['list_name__icontains'] = serializer.validated_data['keyword']
                    serializer.validated_data.pop("keyword")

                # In use
                in_use_filter = ""
                if "filter_in_use" in serializer.validated_data:
                    in_use_filter = serializer.validated_data['filter_in_use']
                    serializer.validated_data.pop('filter_in_use')
                print(in_use_filter)


#                serializer.validated_data['created_by'] = request.user.id
                if "assortment" in request.data:
                    assortment = serializer.validated_data['assortment']
                    serializer.validated_data.pop('assortment')
 #                   data = PriceListStep1.objects.filter(**serializer.validated_data).order_by(assortment)[start_count:end_count]

                    if "start_hour" in serializer.validated_data:
                        serializer.validated_data['start_hour__gte'] = serializer.validated_data['start_hour']
                        serializer.validated_data.pop("start_hour")

                    if "end_hour" in serializer.validated_data:
                        serializer.validated_data['end_hour__lte'] = serializer.validated_data['end_hour']
                        serializer.validated_data.pop("end_hour")

                    data = PriceListStep1.objects.filter(**serializer.validated_data).order_by(
                        "created_at").order_by(assortment)[start_count:end_count]
                    total_count = PriceListStep1.objects.filter(
                        **serializer.validated_data).order_by(assortment).count()
                else:
                    if "start_hour" in serializer.validated_data:
                        serializer.validated_data['start_hour__gte'] = serializer.validated_data['start_hour']
                        serializer.validated_data.pop("start_hour")

                    if "end_hour" in serializer.validated_data:
                        serializer.validated_data['end_hour__lte'] = serializer.validated_data['end_hour']
                        serializer.validated_data.pop("end_hour")

                    data = PriceListStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at")[start_count:end_count]
                    total_count = PriceListStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at").count()

                list_of_ids_to_include = []
                if in_use_filter != "":
                    for i in range(0, total_count):
                        if in_use_filter == "yes":
                            if Schedule.objects.filter(pricelist__id=data[i].id).exists():
                                list_of_ids_to_include.append(data[i].id)
                        else:
                            if not Schedule.objects.filter(pricelist__id=data[i].id).exists():
                                list_of_ids_to_include.append(data[i].id)

                    if len(list_of_ids_to_include) > 0:
                        new_data = PriceListStep1.objects.filter(
                            id__in=list_of_ids_to_include)
                        serializer = self.serializer_class(new_data, many=True)
                        response["result"] = 1
                        response['data'] = serializer.data
                        response['total_count'] = new_data.count()
                        self.add_api_call(request, response)
                        return Response(response, status=status.HTTP_200_OK)
                    else:
                        response["result"] = 1
                        response['data'] = []
                        response['total_count'] = 0
                        self.add_api_call(request, response)
                        return Response(response, status=status.HTTP_200_OK)
                else:
                    serializer = self.serializer_class(data, many=True)
                    response["result"] = 1
                    response['data'] = serializer.data
                    response['total_count'] = total_count
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)

        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class PriceListLISTDELETEAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = PricelistDELETESerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializers = self.serializer_class(data=request.data)
            if serializers.is_valid():

                # Check if schedule template is assigned
                if Schedule.objects.filter(pricelist=serializers.validated_data["id"], is_deleted=False).exists():
                    response["result"] = 0
                    responsedata.append("Price list is in use is in use")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                serializers = self.serializer_class(instance=PriceListStep1.objects.get(
                    id=serializers.validated_data['id'], is_deleted=False), data={"is_deleted": True, 'id': serializers.validated_data['id']})
                if serializers.is_valid():
                    serializers.save()
                    response["result"] = 1
                    responsedata.append("Success")
                    response['data'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)
                else:
                    response = handle_errors(serializers.errors)
                    response['result'] = 0
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_400_BAD_REQUEST)
            else:
                response = handle_errors(serializers.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


##  Schedule Template ##

class TemplateListLISTGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = ScheduleTemplateLISTSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():
                # Get page number
                start_count = (serializer.validated_data['page'] - 1) * 10
                end_count = start_count + 10
                serializer.validated_data.pop('page')

                in_use_filter = ""
                if "filter_in_use" in serializer.validated_data:
                    in_use_filter = serializer.validated_data['filter_in_use']
                    serializer.validated_data.pop('filter_in_use')

                serializer.validated_data['created_by'] = request.user.id

                # Keyword
                keyword = ""
                if "keyword" in serializer.validated_data:
                    serializer.validated_data['template_name__icontains'] = serializer.validated_data['keyword']
                    keyword = serializer.validated_data['keyword']
                    serializer.validated_data.pop("keyword")

                if "date_range" in serializer.validated_data:
                    serializer.validated_data['plan_range'] = serializer.validated_data['date_range']
                    serializer.validated_data.pop("date_range")

                # assortment=""
                # if "assortment" in serializer.validated_data:
                #     assortment = serializer.validated_data['assortment']
                #     serializer.validated_data.pop('assortment')

                list_of_ids_to_include = []
                if in_use_filter != "":
                    if in_use_filter == "yes":
                        schedules_of_that_user = Schedule.objects.filter(
                            created_by=request.user.id, is_deleted=False)
                        upper_list_count = Schedule.objects.filter(
                            created_by=request.user.id, is_deleted=False).count()
                        for x in range(0, upper_list_count):
                            list_of_ids_to_include.append(
                                schedules_of_that_user[x].template.id)

                        if len(list_of_ids_to_include) > 0:
                            serializer.validated_data['id__in'] = list_of_ids_to_include
                            data_without_inuse = ScheduleTemplateStep1.objects.filter(
                                **serializer.validated_data).order_by("created_at")
                            data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                                **serializer.validated_data).order_by("created_at").count()
                            serializer = self.serializer_class(
                                data_without_inuse, many=True)
                            response["result"] = 1
                            response['data'] = serializer.data
                            response['total_count'] = data_without_inuse_count
                            self.add_api_call(request, response)
                            return Response(response, status=status.HTTP_200_OK)

                        else:
                            response["result"] = 1
                            response['data'] = []
                            response['total_count'] = 0
                            self.add_api_call(request, response)
                            return Response(response, status=status.HTTP_200_OK)

                    else:
                        schedules_of_that_user = Schedule.objects.filter(
                            created_by=request.user.id, is_deleted=False)
                        upper_list_count = Schedule.objects.filter(
                            created_by=request.user.id, is_deleted=False).count()
                        for x in range(0, upper_list_count):
                            list_of_ids_to_include.append(
                                schedules_of_that_user[x].template.id)

                        if len(list_of_ids_to_include) > 0:
                            data_without_inuse = ScheduleTemplateStep1.objects.filter(
                                ~Q(id__in=list_of_ids_to_include), **serializer.validated_data).order_by("created_at")
                            data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                                ~Q(id__in=list_of_ids_to_include), **serializer.validated_data).order_by("created_at").count()
                            serializer = self.serializer_class(
                                data_without_inuse, many=True)
                            response["result"] = 1
                            response['data'] = serializer.data
                            response['total_count'] = data_without_inuse_count
                            self.add_api_call(request, response)
                            return Response(response, status=status.HTTP_200_OK)
                        else:
                            data_without_inuse = ScheduleTemplateStep1.objects.filter(
                                **serializer.validated_data).order_by("created_at")
                            data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                                **serializer.validated_data).order_by("created_at").count()
                            serializer = self.serializer_class(
                                data_without_inuse, many=True)
                            response["result"] = 1
                            response['data'] = serializer.data
                            response['total_count'] = data_without_inuse_count
                            self.add_api_call(request, response)
                            return Response(response, status=status.HTTP_200_OK)

                else:
                    data_without_inuse = ScheduleTemplateStep1.objects.filter(
                        **serializer.validated_data).order_by("created_at")
                    data_without_inuse_count = ScheduleTemplateStep1.objects.filter(
                        **serializer.validated_data).order_by("created_at").count()
                    serializer = self.serializer_class(
                        data_without_inuse, many=True)
                    response["result"] = 1
                    response['data'] = serializer.data
                    response['total_count'] = data_without_inuse_count
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class TemplateListLISTDELETEAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = ScheduleTemplateLISTDELETESerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(instance=ScheduleTemplateStep1.objects.get(
                id=request.data['id']), data=request.data, context={"user": request.user})
            if serializer.is_valid():

                # Check if schedule template is assigned
                if Schedule.objects.filter(template=serializer.validated_data["id"], is_deleted=False).exists():
                    response["result"] = 0
                    responsedata.append("Schedule Template is in use")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                serializer.save()
                response["result"] = 1
                responsedata.append("Successfulle Deleted")
                response['errors'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


##  Schedule ##


class ScheduleListGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = ScheduleLISTSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():
                # Get page number
                start_count = (serializer.validated_data['page'] - 1) * 10
                end_count = start_count + 10
                serializer.validated_data.pop('page')

                serializer.validated_data['created_by'] = request.user.id

                if "assortment" in request.data:
                    assortment = serializer.validated_data['assortment']
                    serializer.validated_data.pop('assortment')

                    if "keyword" in serializer.validated_data:
                        serializer.validated_data['schedule_name__icontains'] = serializer.validated_data['keyword']
                        serializer.validated_data.pop("keyword")

                    # Check for in use
                    if "active" in serializer.validated_data:
                        if serializer.validated_data['active'] == 'No':
                            serializer.validated_data['start_date__gt'] = timezone.now(
                            ).date()
                        else:
                            serializer.validated_data['start_date__lte'] = timezone.now(
                            ).date()
                        serializer.validated_data.pop('active')

                    data = Schedule.objects.filter(**serializer.validated_data).order_by(
                        "-created_at").order_by(assortment)[start_count:end_count]
                    total_count = Schedule.objects.filter(
                        **serializer.validated_data).order_by(assortment).count()

                else:

                    if "keyword" in serializer.validated_data:
                        serializer.validated_data['schedule_name__icontains'] = serializer.validated_data['keyword']
                        serializer.validated_data.pop("keyword")

                     # Check for in use
                    if "active" in serializer.validated_data:
                        if serializer.validated_data['active'] == 'No':
                            serializer.validated_data['start_date__gt'] = timezone.now(
                            ).date()
                        else:
                            serializer.validated_data['start_date__lte'] = timezone.now(
                            ).date()
                        serializer.validated_data.pop('active')

                    data = Schedule.objects.filter(
                        **serializer.validated_data).order_by("-created_at")[start_count:end_count]
                    total_count = Schedule.objects.filter(
                        **serializer.validated_data).count()
                serializer = self.serializer_class(data, many=True)

                for count, i in enumerate(serializer.data):
                    if data[count].start_date > timezone.now().date():
                        i['in_use'] = False
                    else:
                        i['end_date'] = data[count].end_date
                        i['current date'] = timezone.now().date()
                        i['in_use'] = True

                response["result"] = 1
                response['data'] = serializer.data
                response['total_count'] = total_count
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class ScheduleListDELETEAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = ScheduleLISTDELETESerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(instance=Schedule.objects.get(
                id=request.data['id']), data=request.data, context={"user": request.user})
            if serializer.is_valid():
                # Check if schedule is running
                schedule_obj = Schedule.objects.get(
                    id=serializer.validated_data['id'])
                # Get current time
                current_datetime = timezone.now().date()

                if schedule_obj.start_date <= current_datetime:
                    response["result"] = 0
                    responsedata.append("Schedule is already active")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                seconds_difference = schedule_obj.created_at.date() - current_datetime
                print(type(seconds_difference))
                print(seconds_difference.total_seconds())
                param_obj = Schedule_Parameter.objects.filter().first()
                if seconds_difference.total_seconds() <= param_obj.schedule_delete*86400:
                    response["result"] = 0
                    responsedata.append(
                        "Cannot delete a schedule until "+str(param_obj.schedule_delete)+" days after its creation")
                    response['errors'] = responsedata
                    self.add_api_call(request, response)
                    return Response(response, status=status.HTTP_200_OK)

                serializer.save()
                response["result"] = 1
                responsedata.append("Successfully Deleted")
                response['data'] = responsedata
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class PriceListLISTWithoutPaginationGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = PricelistLISTWithoutPaginationSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []

            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():

                serializer.validated_data['created_by'] = request.user.id

                if "keyword" in serializer.validated_data:
                    serializer.validated_data['list_name__icontains'] = serializer.validated_data['keyword']
                    serializer.validated_data.pop("keyword")

                # In use
                serializer.validated_data.pop("in_use")

                if "assortment" in request.data:
                    assortment = serializer.validated_data['assortment']
                    serializer.validated_data.pop('assortment')
 #                   data = PriceListStep1.objects.filter(**serializer.validated_data).order_by(assortment)[start_count:end_count]

                    if "start_hour" in serializer.validated_data:
                        serializer.validated_data['start_hour__gte'] = serializer.validated_data['start_hour']
                        serializer.validated_data.pop("start_hour")

                    if "end_hour" in serializer.validated_data:
                        serializer.validated_data['end_hour__lte'] = serializer.validated_data['end_hour']
                        serializer.validated_data.pop("end_hour")

                    data = PriceListStep1.objects.filter(**serializer.validated_data).order_by(
                        "created_at").order_by(assortment)

                else:
                    data = PriceListStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at")

                serializer = self.serializer_class(data, many=True)
                response["result"] = 1
                response['data'] = serializer.data
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)

        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)


class TemplateListLISTWithoutPaginationGETAPIView(PlatformAPICallMixin, generics.GenericAPIView):
    authentication_classes = (TokenAuthentication,)
    permission_classes = (IsAuthenticated,)
    serializer_class = ScheduleTemplateLISTWithoutPaginationSerializer

    def post(self, request, format=None):
        try:
            response = {}
            responsedata = []
            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid():

                serializer.validated_data['created_by'] = request.user.id

                # Keyword
                if "keyword" in serializer.validated_data:
                    serializer.validated_data['template_name__icontains'] = serializer.validated_data['keyword']
                    serializer.validated_data.pop("keyword")

                if "assortment" in request.data:
                    assortment = serializer.validated_data['assortment']
                    serializer.validated_data.pop('assortment')
                    data = ScheduleTemplateStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at").order_by(assortment)
                else:
                    data = ScheduleTemplateStep1.objects.filter(
                        **serializer.validated_data).order_by("-created_at")

                serializer = self.serializer_class(data, many=True)
                response["result"] = 1
                response['data'] = serializer.data
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_200_OK)
            else:
                response = handle_errors(serializer.errors)
                response['result'] = 0
                self.add_api_call(request, response)
                return Response(response, status=status.HTTP_400_BAD_REQUEST)
        except Exception as e:
            response["result"] = 0
            responsedata.append(str(e))
            response['errors'] = responsedata
            self.add_api_call(request, response)
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
