from django.urls import path, include
from .views import *

VenueOwner_urls = [
    path('step1/get', PriceListStep1GETAPIView.as_view()),
    path('step1/post', PriceListStep1POSTAPIView.as_view()),

    path('step2/get', PriceListStep2GETAPIView.as_view()),
    path('step2/post', PriceListStep2POSTAPIView.as_view()),

    path('step3/post', PriceListStep3POSTAPIView.as_view()),

    path('global/get', PriceListGlobalGetAPIView.as_view()),

    # Schedule Template
    path('template1_plan_range/get', PlanRangeGETAPIView.as_view()),

    path('schedule_template1/post', ScheduleTemplate1APIView.as_view()),
    path('schedule_template1/get', ScheduleTemplate1GETAPIView.as_view()),
    path('schedule_template1/update', ScheduleTemplate1UPDATEAPIView.as_view()),

    path('schedule_data/get', ScheduleGETTableAPIView.as_view()),
    path('schedule_data/post', SchedulePOSTTableAPIView.as_view()),
    path('static_fields/get', GetFieldsAPIView.as_view()),

    path('profile', VenueOwnerGetAPIView.as_view()),
    path('profile/add', VenueOwnerPOSTAPIView.as_view()),
    path('profile/update', VenueOwerUPDATEAPIView.as_view()),
    path('newprofile', VenueOwnerNewGetAPIView.as_view()),
    path('newprofile/add', VenueOwnerNewPOSTAPIView.as_view()),
    path('packages/get', PackagesGETAPIView.as_view()),
    path('packages/post', PackagesPostAPIView.as_view()),
    path('flightplan', FlightPlanAPIView.as_view()),
    path('flightplan/popup', FlightPlanPopUpAPIView.as_view()),
    path('flightplan/weekly', FlightPlanWeeklyAPIView.as_view()),
    path('flightplan/monthly', FlightPlanMonthlyAPIView.as_view()),
    path('flightplan/secondpopup', FlightPlanSecondPopupAPIView.as_view()),

    path('schedule_parameter/get', Schedule_ParameterGetAPIView.as_view()),
    path('schedule_parameter/post', Schedule_ParameterPostAPIView.as_view()),

    # edit schedule
    path('schedule_data/edit1', GetSchedule1.as_view()),
    path('schedule_data/editOnlyHour', EditScheduleOnlyHours.as_view()),
    path('schedule_data/editAll', EditScheduleAll.as_view()),

]

Listview_urls = [
    # price List
    path('pricelist/get', PriceListLISTGETAPIView.as_view()),
    path('pricelist/delete', PriceListLISTDELETEAPIView.as_view()),
    path('pricelist/without_pagination',
         PriceListLISTWithoutPaginationGETAPIView.as_view()),

    # schedult Template
    path('schedule_template/get', TemplateListLISTGETAPIView.as_view()),
    path('schedule_template/delete', TemplateListLISTDELETEAPIView.as_view()),
    path('schedule_template/without_pagination',
         TemplateListLISTWithoutPaginationGETAPIView.as_view()),

    # Schedule
    path('schedule/get', ScheduleListGETAPIView.as_view()),
    path('schedule/delete', ScheduleListDELETEAPIView.as_view()),

    # Booking cancellation
    path('bookingCancelRequest/post',
         BookingCancellationRequestPOSTAPIView.as_view()),
    path('bookingCancelFilter/get', BookingCancellationFilterAPIView.as_view()),

]

urlpatterns = [
    path('', include(VenueOwner_urls)),
    path('list_view/', include(Listview_urls)),

]
