from django.contrib import admin
from nested_admin import NestedModelAdmin
from .models import *
# Register your models here.


@admin.register(Venue)
class VennueAdmin(NestedModelAdmin):
    model = Venue
    list_display = ['id', 'name', 'description', 'street',
                    'venue_number', 'buisness_vat', 'created_by']


@admin.register(VenueBankInfo)
class VenueBankAdmin(NestedModelAdmin):
    model = VenueBankInfo
    list_display = ['id', 'venue', 'iban', 'bank',
                    'first_name', 'last_name', 'created_by']


@admin.register(VenueField)
class VenueFieldAdmin(NestedModelAdmin):
    model = VenueField
    list_display = ['id', 'venue', 'name', 'field_type',
                    'seat_capacity', 'floor_type', 'facility_type', 'lights', 'created_by']


@admin.register(VenueContactPerson)
class VenueContactAdmin(NestedModelAdmin):
    model = VenueContactPerson
    list_display = ['id', 'venue', 'first_name',
                    'last_name', 'telephone', 'email', 'created_by']


@admin.register(VenueFieldImage)
class VenueFieldImageAdmin(NestedModelAdmin):
    model = VenueFieldImage
    list_display = ['id', 'venue_field',
                    'is_deleted', 'created_by', 'created_at']


@admin.register(VenueImage)
class VenueImageAdmin(NestedModelAdmin):
    model = VenueImage
    list_display = ['id', 'venue', 'description', 'created_by', 'created_at']


@admin.register(VenueFieldService)
class VenueFieldServiceAdmin(NestedModelAdmin):
    model = VenueFieldService
    list_display = ['id', 'venue_field',
                    'venue_service', 'price_per_hour', 'created_by']


@admin.register(VenueDailyTiming)
class VenueDailyTimingAdmin(NestedModelAdmin):
    model = VenueDailyTiming
    list_display = ['id', 'venue', 'day',
                    'start_time', 'end_time', 'is_active']


admin.site.register(VenueRating)


@admin.register(VenueServiceCost)
class VenueServiceCostAdmin(NestedModelAdmin):
    model = VenueServiceCost
    list_display = ['id', 'venue', 'venue_service',
                    'price_per_hour', 'created_at', 'updated_at']


# @admin.register(VenueServiceCostQuantity)
# class VenueServiceCostQuantityAdmin(NestedModelAdmin):
#     model = VenueServiceCostQuantity
#     list_display = ['id',  'venue_service',
#                     'quantity', 'created_at', 'updated_at']
