# Generated by Django 2.2 on 2021-10-17 05:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('static_data', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='TestModel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(max_length=100)),
            ],
        ),
        migrations.CreateModel(
            name='Venue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, null=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='venue_logo')),
                ('main_image', models.ImageField(blank=True, null=True, upload_to='venue_main_image')),
                ('business_name', models.CharField(max_length=100, null=True)),
                ('description', models.TextField(blank=True, max_length=5000, null=True)),
                ('street', models.TextField(blank=True, max_length=150, null=True)),
                ('pincode', models.CharField(blank=True, max_length=10, null=True)),
                ('latitude', models.FloatField(blank=True, null=True)),
                ('longitude', models.FloatField(blank=True, null=True)),
                ('google_address', models.CharField(blank=True, max_length=450, null=True)),
                ('place_id', models.CharField(blank=True, max_length=450, null=True)),
                ('venue_number', models.CharField(blank=True, max_length=50, null=True)),
                ('buisness_vat', models.CharField(blank=True, help_text='user buisness vat', max_length=50, null=True)),
                ('tax_offices', models.CharField(blank=True, help_text='user buisness Tax office', max_length=100, null=True)),
                ('working_hours', models.CharField(blank=True, help_text='user buisness working hours', max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('all_services', models.ManyToManyField(blank=True, to='static_data.VenueService')),
                ('all_sports', models.ManyToManyField(blank=True, to='static_data.Sport')),
                ('allowed_entry', models.ManyToManyField(blank=True, to='static_data.VenuePermission')),
                ('area', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Area')),
                ('city', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.City')),
                ('country', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Country')),
                ('covid19Measure_description', models.ManyToManyField(blank=True, to='static_data.Covid19Measures')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('professional_allowed', models.ManyToManyField(blank=True, to='static_data.Profession')),
                ('state', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.State')),
            ],
            options={
                'verbose_name_plural': 'Venue',
                'db_table': 'venue',
            },
        ),
        migrations.CreateModel(
            name='VenueField',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, null=True)),
                ('main_image', models.ImageField(blank=True, null=True, upload_to='venue_main_image')),
                ('seat_capacity', models.CharField(blank=True, max_length=100, null=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('status', models.CharField(blank=True, choices=[('A', 'Accepted'), ('R', 'Rejected'), ('O', 'On Hold')], default='O', help_text='Is document Verified', max_length=10, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('availability_in_use', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.AVAILABILITY_IN_USE')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('facility_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.FacilityType')),
                ('field_attributes', models.ManyToManyField(blank=True, to='static_data.FieldAttribute')),
                ('field_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.FieldType')),
                ('floor_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.FloorType')),
                ('lights', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Lights')),
                ('mixed_gender', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.MIXED_GENDER')),
                ('sport', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.Sport')),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Fields',
                'db_table': 'venue_fields',
            },
        ),
        migrations.CreateModel(
            name='VenueServiceCost',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('price_per_hour', models.FloatField(default=0)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
                ('venue_service', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.VenueService')),
            ],
            options={
                'verbose_name_plural': 'Venue Service Cost',
                'db_table': 'venue_service_cost',
            },
        ),
        migrations.CreateModel(
            name='VenueServiceCostQuantity',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('quantity', models.IntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('venue_service', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueServiceCost')),
            ],
            options={
                'verbose_name_plural': 'Venue Service Cost Quantity',
                'db_table': 'venue_service_cost_quantity',
            },
        ),
        migrations.CreateModel(
            name='VenueReview',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rating', models.IntegerField(blank=True, null=True)),
                ('review', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Reviews',
                'db_table': 'venue_review',
            },
        ),
        migrations.CreateModel(
            name='VenueRating',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rating', models.IntegerField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Rating',
                'db_table': 'venue_rating',
            },
        ),
        migrations.CreateModel(
            name='VenuePriceRender',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('time_interval', models.IntegerField(default=0)),
                ('gap_period', models.IntegerField(default=0)),
                ('default_price', models.FloatField(default=0)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Price Render',
                'db_table': 'venue_price_render',
            },
        ),
        migrations.CreateModel(
            name='VenuePriceList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('time_interval', models.IntegerField(default=0)),
                ('gap_period', models.IntegerField(default=0)),
                ('default_price', models.FloatField(default=0)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Price List',
                'db_table': 'venue_price_list',
            },
        ),
        migrations.CreateModel(
            name='VenueOpeningHour',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, null=True)),
                ('end_time', models.TimeField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('day_of_week', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.DayofWeek')),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Opening Hours',
                'db_table': 'venue_opening_hours',
            },
        ),
        migrations.CreateModel(
            name='VenueImage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image', models.ImageField(blank=True, max_length=6000, null=True, upload_to='venue_images')),
                ('description', models.TextField(blank=True, max_length=100, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Images',
                'db_table': 'venue_image',
            },
        ),
        migrations.CreateModel(
            name='VenueFieldService',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('price_per_hour', models.FloatField(default=0)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue_field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueField')),
                ('venue_service', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='static_data.VenueService')),
            ],
            options={
                'verbose_name_plural': 'Venue Field Services',
                'db_table': 'venue_field_services',
            },
        ),
        migrations.CreateModel(
            name='VenueFieldImage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('image', models.ImageField(blank=True, null=True, upload_to='venue_images')),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue_field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.VenueField')),
            ],
            options={
                'verbose_name_plural': 'Venue Field Images',
                'db_table': 'venue_field_image',
            },
        ),
        migrations.CreateModel(
            name='VenueDailyTiming',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start_time', models.TimeField(blank=True, help_text='Start time', null=True)),
                ('end_time', models.TimeField(blank=True, help_text='Start time', null=True)),
                ('is_active', models.BooleanField(blank=True, null=True)),
                ('is_deleted', models.BooleanField(blank=True, default=False, null=True)),
                ('created_at', models.DateTimeField(auto_now=True, null=True)),
                ('day', models.ForeignKey(blank=True, help_text='Day', null=True, on_delete=django.db.models.deletion.SET_NULL, to='static_data.DayofWeek')),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Daily Timing',
                'db_table': 'venue_timing',
            },
        ),
        migrations.CreateModel(
            name='VenueContactPerson',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(blank=True, max_length=50, null=True)),
                ('last_name', models.CharField(blank=True, max_length=50, null=True)),
                ('telephone', models.CharField(blank=True, max_length=50, null=True)),
                ('mobile', models.IntegerField(blank=True, null=True)),
                ('email', models.CharField(blank=True, max_length=50, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Contact Persons',
                'db_table': 'venue_contact_persons',
            },
        ),
        migrations.CreateModel(
            name='VenueBankInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('iban', models.CharField(blank=True, max_length=50, null=True)),
                ('bank', models.CharField(blank=True, max_length=50, null=True)),
                ('first_name', models.CharField(blank=True, max_length=50, null=True)),
                ('last_name', models.CharField(blank=True, max_length=50, null=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True, null=True)),
                ('updated_at', models.DateTimeField(auto_now=True, null=True)),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('venue', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='venues.Venue')),
            ],
            options={
                'verbose_name_plural': 'Venue Bank Info',
                'db_table': 'venue_bank_info',
            },
        ),
    ]
