import json
from django.http import HttpResponse
from django.template import Template, Context
from django.db import transaction
from django.urls import reverse
from django.contrib.contenttypes.models import ContentType

from django.contrib.auth import login as django_login
import datetime
from rest_framework.authtoken.models import Token
from rest_framework import status, generics

from rest_framework.response import Response
from rest_framework.authentication import TokenAuthentication
from rest_framework.permissions import IsAuthenticated

from utils.mixins import PlatformAPICallMixin
from utils.api_handle_errors import handle_errors
from commonAPI.serializers import ContactPersonSerializer
from commonAPI.models import Contact_Person
from venues.serializers import *
from venues.models import *
from venue_owners.models import *
from campaigns.models import CampaignPart1, CampaignPart3
from rest_framework import serializers
from static_data.models import *
from django.contrib.auth.models import User

from professionals import models as promodel
from advertisers import models as advmodel
from venue_owners import models as venmodel
from players import models as plamodel

import random
import string
from django.db.models import Q

from django.core.mail import send_mail

class SaveUserAPIView(PlatformAPICallMixin,generics.GenericAPIView):
    '''
    Create Demo Users
    '''
    # authentication_classes = (TokenAuthentication,)
    # permission_classes = (IsAuthenticated,)
    serializer_class = CreateDemoSerializer

    def post(self,request,format=None):
        response = {}
        responsedata = []

        serializers = self.serializer_class(data=request.data)

        if serializers.is_valid():
            if serializers.validated_data['confirm'] != '1234':
                response['result'] = 0
                response['data'] = "Not Authorized"
                return Response(response, status=status.HTTP_400_BAD_REQUEST)

            # Create user
            user_type = serializers.validated_data['mode']

            # Create User Type
            for i in serializers.validated_data['email_id']:
                User.objects.filter(email=i, username=i, first_name=i, last_name=i).delete()
                User.objects.filter(Q(username=i) | Q(first_name=i) | Q(email=i)).delete()
                user_obj = User.objects.create(email=i, username=i, first_name=i, last_name=i)
                user_obj.set_password(serializers.validated_data['password'])
                my_group = Group.objects.get(name__icontains=user_type[0:5])
                user_obj.groups.add(my_group)
                user_obj.save()

                if hasattr(promodel, user_type):
                    model_obj = getattr(promodel, user_type).objects.create(email=i, user=user_obj)
                elif hasattr(advmodel, user_type):
                    model_obj = getattr(advmodel, user_type).objects.create(email=i, user=user_obj)
                elif hasattr(venmodel, user_type):
                    model_obj = getattr(venmodel, user_type).objects.create(email=i, user=user_obj)
                elif hasattr(plamodel, user_type):
                    model_obj = getattr(plamodel, user_type).objects.create(email=i, user=user_obj)
                
                if user_type == "VenueOwner":
                    letters = string.ascii_lowercase
                    model_obj.first_name = ''.join(random.choice(letters) for i in range(8))
                    model_obj.middle_name = ''.join(random.choice(letters) for i in range(8))
                    model_obj.last_name = ''.join(random.choice(letters) for i in range(8))
                    model_obj.gender = 'M'
                    model_obj.save()


                    Venue.objects.create(
                        city = 'Mumbai',
                        venue_number = 'Mumbai123',
                        created_by = user_obj
                    )

                

            response['result'] = 1
            response['data'] = "done"
            return Response(response, status=status.HTTP_200_OK)

            
        else:
            response = handle_errors(serializers.errors)
            response["result"] = 0
            return Response(response, status=status.HTTP_400_BAD_REQUEST)
            



from django.core import serializers as ser


class VenueProfileSerializer(serializers.ModelSerializer):
    class Meta:
        model = CampaignPart3
        fields = "__all__"


class GetTest(PlatformAPICallMixin, generics.GenericAPIView):
    serializer_class = VenueProfileSerializer

    def get(self, request,format=None):
        response = {}
        campaign = CampaignPart1.objects.get(id=2)

        campaign3 = CampaignPart3.objects.filter(campaign1=campaign).values('email_logo','emailBody','email_logo','email_background')
        campaign3 = campaign3[0]
        print(campaign3['emailBody'])
        # serializer = self.serializer_class(campaign3, many=True)
        # se = ser.serialize('json',campaign3[0])

        response['result'] = 1
        # response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)



class SendMailAPIVIew(PlatformAPICallMixin, generics.GenericAPIView):

    def get(self, request, format=None):
        response = {}
        import requests
        from utils.mail import send_mail_registeration

        # send_mail('subject', 'body of the message', 'sports@worldindia.com', ['yatin.pandit94@gmail.com'])

        # url_response = requests.post(
        # "https://api.mailgun.net/v3/worldindia.com/messages",
        # auth=("api", "e09ce36eb9b16508fad2d1aca600a272-ba042922-4f7d9d0e"),
        # data={"from": "sports@worldindia.com",
        #       "to": ["Deepak.shetty86@hotmail.com"],
        #       "subject": "Hello",
        #       "text": "Testing some Mailgun awesomness!"})

        # print(url_response.content)
        send_mail_registeration("yatin", "www.google.com", 'yatin.pandit94@gmail.com')

        response['result'] = 1
        # response['data'] = serializer.data
        self.add_api_call(request, response)
        return Response(response, status=status.HTTP_200_OK)

