from django.urls import path, include
from .views import *

auth_urls = [
    path('profile', VenueGetAPIView.as_view()),
    path('bank_info', VenueBankInfoGetAPIView.as_view()),

    path('field_info/post', VenueFieldPOSTInfoAPIView.as_view()),
    path('field_info/get', VenueFieldGETInfoAPIView.as_view()),

    path('contact_info', VenueContactAPIView.as_view()),

    path('venue_step3_service/get', VenueServicesGETAPIView.as_view()),
    path('venue_step3_service/post', VenueServicesPOSTAPIView.as_view()),

    path('venue_step4_entry/get', VenueEntryGETAPIView.as_view()),
    path('venue_step4_entry/post', VenueEntryPOSTAPIView.as_view()),

    path('venue_photo/post', VenuePhotosPOSTAPIView.as_view()),

    path('venue_step/global_get', GlobalGetVenueFieldAPIView.as_view()),

    path('field_nobooking', FieldNoBookingAPIView.as_view()),
    path("delete_field", DeleteFieldAPIView.as_view()),

    path("get_extra_services", GetFieldDisabledServicesAPIView.as_view()),

    path("test", SendMailAPIVIew.as_view()),
    path('delete_venue_image', DeleteVenueImageAPIView.as_view()),
    path('delete_venue_field_image', DeleteVenueFieldImageAPIView.as_view()),
    path('venue_photo_new/post', VenuePhotosNewPOSTAPIView.as_view()),
    path('venue_service1_paid/field/get', VenueServicesGETAPIView1.as_view()),
    path('venue_service_free/venue/get', VenueServicesGETAPIView2.as_view()),
    path('venue_service_paid/venue/get', VenueServicesGETAPIView3.as_view()),
    path('venue_service/post', VenueOwnerServicesPOSTAPIView.as_view()),
    path('venue_paid_service/get', VenueOwnerPaidServiceGETAPIView.as_view()),
    path('venue_field_paid_service/get',
         VenueFieldPaidServiceGETAPIView.as_view()),
    path('venue_field_service/post',
         VenueFieldPOSTServicesSerializerAPIView.as_view()),
    path('venue_service_venue/post', VenuePOSTServicesSerializerAPIView.as_view()),

    path('all_venue/get', AllVenueGetAPIView.as_view()),

    # Suggestions
    path('homepage_suggestions', GetNameSuggestionsAPIView.as_view()),

]
urlpatterns = [
    path('', include(auth_urls)),
]
